/*
	
	How to build a simple mesh and render.
		by Grzegorz Tanski

*/

#include <iostream>

#include "../kraysdk/kray.h"
#include "../kraysdk/proto/direct.h"

#include "../SharedSources/libraryDir.h"

extern void setupSimpleMeshScene(Kray::Prototyper& prot);

int kraySdkExampleMain(int argc, const char** argv){	// main function is in startup.cpp
	Kray::Library klib(KRAY_DIRECTORY);				// here we start with KrayLib object

	Kray::Instance* kinst=klib.createInstance();	// then we create Kray instance, each instance have its own scene and settings
	
	if (kinst){									// check if instance was created, if not, Kray library wasn't found
		Kray::DirectPrototyper prot(kinst);		// prototyper gives access to Kray Script command prototypes

		setupSimpleMeshScene(prot);

		prot.echo("Launching flayer....");
		prot.pv_flayer();
		prot.interactive();
//		prot.echo("Rendering....");
//		prot.render();
//		prot.echo("Pause to see render result....");
//		prot.pause(120);	// wait two minutes before closing render window
	}else{
		std::cout << "Failed to create Kray instance" << std::endl;
	}

	return 0;
}
