#ifndef SDK_ADDINFO_H
#define SDK_ADDINFO_H

#include "commons.h"

namespace Kray{

class TriangleAddInfo{
public:
	KrayObjectGroupHandle objs;
	const float *points;
	const float *normals;
	const float *geometric_normal;
	KraySurfaceHandle surface;
	KrayBlendHandle blend;
	KrayTextureHandle clipmap;
	size_t vertex_map_poly_index;
	int flags;
	
	TriangleAddInfo(){
	}
	TriangleAddInfo(KrayObjectGroupHandle objs,
						const float *points,
						KraySurfaceHandle surface,
						KrayBlendHandle blend,
						int flags=0,
						const float *normals=0,
						KrayTextureHandle clipmap=0,
						size_t vertex_map_poly_index=0,
						const float *geometric_normal=0)
		:objs(objs),points(points),surface(surface),blend(blend),flags(flags),clipmap(clipmap)
		 ,vertex_map_poly_index(vertex_map_poly_index),normals(normals),geometric_normal(geometric_normal){
	}
};

class PolyAddInfo{
public:
	KrayMeshHandle msh;

	size_t* indices;
	int n;
	int group;
	int sfid;
	
public:
	PolyAddInfo(){
	}
	PolyAddInfo(KrayMeshHandle msh,
					int n,
					size_t *indices,
					int sfid,
					int group=0)
		:msh(msh),n(n),sfid(sfid),indices(indices),group(group){
	}
};

};

#endif