#import <Cocoa/Cocoa.h>

#include "../kraysdk/startup.h"

@interface CocoaWorkerThreadStarter : NSThread{
@public
	int argc;
	int result;
	const char** argv;
	
	MainFunction* main;
}
- (void) main;
@end

@implementation CocoaWorkerThreadStarter
- (void) main{
	NSAutoreleasePool* pool=[[NSAutoreleasePool alloc] init];

	result=self->main(argc,argv);

	[[NSApplication sharedApplication] terminate: [NSThread currentThread]];	// break Cocoa main event loop

	[pool release];
}
@end

extern "C" int mainKrayCocoaStarter(MainFunction* main,int argc, const char** argv){
    [NSApplication sharedApplication];
	
	CocoaWorkerThreadStarter* cwts=[[CocoaWorkerThreadStarter alloc] init];
	
	cwts->main=main;
	cwts->argc=argc;
	cwts->argv=argv;

	[cwts start];
	
	[NSApp run];
	
	return cwts->result;
}

extern "C" char isCocoaStartupArgument(const char* arg){		// depraceted on latest MacOS
	return strncmp("-psn_",arg,5)==0;
}
extern "C" char isCocoaNSArgument(const char* arg){
	return strncmp("-NS",arg,3)==0;
}
extern "C" int skipCocoaArgument(const char* arg){
    if (isCocoaNSArgument(arg)) return 2;
    if (isCocoaStartupArgument(arg)) return 1;
    
    return 0;
}
extern "C" char isCocoaStartup(int argc,const char** argv){
	for (int a=1 ; a<argc ; a++){
		if (isCocoaStartupArgument(argv[a])){
			return 1;
		}
	}	
	
	return 0;
}
extern "C" const char* getCocoaResource(const char* resource,const char* type){
    NSBundle* bundle=[NSBundle mainBundle];
    
    NSString* result=[bundle pathForResource: [NSString stringWithUTF8String: resource] ofType: type?[NSString stringWithUTF8String: type]:nil];
    
	return [result UTF8String];
}

extern "C" int mainFilteredCocoaArgumentStarter(MainFunction* main,int argc,const char** argv,char cocoaStart){
	const char** fargv=new const char*[argc];	
	
	int fargc=0;
	fargv[fargc++]=argv[0];
	
	for (int a=1 ; a<argc ; a++){
        if (isCocoaNSArgument(argv[a])){
            a+=1;   // skip arg and value
        }else if (!isCocoaStartupArgument(argv[a])){
			fargv[fargc++]=argv[a];
		}
	}
	
	int result=cocoaStart?mainKrayCocoaStarter(main,fargc,fargv):main(fargc,fargv);
	
	delete[] fargv;
	
	return result;
}
