#ifndef KRAY_COMMANDS_ENUMS_H
#define KRAY_COMMANDS_ENUMS_H

/*
 Kray script keywords header
  generated from Kray
  use
   kray -c "commandsprotos 2,5,'kcmds.h';"
  to regenerate
*/

#include "kcmdsinc.h"

namespace Kray{

class Enums{
public:
 enum cmd_code{
  cmd_about=40,
  cmd_anim=82,
  cmd_animOb=84,
  cmd_animObLink=81,
  cmd_axes=16,
  cmd_background=25,
  cmd_bitmap=58,
  cmd_bitmapData=49,
  cmd_bitmapOp=55,
  cmd_blend=19,
  cmd_camera=29,
  cmd_class=155,
  cmd_classObject=157,
  cmd_clear=52,
  cmd_color=13,
  cmd_commandsProtos=77,
  cmd_coordSys=12,
  cmd_delete=42,
  cmd_displaceMap=114,
  cmd_double=9,
  cmd_echo=5,
  cmd_end=4,
  cmd_environment=37,
  cmd_exit=17,
  cmd_fg=46,
  cmd_fiberPack=115,
  cmd_fiberPackOp=116,
  cmd_for=91,
  cmd_fs=20,
  cmd_function=154,
  cmd_gpGpu=78,
  cmd_group=85,
  cmd_groupLink=74,
  cmd_help=76,
  cmd_if=50,
  cmd_include=92,
  cmd_instanceAdd=67,
  cmd_instanceLinkAdd=66,
  cmd_interactive=51,
  cmd_k2=30,
  cmd_kray=31,
  cmd_light=38,
  cmd_lightAdd=11,
  cmd_lightOp=44,
  cmd_loadGis=63,
  cmd_lopt=57,
  cmd_lw=70,
  cmd_mapping=22,
  cmd_material=102,
  cmd_materialSet=54,
  cmd_mem=32,
  cmd_mesh=99,
  cmd_meshAddPoly=100,
  cmd_meshesOptions=98,
  cmd_meshOp=80,
  cmd_metaSurface=103,
  cmd_metaTexture=47,
  cmd_metaTextureSet=48,
  cmd_method=158,
  cmd_mlt=93,
  cmd_net=35,
  cmd_objectAdd=2,
  cmd_objectInfo=53,
  cmd_oct=39,
  cmd_openCl=75,
  cmd_parse=41,
  cmd_parseMode=34,
  cmd_pause=94,
  cmd_platform=59,
  cmd_pm=43,
  cmd_portalAdd=107,
  cmd_postProcess=73,
  cmd_pv=28,
  cmd_rayCast=72,
  cmd_reference=60,
  cmd_rem=1,
  cmd_render=3,
  cmd_reset=64,
  cmd_return=156,
  cmd_saveGis=62,
  cmd_sett=27,
  cmd_shaderNode=24,
  cmd_shadowMap=36,
  cmd_shape=15,
  cmd_shapeAdd=10,
  cmd_shapeSelection=68,
  cmd_shapeSelectionOp=69,
  cmd_shOb=106,
  cmd_shObOp=105,
  cmd_showInfo=83,
  cmd_stop=61,
  cmd_string=112,
  cmd_stringId=113,
  cmd_surface=23,
  cmd_surfaceOp=26,
  cmd_symbolsDelete=71,
  cmd_tds=97,
  cmd_texture=21,
  cmd_threads=65,
  cmd_var=18,
  cmd_variable=8,
  cmd_vector=14,
  cmd_vertex2d=88,
  cmd_vertex3d=89,
  cmd_vertexData=90,
  cmd_vertexMap=87,
  cmd_vertexMapOp=86,
  cmd_view=33,
  cmd_while=95
 };

 static const char* cmd_strings[];

 static const char* toString(cmd_code code){
  return cmd_strings[(int)code-1];
 }

 enum groupOps_code{
  groupOps_add=6,
  groupOps_addInstance=7,
  groupOps_attachSet=5,
  groupOps_clear=1,
  groupOps_remove=3,
  groupOps_removeAll=8,
  groupOps_removeUnused=10,
  groupOps_select=2,
  groupOps_selectInstance=4,
  groupOps_updateMaterials=9
 };

 static const char* groupOps_strings[];

 static const char* toString(groupOps_code code){
  return groupOps_strings[(int)code-1];
 }

 enum groupLinkTypes_code{
  groupLinkTypes_attachGroup=3,
  groupLinkTypes_attachInstance=4,
  groupLinkTypes_group=1,
  groupLinkTypes_instance=2
 };

 static const char* groupLinkTypes_strings[];

 static const char* toString(groupLinkTypes_code code){
  return groupLinkTypes_strings[(int)code-1];
 }

 enum aaMode_code{
  aaMode_none=1,
  aaMode_qmcAdaptive=3,
  aaMode_rotUniform=8,
  aaMode_totalMbRandom=10,
  aaMode_totalQmc=6,
  aaMode_totalQmcAdaptive=5,
  aaMode_totalRandom=7,
  aaMode_totalRotUniform=9,
  aaMode_totalUniform=4,
  aaMode_uniform=2
 };

 static const char* aaMode_strings[];

 static const char* toString(aaMode_code code){
  return aaMode_strings[(int)code-1];
 }

 enum aaModeOld_code{
  aaModeOld_adaptive=2,
  aaModeOld_coneAdaptive=5,
  aaModeOld_conePath=6,
  aaModeOld_coneUniform=4,
  aaModeOld_path=3,
  aaModeOld_uniform=1
 };

 static const char* aaModeOld_strings[];

 static const char* toString(aaModeOld_code code){
  return aaModeOld_strings[(int)code-1];
 }

 enum autoPhoton_code{
  autoPhoton_caustics=2,
  autoPhoton_global=1,
  autoPhoton_gScaleCaustics=4,
  autoPhoton_gScalePrecached=6
 };

 static const char* autoPhoton_strings[];

 static const char* toString(autoPhoton_code code){
  return autoPhoton_strings[(int)code-1];
 }

 enum background_code{
  background_color=1,
  background_directionsMap=12,
  background_fishEyeMap=6,
  background_phySky=9,
  background_phySkyEnv=10,
  background_shader=3,
  background_sky=2,
  background_sphereMap=5
 };

 static const char* background_strings[];

 static const char* toString(background_code code){
  return background_strings[(int)code-1];
 }

 enum bitmaps_code{
  bitmaps_alphaMap=9,
  bitmaps_bitPlane=12,
  bitmaps_bumpMap=10,
  bitmaps_charGray=2,
  bitmaps_charRgba=3,
  bitmaps_compress=7,
  bitmaps_copy=8,
  bitmaps_copyView=11,
  bitmaps_floatGray=4,
  bitmaps_floatRgb=5,
  bitmaps_floatRgba=6,
  bitmaps_load=1
 };

 static const char* bitmaps_strings[];

 static const char* toString(bitmaps_code code){
  return bitmaps_strings[(int)code-1];
 }

 enum outputChannels_code{
  outputChannels_alph=2,
  outputChannels_caus=9,
  outputChannels_dire=5,
  outputChannels_indi=7,
  outputChannels_lumi=15,
  outputChannels_norm=23,
  outputChannels_obid=21,
  outputChannels_othr=17,
  outputChannels_posi=8,
  outputChannels_preview=34,
  outputChannels_refl=11,
  outputChannels_refr=13,
  outputChannels_rgb=1,
  outputChannels_rgba=33,
  outputChannels_sfid=19,
  outputChannels_shdn=6,
  outputChannels_txtr=3,
  outputChannels_zbuf=4
 };

 static const char* outputChannels_strings[];

 static const char* toString(outputChannels_code code){
  return outputChannels_strings[(int)code-1];
 }

 enum blend_code{
  blend_default=7,
  blend_fromShader=5,
  blend_none=3,
  blend_partial=2,
  blend_superficial=4,
  blend_total=1
 };

 static const char* blend_strings[];

 static const char* toString(blend_code code){
  return blend_strings[(int)code-1];
 }

 enum camera_code{
  camera_castMaps=10,
  camera_fishEye=6,
  camera_lens1=3,
  camera_lens2=4,
  camera_mesh=5,
  camera_move=11,
  camera_parallel=7,
  camera_parallelExt=9,
  camera_perspective=1,
  camera_picture=14,
  camera_rotate=12,
  camera_shift=13,
  camera_sphere=2,
  camera_stereo=8
 };

 static const char* camera_strings[];

 static const char* toString(camera_code code){
  return camera_strings[(int)code-1];
 }

 enum dither_code{
  dither_floydSteinberg=3,
  dither_qRandom=4,
  dither_random=2,
  dither_simple=1
 };

 static const char* dither_strings[];

 static const char* toString(dither_code code){
  return dither_strings[(int)code-1];
 }

 enum environment_code{
  environment_colorFade=2,
  environment_phySky=3,
  environment_shader=1
 };

 static const char* environment_strings[];

 static const char* toString(environment_code code){
  return environment_strings[(int)code-1];
 }

 enum fiberpackParams_code{
  fiberpackParams_addFiber=2,
  fiberpackParams_bBoxSize=1
 };

 static const char* fiberpackParams_strings[];

 static const char* toString(fiberpackParams_code code){
  return fiberpackParams_strings[(int)code-1];
 }

 enum infos_code{
  infos_all=10,
  infos_anim=13,
  infos_bitmaps=2,
  infos_bitmapsExt=4,
  infos_fg=8,
  infos_fiberPacks=12,
  infos_pm=7,
  infos_scene=1,
  infos_shared=9,
  infos_symbols=3,
  infos_vertexMaps=5,
  infos_views=11
 };

 static const char* infos_strings[];

 static const char* toString(infos_code code){
  return infos_strings[(int)code-1];
 }

 enum settings_code{
  settings_aRecurse=7,
  settings_bitmapPixelCompression=1,
  settings_buffersMask=39,
  settings_debug=44,
  settings_debugExecute=50,
  settings_debugTestValue=45,
  settings_dither=38,
  settings_ditherAmplitude=40,
  settings_edgeDetector=36,
  settings_edgeDetectorGlobals=41,
  settings_edgeDetectorSlot=42,
  settings_energetic=2,
  settings_failBitmap=15,
  settings_imageSampler=35,
  settings_imageSamplerMultiPass=13,
  settings_importanceGammaMultiplier=19,
  settings_instanceOctreeWeight=17,
  settings_instanceRecurse=27,
  settings_lightRaysShadowCheck=25,
  settings_logFile=43,
  settings_maxRayColor=4,
  settings_mipMap=47,
  settings_miscBufOrder=22,
  settings_outputFormat=30,
  settings_outputTo=28,
  settings_outsideSize=6,
  settings_pixelBufOrder=21,
  settings_pixelFilter=46,
  settings_pixelOrder=29,
  settings_previewSize=49,
  settings_rayDiff=10,
  settings_recurse=3,
  settings_renderInfo=33,
  settings_renderInfoSize=34,
  settings_semaphoreFileTryDelete=24,
  settings_splitScreen=37,
  settings_sssErr=9,
  settings_sssOct=8,
  settings_subframeRecomputeFlags=14,
  settings_threadMinSplit=23,
  settings_toneMapping=48,
  settings_underSample=11,
  settings_undersamplePrerender=18,
  settings_vrPrerender=16
 };

 static const char* settings_strings[];

 static const char* toString(settings_code code){
  return settings_strings[(int)code-1];
 }

 enum instanceTransformer_code{
  instanceTransformer_copyAxes=7,
  instanceTransformer_copyRevAxes=11,
  instanceTransformer_localAxes=9,
  instanceTransformer_normalFixedRotate=13,
  instanceTransformer_normalRandomRotate=12,
  instanceTransformer_normalRotate=8,
  instanceTransformer_patternAxes=14,
  instanceTransformer_randomSeed=1,
  instanceTransformer_randRotate=2,
  instanceTransformer_randScale=6,
  instanceTransformer_randScaleX=3,
  instanceTransformer_randScaleY=4,
  instanceTransformer_randScaleZ=5,
  instanceTransformer_worldAxes=10
 };

 static const char* instanceTransformer_strings[];

 static const char* toString(instanceTransformer_code code){
  return instanceTransformer_strings[(int)code-1];
 }

 enum fileCommands_code{
  fileCommands_appendString=2,
  fileCommands_cat=3,
  fileCommands_copy=1,
  fileCommands_hexCat=4,
  fileCommands_list=11,
  fileCommands_openUrl=10,
  fileCommands_pathAdd=9,
  fileCommands_pathRemove=6,
  fileCommands_pathShow=8,
  fileCommands_pathSkipCurrentDir=7,
  fileCommands_pathSlashCut=5
 };

 static const char* fileCommands_strings[];

 static const char* toString(fileCommands_code code){
  return fileCommands_strings[(int)code-1];
 }

 enum toneMapSet_code{
  toneMapSet_edge=4,
  toneMapSet_ray=2,
  toneMapSet_z=6
 };

 static const char* toneMapSet_strings[];

 static const char* toString(toneMapSet_code code){
  return toneMapSet_strings[(int)code-1];
 }

 enum light_code{
  light_adaptive=20,
  light_adaptiveSpot=21,
  light_ambient=40,
  light_ambientTextured=41,
  light_background=38,
  light_dirPoint=14,
  light_dirPointTextured=31,
  light_distantSphere=37,
  light_fade=16,
  light_fadeDirPoint=18,
  light_fadeDirPointTextured=34,
  light_fadePoint=15,
  light_fadePointTextured=32,
  light_fakePhotonEmitter=4,
  light_group=6,
  light_groupImportance=36,
  light_ies=35,
  light_line=19,
  light_linear=17,
  light_lineTextured=33,
  light_parallel=9,
  light_parallelTextured=27,
  light_photonMultiplier=42,
  light_phySky=39,
  light_phySun=22,
  light_point=1,
  light_pointTextured=8,
  light_rangeLimiter=3,
  light_rectangle=10,
  light_rectangleDS=43,
  light_rectangleSpot=11,
  light_rectangleSpotDS=44,
  light_rectangleSpotTextured=29,
  light_rectangleSpotTexturedDS=46,
  light_rectangleTextured=28,
  light_rectangleTexturedDS=45,
  light_shadowCache=24,
  light_shadowMapPoint=12,
  light_shadowMapPointTextured=30,
  light_shape=2,
  light_shapeTextured=13,
  light_sphere=23,
  light_sphereTextured=25,
  light_spot=5,
  light_spotTextured=26,
  light_symbol=7
 };

 static const char* light_strings[];

 static const char* toString(light_code code){
  return light_strings[(int)code-1];
 }

 enum lightOps_code{
  lightOps_shadow=1
 };

 static const char* lightOps_strings[];

 static const char* toString(lightOps_code code){
  return lightOps_strings[(int)code-1];
 }

 enum materialAttrib_code{
  materialAttrib_ambientOcclusionColor=30,
  materialAttrib_ambientOcclusionDistance=33,
  materialAttrib_backSideFlags=29,
  materialAttrib_blurMaxRays=22,
  materialAttrib_blurRays=21,
  materialAttrib_blurTolerance=23,
  materialAttrib_bumpDepth=8,
  materialAttrib_color=11,
  materialAttrib_diffuse=1,
  materialAttrib_diffuseModel=17,
  materialAttrib_edgeDetectSlot=16,
  materialAttrib_flags=24,
  materialAttrib_forceColor=9,
  materialAttrib_fresnel=4,
  materialAttrib_glossiness=26,
  materialAttrib_ior=7,
  materialAttrib_light=3,
  materialAttrib_lightGroup=10,
  materialAttrib_reflection=18,
  materialAttrib_reflectionBlur=19,
  materialAttrib_reflectionBlurLights=27,
  materialAttrib_refractionBlur=20,
  materialAttrib_specularity=25,
  materialAttrib_texture=34,
  materialAttrib_translucency=5,
  materialAttrib_transparency=15,
  materialAttrib_transparencyAffects=28
 };

 static const char* materialAttrib_strings[];

 static const char* toString(materialAttrib_code code){
  return materialAttrib_strings[(int)code-1];
 }

 enum materialTexture_code{
  materialTexture_bump=8,
  materialTexture_color=1,
  materialTexture_diffuse=2,
  materialTexture_light=5,
  materialTexture_normal=9,
  materialTexture_reflection=6,
  materialTexture_specularity=7,
  materialTexture_translucency=3,
  materialTexture_transparency=4
 };

 static const char* materialTexture_strings[];

 static const char* toString(materialTexture_code code){
  return materialTexture_strings[(int)code-1];
 }

 enum Mapping_code{
  Mapping_rect=1,
  Mapping_sphere=2,
  Mapping_triangleUvMap=4,
  Mapping_tube=3
 };

 static const char* Mapping_strings[];

 static const char* toString(Mapping_code code){
  return Mapping_strings[(int)code-1];
 }

 enum meshTag_code{
  meshTag_clipMap=12,
  meshTag_directClipMap=16,
  meshTag_displaceDepth=7,
  meshTag_displaceDepthPointUv=10,
  meshTag_displaceDepthPolyUv=11,
  meshTag_displaceMap=15,
  meshTag_displacePointUv=8,
  meshTag_displacePolyUv=9,
  meshTag_flags=5,
  meshTag_material=1,
  meshTag_name=17,
  meshTag_normalPointMap=13,
  meshTag_normalPolyMap=14,
  meshTag_shader=2,
  meshTag_smoothing=4
 };

 static const char* meshTag_strings[];

 static const char* toString(meshTag_code code){
  return meshTag_strings[(int)code-1];
 }

 enum meshExport_code{
  meshExport_grabVertexMap=1,
  meshExport_videoScape=2
 };

 static const char* meshExport_strings[];

 static const char* toString(meshExport_code code){
  return meshExport_strings[(int)code-1];
 }

 enum meshOperations_code{
  meshOperations_addPolyTagName=17,
  meshOperations_align=3,
  meshOperations_autoGroup=5,
  meshOperations_export=1,
  meshOperations_findQuads=18,
  meshOperations_flip=19,
  meshOperations_geometricNormalFlip=6,
  meshOperations_metaShare=12,
  meshOperations_pointMeta=10,
  meshOperations_pointNormals=13,
  meshOperations_points=9,
  meshOperations_polyMeta=11,
  meshOperations_polyNormals=14,
  meshOperations_removeDuplicates=2,
  meshOperations_removeUnusedTags=4,
  meshOperations_saveScript=8,
  meshOperations_setUvIndexShift=7,
  meshOperations_shadingNormalFlip=20,
  meshOperations_tag=16,
  meshOperations_tagsMap=15
 };

 static const char* meshOperations_strings[];

 static const char* toString(meshOperations_code code){
  return meshOperations_strings[(int)code-1];
 }

 enum meshVertexmapGrab_code{
  meshVertexmapGrab_discretizePoints=1,
  meshVertexmapGrab_gridSamplePoints=3,
  meshVertexmapGrab_samplePoints=2
 };

 static const char* meshVertexmapGrab_strings[];

 static const char* toString(meshVertexmapGrab_code code){
  return meshVertexmapGrab_strings[(int)code-1];
 }

 enum metatextureAttrib_code{
  metatextureAttrib_bitmap=5,
  metatextureAttrib_bitmapFilename=9,
  metatextureAttrib_color=8,
  metatextureAttrib_colorVmap=7,
  metatextureAttrib_inputTone=3,
  metatextureAttrib_lod=2,
  metatextureAttrib_mapping=1,
  metatextureAttrib_worldCoords=6,
  metatextureAttrib_wraping=4
 };

 static const char* metatextureAttrib_strings[];

 static const char* toString(metatextureAttrib_code code){
  return metatextureAttrib_strings[(int)code-1];
 }

 enum metatextureMapping_code{
  metatextureMapping_external=1,
  metatextureMapping_fishEye=9,
  metatextureMapping_fishEyeDirection=10,
  metatextureMapping_projection=7,
  metatextureMapping_projectionDirection=8,
  metatextureMapping_rect=3,
  metatextureMapping_sphere=4,
  metatextureMapping_sphereDirection=6,
  metatextureMapping_tube=5,
  metatextureMapping_uv=2
 };

 static const char* metatextureMapping_strings[];

 static const char* toString(metatextureMapping_code code){
  return metatextureMapping_strings[(int)code-1];
 }

 enum outputFormats_code{
  outputFormats_bmp=1,
  outputFormats_exr=5,
  outputFormats_hdr=4,
  outputFormats_jpg=7,
  outputFormats_png=2,
  outputFormats_tga=3,
  outputFormats_tif=8
 };

 static const char* outputFormats_strings[];

 static const char* toString(outputFormats_code code){
  return outputFormats_strings[(int)code-1];
 }

 enum objectSet_code{
  objectSet_3ds=4,
  objectSet_function=3,
  objectSet_lwo=1,
  objectSet_lwo2=2,
  objectSet_mesh=5
 };

 static const char* objectSet_strings[];

 static const char* toString(objectSet_code code){
  return objectSet_strings[(int)code-1];
 }

 enum miscSharedObjects_code{
  miscSharedObjects_ies=4,
  miscSharedObjects_physky=1,
  miscSharedObjects_physky0=5,
  miscSharedObjects_physky2=2,
  miscSharedObjects_water=3
 };

 static const char* miscSharedObjects_strings[];

 static const char* toString(miscSharedObjects_code code){
  return miscSharedObjects_strings[(int)code-1];
 }

 enum miscSharedObjectOpetarions_code{
  miscSharedObjectOpetarions_flags=4,
  miscSharedObjectOpetarions_waterDisturb=3,
  miscSharedObjectOpetarions_waterIterate=1,
  miscSharedObjectOpetarions_waterSetBounds=2
 };

 static const char* miscSharedObjectOpetarions_strings[];

 static const char* toString(miscSharedObjectOpetarions_code code){
  return miscSharedObjectOpetarions_strings[(int)code-1];
 }

 enum pixelFilter_code{
  pixelFilter_box=1,
  pixelFilter_catmull=6,
  pixelFilter_cone=2,
  pixelFilter_cubic=7,
  pixelFilter_lanczos=3,
  pixelFilter_mitchell=4,
  pixelFilter_quadric=8,
  pixelFilter_spline=5
 };

 static const char* pixelFilter_strings[];

 static const char* toString(pixelFilter_code code){
  return pixelFilter_strings[(int)code-1];
 }

 enum postProcessor_code{
  postProcessor_add=3,
  postProcessor_autoExp=9,
  postProcessor_bitmapOverlay=15,
  postProcessor_ca=16,
  postProcessor_desaturate=12,
  postProcessor_dof=4,
  postProcessor_erode=6,
  postProcessor_erodeAlpha=22,
  postProcessor_filter=1,
  postProcessor_gamma=11,
  postProcessor_gBlur=8,
  postProcessor_glow=5,
  postProcessor_histogramFix=13,
  postProcessor_mult=10,
  postProcessor_saveImage=19,
  postProcessor_saveNormal=18,
  postProcessor_saveZ=14,
  postProcessor_setDirectionsMapFormat=23,
  postProcessor_shader=2,
  postProcessor_stereogram=20,
  postProcessor_trimAlpha=21
 };

 static const char* postProcessor_strings[];

 static const char* toString(postProcessor_code code){
  return postProcessor_strings[(int)code-1];
 }

 enum pixelServer_code{
  pixelServer_flood=8,
  pixelServer_frost=6,
  pixelServer_progressive=3,
  pixelServer_random=4,
  pixelServer_ripples=7,
  pixelServer_scanLine=1,
  pixelServer_scanRow=2,
  pixelServer_worm=5
 };

 static const char* pixelServer_strings[];

 static const char* toString(pixelServer_code code){
  return pixelServer_strings[(int)code-1];
 }

 enum surface_code{
  surface_ambientOcclusion=90,
  surface_black=22,
  surface_blur2=39,
  surface_btHybrid=99,
  surface_bump=7,
  surface_cell=71,
  surface_color=43,
  surface_cosColor=47,
  surface_cShaded=55,
  surface_default=4,
  surface_diffuse=1,
  surface_dispGlass2=45,
  surface_dist=82,
  surface_dist2=67,
  surface_dist3=68,
  surface_dReflect=46,
  surface_dSide=41,
  surface_energetic=10,
  surface_envMap=37,
  surface_fHybrid=75,
  surface_filter=40,
  surface_filterMetalic=29,
  surface_fresnel=66,
  surface_fromShader=5,
  surface_gisst=73,
  surface_glass2=27,
  surface_glassTransparent2=25,
  surface_glassTransparentText2=87,
  surface_gStat=60,
  surface_hybrid=18,
  surface_hybridRgb=23,
  surface_ids=88,
  surface_light=63,
  surface_metalic=2,
  surface_mltHybrid=98,
  surface_mltshaded=84,
  surface_noCC=81,
  surface_normal=100,
  surface_nrgShaded=61,
  surface_nrgTest=8,
  surface_occlusionMap=89,
  surface_pmBaked=95,
  surface_pmbcShaded=97,
  surface_pmbShaded=96,
  surface_pmcmcShaded=86,
  surface_pmcShaded=52,
  surface_pmDirect=83,
  surface_pmmcShaded=85,
  surface_pmPrecached=54,
  surface_pmShaded=59,
  surface_pmUnfiltered=64,
  surface_qStat=48,
  surface_qStatD=50,
  surface_qStatDReflect=51,
  surface_qStatReflect=49,
  surface_reflect=21,
  surface_reflectMap=36,
  surface_shaded=3,
  surface_shadeMap=35,
  surface_shSdEnergetic=16,
  surface_shSdSmoothEnergetic=17,
  surface_sss=72,
  surface_sst=74,
  surface_stat=42,
  surface_statd=38,
  surface_statReflect=44,
  surface_sTransparent=28,
  surface_transparent=24,
  surface_uvColors=102,
  surface_wireNormal=101,
  surface_zeroTransparent2=79
 };

 static const char* surface_strings[];

 static const char* toString(surface_code code){
  return surface_strings[(int)code-1];
 }

 enum shape_code{
  shape_and2=13,
  shape_circle=10,
  shape_clipMap=3,
  shape_cone=8,
  shape_dIntTriangle=34,
  shape_dIntTriangleSs=35,
  shape_distanceField=30,
  shape_dQuad=22,
  shape_dTriangle=32,
  shape_dTriangleSs=33,
  shape_elipCone=18,
  shape_elipParaboloid=19,
  shape_elipTube=17,
  shape_ellipsoid=12,
  shape_fibers=20,
  shape_intTriangle=24,
  shape_intTriangleSs=27,
  shape_isoSurface=29,
  shape_mandelBulb=28,
  shape_or2=14,
  shape_paraboloid=9,
  shape_polygon=6,
  shape_qJulia=31,
  shape_rectangle=11,
  shape_sphere=2,
  shape_sub2=15,
  shape_testShape=23,
  shape_triangle=4,
  shape_triangleSs=25,
  shape_tube=7,
  shape_uvTriangle=5,
  shape_uvTriangleSs=26,
  shape_wall=1
 };

 static const char* shape_strings[];

 static const char* toString(shape_code code){
  return shape_strings[(int)code-1];
 }

 enum screenSplit_code{
  screenSplit_auto=1,
  screenSplit_betterAuto=4,
  screenSplit_none=5,
  screenSplit_parts=2,
  screenSplit_size=3
 };

 static const char* screenSplit_strings[];

 static const char* toString(screenSplit_code code){
  return screenSplit_strings[(int)code-1];
 }

 enum toneMapper_code{
  toneMapper_desaturate=10,
  toneMapper_exponential=3,
  toneMapper_gamma=2,
  toneMapper_gammaAlpha=12,
  toneMapper_limitDr=6,
  toneMapper_linear=1,
  toneMapper_reverse=11,
  toneMapper_vExponential=5,
  toneMapper_vGamma=4,
  toneMapper_vGammaAlpha=13,
  toneMapper_vLimitDr=7
 };

 static const char* toneMapper_strings[];

 static const char* toString(toneMapper_code code){
  return toneMapper_strings[(int)code-1];
 }

 enum Texture_code{
  Texture_bitmap=2,
  Texture_color=1,
  Texture_fromShader=6,
  Texture_lodBitmap=4,
  Texture_toneMap=5,
  Texture_wire=3
 };

 static const char* Texture_strings[];

 static const char* toString(Texture_code code){
  return Texture_strings[(int)code-1];
 }

 enum ztoneMapper_code{
  ztoneMapper_inverse=2,
  ztoneMapper_linear=1,
  ztoneMapper_log=3
 };

 static const char* ztoneMapper_strings[];

 static const char* toString(ztoneMapper_code code){
  return ztoneMapper_strings[(int)code-1];
 }

 enum datatype_code{
  datatype_axes=5,
  datatype_double=3,
  datatype_reference=7,
  datatype_string=6,
  datatype_var=2,
  datatype_variable=1,
  datatype_vector=4
 };

 static const char* datatype_strings[];

 static const char* toString(datatype_code code){
  return datatype_strings[(int)code-1];
 }

 enum instanceAddAttribs_code{
  instanceAddAttribs_clipMap=1,
  instanceAddAttribs_light=3,
  instanceAddAttribs_timeShift=2
 };

 static const char* instanceAddAttribs_strings[];

 static const char* toString(instanceAddAttribs_code code){
  return instanceAddAttribs_strings[(int)code-1];
 }

 enum rayCast_code{
  rayCast_camera=1,
  rayCast_cameraHit=6,
  rayCast_cameraZ=3,
  rayCast_hitToNormalQuick=5,
  rayCast_init=7,
  rayCast_z=2,
  rayCast_zToHit=4
 };

 static const char* rayCast_strings[];

 static const char* toString(rayCast_code code){
  return rayCast_strings[(int)code-1];
 }

 enum previewCmds_code{
  previewCmds_flayer=13,
  previewCmds_iterativeWaitLevel=14,
  previewCmds_none=7,
  previewCmds_on=15,
  previewCmds_pause=4,
  previewCmds_pauseSignal=18,
  previewCmds_rasterize=9,
  previewCmds_raycast=16,
  previewCmds_raytrace=8,
  previewCmds_render=11,
  previewCmds_restart=12,
  previewCmds_setAnimMode=17,
  previewCmds_setAutoRestart=3,
  previewCmds_setDelay=6,
  previewCmds_setWeight=10,
  previewCmds_start=1,
  previewCmds_stop=2,
  previewCmds_waitLevel=5
 };

 static const char* previewCmds_strings[];

 static const char* toString(previewCmds_code code){
  return previewCmds_strings[(int)code-1];
 }

 enum octreeCmds_code{
  octreeCmds_build=2,
  octreeCmds_explorer=5,
  octreeCmds_flags=6,
  octreeCmds_invalidate=7,
  octreeCmds_limits=1,
  octreeCmds_show=4,
  octreeCmds_stats=3
 };

 static const char* octreeCmds_strings[];

 static const char* toString(octreeCmds_code code){
  return octreeCmds_strings[(int)code-1];
 }

 enum shapeSelectionOps_code{
  shapeSelectionOps_add=1
 };

 static const char* shapeSelectionOps_strings[];

 static const char* toString(shapeSelectionOps_code code){
  return shapeSelectionOps_strings[(int)code-1];
 }

 enum portalOps_code{
  portalOps_lightId=1,
  portalOps_shapeSelectionId=2,
  portalOps_sShapeSelectionLight=3
 };

 static const char* portalOps_strings[];

 static const char* toString(portalOps_code code){
  return portalOps_strings[(int)code-1];
 }

 enum portalTypes_code{
  portalTypes_caustics=2,
  portalTypes_global=1
 };

 static const char* portalTypes_strings[];

 static const char* toString(portalTypes_code code){
  return portalTypes_strings[(int)code-1];
 }

 enum openClCmds_code{
  openClCmds_deviceInfo=4,
  openClCmds_devices=2,
  openClCmds_platformInfo=3,
  openClCmds_platforms=1
 };

 static const char* openClCmds_strings[];

 static const char* toString(openClCmds_code code){
  return openClCmds_strings[(int)code-1];
 }

 enum gpGpuCmds_code{
  gpGpuCmds_addDebug=8,
  gpGpuCmds_addInternal=7,
  gpGpuCmds_addOpenCl=6,
  gpGpuCmds_clear=3,
  gpGpuCmds_listAvailable=1,
  gpGpuCmds_listUsed=2,
  gpGpuCmds_oct=9,
  gpGpuCmds_remove=5,
  gpGpuCmds_useGpus=4,
  gpGpuCmds_useInternal=10
 };

 static const char* gpGpuCmds_strings[];

 static const char* toString(gpGpuCmds_code code){
  return gpGpuCmds_strings[(int)code-1];
 }

 enum meshInitializers_code{
  meshInitializers_fromAnimOb=4,
  meshInitializers_fromBitmap=5,
  meshInitializers_fromVertexMap=2,
  meshInitializers_import=3,
  meshInitializers_triple=1
 };

 static const char* meshInitializers_strings[];

 static const char* toString(meshInitializers_code code){
  return meshInitializers_strings[(int)code-1];
 }

 enum materialInitializers_code{
  materialInitializers_fromMeshTag=1,
  materialInitializers_fromMeshTagName=2
 };

 static const char* materialInitializers_strings[];

 static const char* toString(materialInitializers_code code){
  return materialInitializers_strings[(int)code-1];
 }

 enum shaderNodes_code{
  shaderNodes_background=4,
  shaderNodes_chain=7,
  shaderNodes_colorFilter=16,
  shaderNodes_dummy=8,
  shaderNodes_environment=6,
  shaderNodes_extractAlpha=5,
  shaderNodes_fromMeshTag=1,
  shaderNodes_fromMeshTagName=12,
  shaderNodes_giDesaturate=17,
  shaderNodes_lowLevel=14,
  shaderNodes_mix=10,
  shaderNodes_postProcess=11,
  shaderNodes_toneMap=9,
  shaderNodes_toneMapFilter=3,
  shaderNodes_twoSided=2,
  shaderNodes_visibilityFlags=15,
  shaderNodes_wire=13
 };

 static const char* shaderNodes_strings[];

 static const char* toString(shaderNodes_code code){
  return shaderNodes_strings[(int)code-1];
 }

 enum surfaceOperations_code{
  surfaceOperations_clearFlag=2,
  surfaceOperations_setFlag=1
 };

 static const char* surfaceOperations_strings[];

 static const char* toString(surfaceOperations_code code){
  return surfaceOperations_strings[(int)code-1];
 }

 enum bitmapOp_code{
  bitmapOp_blit=21,
  bitmapOp_circle=13,
  bitmapOp_clear=15,
  bitmapOp_copy=2,
  bitmapOp_copyView=7,
  bitmapOp_fill=14,
  bitmapOp_flush=16,
  bitmapOp_line=12,
  bitmapOp_load=8,
  bitmapOp_loadRaw=20,
  bitmapOp_plot=1,
  bitmapOp_process=10,
  bitmapOp_resize=11,
  bitmapOp_save=9,
  bitmapOp_saveRaw=19,
  bitmapOp_saveScript=18,
  bitmapOp_show=3,
  bitmapOp_showAlpha=5,
  bitmapOp_showDirections=6,
  bitmapOp_showHit=17,
  bitmapOp_showZ=4
 };

 static const char* bitmapOp_strings[];

 static const char* toString(bitmapOp_code code){
  return bitmapOp_strings[(int)code-1];
 }

 enum phySkyLights_code{
  phySkyLights_parallel=2,
  phySkyLights_point=1,
  phySkyLights_rectangle=3,
  phySkyLights_rectangleTextured=4
 };

 static const char* phySkyLights_strings[];

 static const char* toString(phySkyLights_code code){
  return phySkyLights_strings[(int)code-1];
 }

 enum net_code{
  net_ftp=2,
  net_server=1
 };

 static const char* net_strings[];

 static const char* toString(net_code code){
  return net_strings[(int)code-1];
 }

 enum platform_code{
  platform_options=1,
  platform_test=2
 };

 static const char* platform_strings[];

 static const char* toString(platform_code code){
  return platform_strings[(int)code-1];
 }

 enum view_code{
  view_camAspect=5,
  view_camFilter=22,
  view_camSingleSide=4,
  view_close=3,
  view_flags=8,
  view_freeRenderedImage=12,
  view_offset=15,
  view_postProcess=17,
  view_rayDiff=16,
  view_remove=2,
  view_removeAll=13,
  view_render=21,
  view_save=7,
  view_select=1,
  view_selectActive=20,
  view_setActive=19,
  view_size=6,
  view_toneMapping=18,
  view_window=14
 };

 static const char* view_strings[];

 static const char* toString(view_code code){
  return view_strings[(int)code-1];
 }

 enum photonMap_code{
  photonMap_auto=22,
  photonMap_causticsBuild=1,
  photonMap_causticsMultiplier=17,
  photonMap_causticsRrValue=19,
  photonMap_causticsSearch=2,
  photonMap_globalBuild=6,
  photonMap_globalBuildLightMap=3,
  photonMap_globalBuildLightMapWithCaustics=28,
  photonMap_globalMultiplier=13,
  photonMap_globalSearch=7,
  photonMap_kdBalance=25,
  photonMap_kdOptimize=26,
  photonMap_lmAnim=16,
  photonMap_lmImportance=15,
  photonMap_photonNormal=4,
  photonMap_precachedBlur=18,
  photonMap_precachedBuild=8,
  photonMap_precachedCorner=20,
  photonMap_precachedSearch=9,
  photonMap_precacheLimitdr=14,
  photonMap_receivedMinHitRatio=10,
  photonMap_removeUnused=5,
  photonMap_render=29,
  photonMap_reset=27,
  photonMap_showPreview=21,
  photonMap_smoothPrecacheScale=12,
  photonMap_stats=23,
  photonMap_timePrecached=24
 };

 static const char* photonMap_strings[];

 static const char* toString(photonMap_code code){
  return photonMap_strings[(int)code-1];
 }

 enum finalGather_code{
  finalGather_gradients=6,
  finalGather_gradients2=1,
  finalGather_gradients3=2,
  finalGather_gradients4=3,
  finalGather_gradientsFlags=11,
  finalGather_gradientsNeighbour=7,
  finalGather_gradReload=4,
  finalGather_gradSidethreshold=5,
  finalGather_irradianceBlur=9,
  finalGather_irradianceBlurGamma=8,
  finalGather_irrMissingBlur=13,
  finalGather_pixels=15,
  finalGather_pmCorner=18,
  finalGather_prerender=22,
  finalGather_rays=16,
  finalGather_raysNMultiplier=12,
  finalGather_render=24,
  finalGather_reset=23,
  finalGather_scale=19,
  finalGather_scaleRelativeToGlobalPm=20,
  finalGather_scaleRelativeToPrecachedPm=21,
  finalGather_showCornerSamples=14,
  finalGather_showSamples=10,
  finalGather_timeGradients=17
 };

 static const char* finalGather_strings[];

 static const char* toString(finalGather_code code){
  return finalGather_strings[(int)code-1];
 }

 enum lightOptions_code{
  lightOptions_lemQuality=2,
  lightOptions_lineQuality=4,
  lightOptions_rectangleQuality=1
 };

 static const char* lightOptions_strings[];

 static const char* toString(lightOptions_code code){
  return lightOptions_strings[(int)code-1];
 }

 enum lightWaveMeshOptions_code{
  lightWaveMeshOptions_airPolys=5,
  lightWaveMeshOptions_baseNormalGrab=6,
  lightWaveMeshOptions_blur=3,
  lightWaveMeshOptions_blurDoubleSide=8,
  lightWaveMeshOptions_raysLimit=7,
  lightWaveMeshOptions_reflectBlurModel=10,
  lightWaveMeshOptions_sideness=4,
  lightWaveMeshOptions_textureSystem=2,
  lightWaveMeshOptions_unseenByRaysAffectsGi=9
 };

 static const char* lightWaveMeshOptions_strings[];

 static const char* toString(lightWaveMeshOptions_code code){
  return lightWaveMeshOptions_strings[(int)code-1];
 }

 enum lightWave_code{
  lightWave_areaLights=1,
  lightWave_backgroundInputTone=25,
  lightWave_bitmapLoad=10,
  lightWave_camBokeh=17,
  lightWave_camCastMaps=12,
  lightWave_camDofTargetObject=20,
  lightWave_camMeshAndUv=19,
  lightWave_camMode=3,
  lightWave_camStereo=22,
  lightWave_commRingEvent=29,
  lightWave_coneToArea=5,
  lightWave_controlAmbient=31,
  lightWave_controlBackground=32,
  lightWave_controlEnvironment=33,
  lightWave_directLoader=11,
  lightWave_environmentFlags=6,
  lightWave_ignoreItemId=13,
  lightWave_ignoreItemName=14,
  lightWave_inputTone=27,
  lightWave_instanceTemplateItem=24,
  lightWave_invalidateScene=30,
  lightWave_itemReload=34,
  lightWave_lightInputTone=16,
  lightWave_meshesOptions=4,
  lightWave_nonPhyLightsCastsPhotons=35,
  lightWave_outputTo=21,
  lightWave_pathMode=15,
  lightWave_raySamples=9,
  lightWave_replaceLight=23,
  lightWave_sceneLoad=2,
  lightWave_sceneReLoad=28,
  lightWave_selfInstance=18,
  lightWave_shaderNodeBackground=7,
  lightWave_shaderNodeEnvironment=8,
  lightWave_textureInputTone=26
 };

 static const char* lightWave_strings[];

 static const char* toString(lightWave_code code){
  return lightWave_strings[(int)code-1];
 }

 enum treeds_code{
  treeds_sceneLoad=2
 };

 static const char* treeds_strings[];

 static const char* toString(treeds_code code){
  return treeds_strings[(int)code-1];
 }

 enum meshOptions_code{
  meshOptions_ambientOcclusion=8,
  meshOptions_bitFlags=4,
  meshOptions_diffuseModel=1,
  meshOptions_illuminateModel=7,
  meshOptions_overrideColor=5,
  meshOptions_overrideSurface=2,
  meshOptions_overrideWire=6,
  meshOptions_surfaceFlags=3
 };

 static const char* meshOptions_strings[];

 static const char* toString(meshOptions_code code){
  return meshOptions_strings[(int)code-1];
 }

 enum animOperations_code{
  animOperations_renderFrame=4,
  animOperations_reset=3,
  animOperations_setFps=2,
  animOperations_setupFrame=1
 };

 static const char* animOperations_strings[];

 static const char* toString(animOperations_code code){
  return animOperations_strings[(int)code-1];
 }

 enum animObjectAttributesSet_code{
  animObjectAttributesSet_addAxesKey=8,
  animObjectAttributesSet_addChannelKey=9,
  animObjectAttributesSet_addInstanceTransformer=16,
  animObjectAttributesSet_addKey=18,
  animObjectAttributesSet_addPositionKey=7,
  animObjectAttributesSet_clearInstanceTransformers=17,
  animObjectAttributesSet_clearKeys=6,
  animObjectAttributesSet_invalidateGeometry=22,
  animObjectAttributesSet_invalidateSurfaces=23,
  animObjectAttributesSet_remove=12,
  animObjectAttributesSet_rename=3,
  animObjectAttributesSet_setActive=13,
  animObjectAttributesSet_setMeshHandnessAutoFlip=19,
  animObjectAttributesSet_setParent=1,
  animObjectAttributesSet_setStatic=4,
  animObjectAttributesSet_showInfo=21,
  animObjectAttributesSet_showKeys=5,
  animObjectAttributesSet_typeBackground=24,
  animObjectAttributesSet_typeCopy=2,
  animObjectAttributesSet_typeCopyTree=20,
  animObjectAttributesSet_typeInstance=15,
  animObjectAttributesSet_typeMesh=10,
  animObjectAttributesSet_typeMeshInstance=14,
  animObjectAttributesSet_typeNull=11
 };

 static const char* animObjectAttributesSet_strings[];

 static const char* toString(animObjectAttributesSet_code code){
  return animObjectAttributesSet_strings[(int)code-1];
 }

 enum vertexMapTypes_code{
  vertexMapTypes_fixedSize=1,
  vertexMapTypes_grabMesh=2
 };

 static const char* vertexMapTypes_strings[];

 static const char* toString(vertexMapTypes_code code){
  return vertexMapTypes_strings[(int)code-1];
 }

 enum vertexMapOps_code{
  vertexMapOps_flush=3,
  vertexMapOps_resize=2,
  vertexMapOps_saveScript=4,
  vertexMapOps_show=1
 };

 static const char* vertexMapOps_strings[];

 static const char* toString(vertexMapOps_code code){
  return vertexMapOps_strings[(int)code-1];
 }

 enum memCmds_code{
  memCmds_flush=1,
  memCmds_markerSet=4,
  memCmds_markerStats=3,
  memCmds_show=5,
  memCmds_stats=2
 };

 static const char* memCmds_strings[];

 static const char* toString(memCmds_code code){
  return memCmds_strings[(int)code-1];
 }

 enum renderInfosStringFormat_code{
  renderInfosStringFormat_arch=27,
  renderInfosStringFormat_br=26,
  renderInfosStringFormat_buffer=25,
  renderInfosStringFormat_build=16,
  renderInfosStringFormat_buswidth=28,
  renderInfosStringFormat_centisecs=10,
  renderInfosStringFormat_compiler=21,
  renderInfosStringFormat_cr=34,
  renderInfosStringFormat_days=2,
  renderInfosStringFormat_dq=33,
  renderInfosStringFormat_endian=29,
  renderInfosStringFormat_extension=23,
  renderInfosStringFormat_file=7,
  renderInfosStringFormat_fileformat=20,
  renderInfosStringFormat_frame=24,
  renderInfosStringFormat_group=14,
  renderInfosStringFormat_height=9,
  renderInfosStringFormat_hours=3,
  renderInfosStringFormat_kray=12,
  renderInfosStringFormat_lf=35,
  renderInfosStringFormat_libraryDir=37,
  renderInfosStringFormat_mins=4,
  renderInfosStringFormat_now=17,
  renderInfosStringFormat_nowstamp=31,
  renderInfosStringFormat_platform=22,
  renderInfosStringFormat_prompt=18,
  renderInfosStringFormat_ptime=15,
  renderInfosStringFormat_score=30,
  renderInfosStringFormat_secs=5,
  renderInfosStringFormat_sectime=11,
  renderInfosStringFormat_sq=36,
  renderInfosStringFormat_threads=13,
  renderInfosStringFormat_time=6,
  renderInfosStringFormat_ver=1,
  renderInfosStringFormat_view=32,
  renderInfosStringFormat_width=8
 };

 static const char* renderInfosStringFormat_strings[];

 static const char* toString(renderInfosStringFormat_code code){
  return renderInfosStringFormat_strings[(int)code-1];
 }

};

inline CommandBuffer& operator+(CommandBuffer& b,Enums::cmd_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::groupOps_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::groupLinkTypes_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::aaMode_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::aaModeOld_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::autoPhoton_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::background_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::bitmaps_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::outputChannels_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::blend_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::camera_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::dither_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::environment_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::fiberpackParams_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::infos_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::settings_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::instanceTransformer_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::fileCommands_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::toneMapSet_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::light_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::lightOps_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::materialAttrib_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::materialTexture_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::Mapping_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::meshTag_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::meshExport_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::meshOperations_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::meshVertexmapGrab_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::metatextureAttrib_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::metatextureMapping_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::outputFormats_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::objectSet_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::miscSharedObjects_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::miscSharedObjectOpetarions_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::pixelFilter_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::postProcessor_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::pixelServer_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::surface_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::shape_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::screenSplit_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::toneMapper_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::Texture_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::ztoneMapper_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::datatype_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::instanceAddAttribs_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::rayCast_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::previewCmds_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::octreeCmds_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::shapeSelectionOps_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::portalOps_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::portalTypes_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::openClCmds_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::gpGpuCmds_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::meshInitializers_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::materialInitializers_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::shaderNodes_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::surfaceOperations_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::bitmapOp_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::phySkyLights_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::net_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::platform_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::view_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::photonMap_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::finalGather_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::lightOptions_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::lightWaveMeshOptions_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::lightWave_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::treeds_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::meshOptions_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::animOperations_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::animObjectAttributesSet_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::vertexMapTypes_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::vertexMapOps_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::memCmds_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

inline CommandBuffer& operator+(CommandBuffer& b,Enums::renderInfosStringFormat_code c){
 b.addEnum(c,Enums::toString(c));
 return b;
}

};

#endif
