#include "../kraysdk/base/mt.h"
#include "../kraysdk/kray.h"

using namespace Kray;

MTJobSplit::MTJobSplit(const MTFunctionsVtable* vt):vt(vt),group(0){
	if (vt){
		group=vt->allocGroup();
	}
}
MTJobSplit::~MTJobSplit(){
	if (group){	// if group!=0 -> vt!=0
		vt->freeGroup(group);
	}
}
void MTJobSplit::start(const size_t jobSize[3],int threads){
	if (group && threads>1){
		vt->multiThreadedExecute(group,jobSize,threads,callback,(void*)this);
	}else{	// no way to call MT, just do regular loop
		size_t js[3];
		size_t ji[3];
		
		for (int a=0 ; a<3 ;a++){
			js[a]=jobSize[a];
			if (!js[a]) js[a]=1;
		}
		
		for (ji[2]=0 ; ji[2]<js[2] ; ji[2]++){
			for (ji[1]=0 ; ji[1]<js[1] ; ji[1]++){
				for (ji[0]=0 ; ji[0]<js[0] ; ji[0]++){
					run(ji,0);
				}
			}
		}
	}
}