#include "../kraysdk/kray.h"
#include "../kraysdk/base/rt.h"

using namespace Kray;

RaytraceAccess* Instance::createRaytraceAccess() const{
	return new RaytraceAccess(parent->vtable().krt,kinst);
}

RaytraceAccess::RaytraceAccess(RaytraceFunctionsVtable* krt,KrayLibraryInstance* kli):krt(krt){
	rtBuf=krt->allocRaytraceBuffer(kli);
}
RaytraceAccess::~RaytraceAccess(){
	krt->freeRaytraceBuffer(rtBuf);
}
char RaytraceAccess::allocBuffer(const size_t jobSize[3]){
	if (krt->setRaytraceBufferSize(rtBuf,jobSize)){
		krt->getDimensions(rtBuf,&input);
		krt->getDimensions(rtBuf,&output);
		input.alloc();
		output.alloc();
		
		size_t total=input.totalBuckets();
		for (size_t a=0 ; a<total ; a++){
			input.data[a]=(RaytraceInput*)krt->getRaytraceBucket(rtBuf,a,0);
			output.data[a]=(RaytraceOutput*)krt->getRaytraceBucket(rtBuf,a,1);
		}
		
		return 1;
	}else{
		return 0;
	}
}
