#include <stddef.h>
#include <stdio.h>

#include "../kraysdk/staticlink.h"

#include "../kraysdk/kray.h"
#include "../kraysdk/buffer/dynamic.h"
#include "../kraysdk/buffer/binary.h"
#include "../kraysdk/commands.h"
#include "../kraysdk/startup.h"
#include "../kraysdk/base/listener.h"

using namespace Kray;

extern "C" void KrayLibInitFunction(Library* kray);

Library& Kray::getLibrary(const char* dynamicLibraryDirectory){
	static StaticLibraryLoader staticKrayLibraryLoader;

	return staticKrayLibraryLoader.getLibrary(dynamicLibraryDirectory);
}

StaticLibraryLoader::~StaticLibraryLoader(){
	delete loadedLibrary;
}
Library& StaticLibraryLoader::getLibrary(const char* libDir){
	if (!loadedLibrary){
#ifdef KRAY_LIB_STATIC
		loadedLibrary=new Library(KrayLibInitFunction,libDir);
#else
		loadedLibrary=new Library(libDir);
#endif
	}

	return *loadedLibrary;
}
