#ifndef KRAY_NO_IOSTREAM

#include "../kraysdk/type/string.h"
#include "../kraysdk/type/vector.h"
#include "../kraysdk/type/axes.h"
#include "../kraysdk/type/coordsys.h"
#include "../kraysdk/stdc/iostream.h"

namespace Kray{

std::ostream& operator<<(std::ostream& out,const Vector& v){
	out << "(";

	for (int a=0 ; a<v.dim() ; a++){
		if (a!=0) out << ",";
		out << v[a];
	}

	out << ")";

	return out;
}
std::ostream& operator<<(std::ostream& out,const Axes& ax){
	AxesHpb v;
	ax.toAxesHpb(v);

	out << "<";

	if (!v.isHpbNulls()){
		for (int a=0 ; a<v.dim() ; a++){
			if (a!=0) out << ",";
			out << (v.hpb(a)*180/PI);
		}
	}

	out << ">";
	
	if (!v.isSclOnes()){
		out << "*(";

		out << v.scl(0);

		if (!v.isSclProportional()){
			for (int a=1 ; a<v.dim() ; a++){
				out << ",";
				out << v.scl(a);
			}
		}

		out << ")";
	}

	return out;
}
std::ostream& operator<<(std::ostream& out,const CoordSys& ax){
	if (!ax.isCenteredAtZero()){
		out << Vector::fromArray(ax.v,3);
	}

	out << "@";

	if (!ax.isEyeAxes()){
		out << Axes(ax.a);
	}

	return out;
}

}

#endif