#ifndef SDK_CORE_VTABLE_H
#define SDK_CORE_VTABLE_H

#include "object.h"

class KrayLibraryInstance;

namespace Kray{

struct CoreFunctions{
	static void KRAYDLL_CALL_TYPE release();	

	static KrayLibraryInstance* KRAYDLL_CALL_TYPE createInstance(class Instance*);
	static void KRAYDLL_CALL_TYPE releaseInstance(KrayLibraryInstance* kli);
	
	static int KRAYDLL_CALL_TYPE getKrayFlag(int mode);
	static const char* KRAYDLL_CALL_TYPE getKrayString(int mode);
	
	static void KRAYDLL_CALL_TYPE processMessage(KrayLibraryInstance* kli,class EventData& ked);
	
	static KrayObject KRAYDLL_CALL_TYPE addTriangleDirect(KrayLibraryInstance* kli,const class TriangleAddInfo& ktai);
	static int KRAYDLL_CALL_TYPE addPolyToMesh(const class PolyAddInfo& kpai);
	
	static void KRAYDLL_CALL_TYPE getSceneInfo(KrayLibraryInstance* kli,class SceneInfo* ksi);

	static int KRAYDLL_CALL_TYPE setPlatformOption(const char* option,const char* stringData,void* binaryData);
};

class CoreFunctionsVtable : public Object{
public:
	void (KRAYDLL_CALL_TYPE *release)();	

	KrayLibraryInstance* (KRAYDLL_CALL_TYPE *createInstance)(class Instance*);
	void (KRAYDLL_CALL_TYPE *releaseInstance)(KrayLibraryInstance*);

	int (KRAYDLL_CALL_TYPE *getKrayFlag)(int mode);
	const char* (KRAYDLL_CALL_TYPE *getKrayString)(int mode);

	void (KRAYDLL_CALL_TYPE *processMessage)(KrayLibraryInstance* kli,class EventData& ked);

	KrayObject (KRAYDLL_CALL_TYPE *addTriangleDirect)(KrayLibraryInstance* kli,const TriangleAddInfo& ktai);
	int (KRAYDLL_CALL_TYPE *addPolyToMesh)(const PolyAddInfo& kpai);
	
	void (KRAYDLL_CALL_TYPE *getSceneInfo)(KrayLibraryInstance* kli,class SceneInfo* ksi);

	int (KRAYDLL_CALL_TYPE *setPlatformOption)(const char* option,const char* stringData,void* binaryData);

public:
	CoreFunctionsVtable(){
	}

	void init();
	void exit(){
//		if (ok()){
			release();
//		}
		
//		release=0;
	}
	
//	char ok(){
//		return release!=0;
//	}
};

};

#endif