#ifndef SDK_EVENT_DISPATCH_LISTENER_H
#define SDK_EVENT_DISPATCH_LISTENER_H

#ifndef __cplusplus
#error C++ required
#endif

#include "listener.h"

namespace Kray{

class TextStreamListener{
public:
	virtual void textLine(const char* txt){
	}
	virtual void textNewLine(){
	};
	virtual void getTextLine(const char* promptString,KrayEventTextBufferData* bufferData){
		bufferData->buffer=0;
	}
	virtual int getTextFlags(){
		return 0;
	}

	virtual ~TextStreamListener(){
	}
};

class GfxWindowListener{
public:
	virtual ~GfxWindowListener(){
	}
};


class DispatchLinkedListener : public InstanceLinkedListener{	// dispatches calls to stream listener and windows listener
public:
	DispatchLinkedListener(){
	}

protected:
	void* createTextStream(){
		return (void*)createTextListner();
	}
	void destroyTextStream(void* handle);

	void textLine(void* handle,const char* txt){
		if (!handle) return;

		((TextStreamListener*)handle)->textLine(txt);
	};
	void textNewLine(void* handle){
		if (!handle) return;

		((TextStreamListener*)handle)->textNewLine();
	};
	void getTextLine(void* handle,const char* promptString,KrayEventTextBufferData* bufferData){
		if (!handle) return;

		((TextStreamListener*)handle)->getTextLine(promptString,bufferData);
	}
	int getTextFlags(void* handle){
		if (!handle) return 0;

		return ((TextStreamListener*)handle)->getTextFlags();
	}

public:
	virtual TextStreamListener* createTextListner(){	// overload this with custom class allocator
		return 0;
	}

};

};

#endif