#ifndef T_CONVERT_H
#define T_CONVERT_H

#ifdef KRAY_CL_KERNEL
#define KRAY_CL_ATTRIBUTE __attribute__ ((endian(host)))
#else
#define KRAY_CL_ATTRIBUTE 
#endif

typedef KRAY_CL_ATTRIBUTE float kl_float;
typedef KRAY_CL_ATTRIBUTE int kl_int;
typedef KRAY_CL_ATTRIBUTE void* kl_void_ptr;

typedef struct{
	kl_float v[3];
} kl_vec;

typedef struct{
	kl_vec pos;
	kl_vec dir;
} kl_line;

#define read_2(fr,to) (to)=(fr);
#define write_2(fr,to) (to)=(fr);

#define read_4(fr,to) (to)=(fr);
#define write_4(fr,to) (to)=(fr);

#define read_f4(fr,to) (to)=(fr);
#define write_f4(fr,to) (to)=(fr);

#if defined(KRAY_CL_KERNEL) || defined(KRAY_C_KERNEL)
	#define read_vec(fr,to) read_f4((fr).v[0],(to).x); read_f4((fr).v[1],(to).y); read_f4((fr).v[2],(to).z)
	#define write_vec(fr,to) write_f4((fr).x,(to).v[0]); write_f4((fr).y,(to).v[1]); write_f4((fr).z,(to).v[2]);
#else
	#define read_vec(fr,to) read_f4((fr).v[0],(to.X())); read_f4((fr).v[1],(to.Y())); read_f4((fr).v[2],(to.Z()))
	#define write_vec(fr,to) write_f4((fr).X(),(to).v[0]); write_f4((fr).Y(),(to).v[1]); write_f4((fr).Z(),(to).v[2]);
#endif

#endif	/* T_CONVERT_H */
