#ifndef SDK_MULTITHREADING_TOOLS_MUTEX_H
#define SDK_MULTITHREADING_TOOLS_MUTEX_H

namespace Kray{

class Mutex{
	const class MTFunctionsVtable* vt;
	void* mtx;

public:
	Mutex(const MTFunctionsVtable* vt=0):mtx(0){
		init(vt);
	}
	~Mutex(){
		destroy();
	}

	void destroy();
	void init(const MTFunctionsVtable* vt);

	void lock();
	void unlock();
	char trylock();
};

class MutexLocker{
	Mutex* m;

public:
	MutexLocker(Mutex& m):m(&m){
		m.lock();
	}
	~MutexLocker(){
		m->unlock();
	}
};

};

#endif