#ifndef KRAY_OFFLINE_PROTOTYPER_H
#define KRAY_OFFLINE_PROTOTYPER_H

#include "proto.h"
#include "../buffer/offline.h"

// special prototyper for offline script generation

namespace Kray{

class OfflinePrototyper : public Prototyper{
protected:
	class InternalOfflineBuffer : public CommandOfflineBuffer{
	protected:
		OfflinePrototyper& parent;

	public:
		InternalOfflineBuffer(OfflinePrototyper& parent,bool packEnums=false):parent(parent),CommandOfflineBuffer(packEnums){
		}

		void parse(){
			out(getTerminatedBuffer());
		}
		void out(const char* commands){
			parent.out(commands);
		}
	};

public:
	OfflinePrototyper(bool packEnums=false):Prototyper(){
		buf=new InternalOfflineBuffer(*this,packEnums);
	}
	OfflinePrototyper(CommandOfflineBuffer& buf):Prototyper(buf){
	}

	CommandOfflineBuffer& buffer(){
		return *((CommandOfflineBuffer*)&Prototyper::buffer());
	}

	virtual void out(const char* commands){	// overload this method when not using CommandOfflineBuffer
	}
};

};

#endif