#ifndef KRAY_PROTOTYPER_H
#define KRAY_PROTOTYPER_H

#include "enums.h"
#include "../kprotos.h"

// basic Kray C++ prototyper class
// allows to call Kray Script with C function syntax

#ifndef KRAY_COMMANDS_PROTOS_H		// protos not yet generated

#include "../kprotosinc.h"

namespace Kray{

class Protos : public ProtoBase{
};

};

#endif

namespace Kray{

class Prototyper : public Protos{
	bool freeBuffer;

protected:
	Prototyper(CommandBuffer* buf=0);					// calls 'delete buf;' on destruction

public:
	Prototyper(class Instance* inst);					// creates default CommandBuffer
	Prototyper(CommandBuffer& buf):freeBuffer(false){	// 'buf' is not destroyed on Prototyper destruction
		this->buf=&buf;
	}

	virtual ~Prototyper();

	operator CommandBuffer&() const{
		return buffer();
	}
};

};

#endif
