#ifndef MULT_ARGS_UTF8_H
#define MULT_ARGS_UTF8_H

#include <own/memhneeded.h>
#include "utf8.h"

template <class T> class CommandLineUTF8Encoder{
	int utf8argc;
	const char** utf8argv;
	
	UTF8EncoderBuffer<T>* buffers;
public:
	CommandLineUTF8Encoder(int argc,const T** argv):utf8argc(argc){
		utf8argv=new const char*[argc];
		buffers=new UTF8EncoderBuffer<T>[argc];
		
		for (int a=0 ; a<argc ; a++){
			buffers[a].encode(argv[a]);
			utf8argv[a]=buffers[a].buffer();
		}
	}
	~CommandLineUTF8Encoder(){
		delete[] utf8argv;
		delete[] buffers;
	}
	
	int argc() const{
		return utf8argc;
	}
	const char** argv() const{
		return utf8argv;
	}
};

#endif