#ifndef STRNUMLIB_H
#define STRNUMLIB_H

#include <stddef.h>

size_t modulo_2_size_t(const char*& str,int modulo=10);
double udecimal_2_double(const char*& str);

int modulo_2_int(const char*& str,int modulo=10);
double sdecimal_2_double(const char *&str);

void size_t_2_modulo(size_t n,char *buffer,size_t &bufsize,char fill=0,int modulo=10,char minus=0);
void double_2_decimal(double n,char *buffer,size_t &bufsize,int dot,char fill=0);
int double_predot_count(double n);

void int_2_modulo(int n,char* buffer,size_t &bufsize,char fill=0,int modulo=10);
void double_2_sdecimal(double n,char* buffer,size_t &bufsize,int dot,char fill=0);
void double_2_natural(double n,char* buffer,size_t &bufsize,int dot,char fill=0);

void double_2_sci(double n,char *buffer,size_t &bufsize,int dot,int sci_tolerance=0);

inline size_t s2n_scan(const char* str,int* res){
	const char *strt=str;
	
	*res=(int)modulo_2_int(str);
	
	return str-strt;
}
inline size_t s2n_scan(const char* str,size_t* res,int modulo=10){
	const char *strt=str;
	
	*res=modulo_2_int(str,modulo);
	
	return str-strt;
}
inline size_t s2n_scan(const char* str,void** res){
	const char *strt=str;
	
	*res=(void*)modulo_2_size_t(str,16);
	
	return str-strt;
}
inline size_t s2n_scan(const char* str,float* res){
	const char *strt=str;
	
	*res=(float)sdecimal_2_double(str);
	
	return str-strt;
}
inline size_t s2n_scan(const char* str,double* res){
	const char *strt=str;
	
	*res=sdecimal_2_double(str);
	
	return str-strt;
}
void s2n_numcat(void* n,char* buffer);
void s2n_numcat(int n,char* buffer);
void s2n_numcat(double n,char* buffer,size_t blen=12,int dot=8);
void s2n_numcat(float n,char* buffer);

void s2n_numcat(unsigned int n,char* buffer,int width);

void s2n_amemcpy(void* dest,const void* src,size_t size);	// aligned (to sizeof(size_t), both adresses and size)
void s2n_memcpy(void* dest,const void* src,size_t size);
void s2n_amemset(void* dest,unsigned char value,size_t size);		// aligned
void s2n_memset(void* dest,unsigned char value,size_t size);
int s2n_memcmp(void* e1,void* e2,size_t size);

size_t s2n_strlen(const char* string);
void s2n_strcpy(char* dest,const char* src);
void s2n_strcat(char* dest,const char* src);
int s2n_strcmp(const char* s1,const char* s2);
int s2n_strncmp(const char* s1,const char* s2,size_t max);
void s2n_strncpy(char* dest,const char* src,size_t max);
const char* s2n_strstr(const char* text,const char* find);
char* s2n_strstr(char* text,const char* find);

#endif

