#ifndef TEXT_BUFFER_H
#define TEXT_BUFFER_H

#include "resizablebuffer.h"

class TextBuffer : public ResizableBuffer{
protected:
	const char* sepMode;
public:
	TextBuffer(){
		free();
	}
	~TextBuffer(){
		free();
	}

	void free(){
		ResizableBuffer::freeBuffer();
		sepMode=0;
	}

	void concat(char a){
		append(a);
	}
	void concat(const char* str);
	void concatQuotedString(const char* str,char quoteType='"');
	void concat(int a);
	void concat(double a);
	void concat(float a);


	void terminate(){
		used=0;

		setSeparate(0);
	}
	void setSeparate(const char* s=0){
		sepMode=s;
	}

	void setSeparateIf(const char* ifSome,const char* ifNone=0);
	void separate();

	operator const char*();

	TextBuffer& operator+(const char* str);
	TextBuffer& operator+=(const char* str);
	void addQuotedString(const char* str,char quote='"');

	template <class T> TextBuffer& operator+(T a){
		separate();
		concat(a);
		
		return (*this);
	}
};

#endif