#ifndef SDK_KRAY_JNI_LISTENERS_H
#define SDK_KRAY_JNI_LISTENERS_H

/*
	Kray SDK Java JNI wrapper header
*/

#include "../../kraysdk/utils/jni_tools.h"
#include "../../kraysdk/base/dispatchlistener.h"

using namespace Kray;

class JavaTextStreamEventListner : public TextStreamListener{
	class JavaEventListener* parent;
	JniGlobalReference jListener;

	jmethodID mTextLine;
	jmethodID mTextNewLine;
	jmethodID mGetTextFlags;
	jmethodID mGetTextLine;

public:
	JavaTextStreamEventListner(JavaEventListener* parent,JNIEnv* env,jobject javaListner);
	~JavaTextStreamEventListner(){
	}

	char ok() const{
		return mTextLine!=0 && mTextNewLine!=0 && mGetTextFlags!=0 && mGetTextLine!=0;
	}

	void getTextLine(const char* promptString,KrayEventTextBufferData* bufferData);
	int getTextFlags();
	void textLine(const char* txt);
	void textNewLine();
};

class JavaEventListener : public DispatchLinkedListener{
	JniGlobalReference jListener;

public:
	JavaEventListener(jobject javaListner,JNIEnv* env=0):jListener(javaListner,env){
	}
	~JavaEventListener(){
	}

	TextStreamListener* createTextListner();

	char ok() const{
		return jListener!=0;
	}
};

#endif
