#include "../../../kraysdk/legacy/kray1x.h"

KrayLib1x kray;

int KrayLib1x::parse(const char* script,const char* name){
	if (parseMode){
		return kray->parse(script,name);
	}else{
		k2Cmd.truncate();
		k2Cmd.appendString("k2{");
		k2Cmd.appendString(script);
		k2Cmd.appendString(";\n}");
		k2Cmd.append(0);

		return kray->parse(k2Cmd.getBuffer(),name);
	}
}
void KrayLib1x::renderInit(){
	defaultGroup=kray->getObjectByName("",KrayObjectGroupType);
}
void KrayLib1x::renderCleanUp(){
	defaultGroup=0;
}
void KrayLib1x::render(int flags){
	if (flags&KRAY_RENDERASYNC){
		kray->parse("previewer render;","render(KRAY_RENDERASYNC)");
	}else{
		kray->parse("render;","render()");
	}
}	
char KrayLib1x::load(){
	if (listener){
		kray=createInstanceWithListner(listener);
	}else if (handler){
		kray=createInstanceWithHandler(handler);
	}else{
		kray=createInstance();
	}
		
	return kray!=0;
}
void KrayLib1x::release(){
	releaseInstance(kray);
	kray=0;

	Library::release();
}

////////////////////////////////////////////////////////////////////

void Kray2DeprecatedListner::setPixels(const KrayEventPixelTable& kept){
	KrayEventPixel* pixtab=kept.pxls;	// redirect to deprecated method
	
	for (size_t a=0 ; a<kept.count ; a++){
		setPixel(pixtab[a].x,pixtab[a].y,pixtab[a].c);
	}
};
void Kray2DeprecatedListner::copyPixels(unsigned int* pixels,int sx,int x1,int y1,int x2,int y2){ // redirect to setPixel
	const int bufSize=128;
	
	KrayEventPixel pxls[bufSize];
	
	KrayEventPixelTable kep;
	kep.count=0;
	kep.pxls=pxls;
	
	pixels+=y1*sx+x1;
	sx-=(x2-x1);
	for (int y=y1 ; y<y2 ; y++){
		for (int x=x1 ; x<x2 ; x++){
			pxls[kep.count].x=x;
			pxls[kep.count].y=y;
			pxls[kep.count].c=*pixels++;
			
			kep.count++;
			if (kep.count==bufSize){
				setPixels(kep);
				kep.count=0;
			}
		}
		pixels+=sx;
	}
	
	setPixels(kep);
}
