#ifndef PROTOTYPER_STREAMS_H
#define PROTOTYPER_STREAMS_H

#include "offline.h"
#include "../stdc/iostream.h"

namespace Kray{

class OstreamPrototyper : public OfflinePrototyper{
protected:
	std::ostream& stream;
public:
	OstreamPrototyper(std::ostream& stream,bool packEnums=false):OfflinePrototyper(packEnums),stream(stream){
	}

	void out(const char* scriptLine){
		stream << scriptLine << std::endl;
	}
};

class OstreamLinePrintPrototyper : public OstreamPrototyper{
	int line;
public:
	OstreamLinePrintPrototyper(std::ostream& stream,bool packEnums=false):OstreamPrototyper(stream,packEnums),line(1){
	}

	void out(const char* scriptLine){
		stream << "Line " << (line++) << "\t: " << scriptLine << std::endl;
	}
};

class OstreamPlusDirectPrototyper : public OstreamPrototyper{
	Kray::Instance& ki;
public:
	OstreamPlusDirectPrototyper(std::ostream& stream,Kray::Instance& ki,bool packEnums=false):OstreamPrototyper(stream,packEnums),ki(ki){
	}

	void out(const char* scriptLine){
		stream << scriptLine << std::endl;
		ki.parse(scriptLine);
	}
};

};

#endif