#ifndef KRAY_STRING_H
#define KRAY_STRING_H

#include "../base/parser.h"
#include "../symbol/symbol.h"

namespace Kray{

class String : public KrayStringCore{
public:
	String(const char* string=0){
		set(string);
	}
	
	operator const char*() const{
		return string;
	}

	void set(const char* string=0){
		this->string=string;
	}

	KrayDtTypes dtType() const{
		return KrayDtStringType;
	}
};

class StringSymbol : public DatatypeSymbol{
	void registerSymbol();
public:
	StringSymbol(CommandBuffer& ktb,const char* name=0):DatatypeSymbol(ktb,name){
		registerSymbol();
	}	

	void directSet(const String& v);
	void directGet(String& v) const;

	const char* toString(DynamicBuffer& rb);
};

};

#endif