#include "str2num.h"
#include "textbuffer.h"

void TextBuffer::concat(int a){
	const size_t s=10;
	size_t buflen=s;
	char tmp[s];

	int_2_modulo(a,tmp,buflen);
	
	concat(tmp);
}
void TextBuffer::concat(double a){
	const size_t s=23;
	size_t buflen=s;
	char tmp[s];

	double_2_sci(a,tmp,buflen,8,5);

	concat(tmp);
}
void TextBuffer::concat(float a){
	const size_t s=14;
	size_t buflen=s;
	char tmp[s];

	double_2_sci(a,tmp,buflen,5,4);

	concat(tmp);
}
void TextBuffer::concat(const char* str){
	size_t nl=s2n_strlen(str);
	
	append(str,nl+1);
	
	used--;	// last null character is not actually used
}
void TextBuffer::concatQuotedString(const char* str,char quoteType){
	while(*str){
		append(*str);

		if (*str==quoteType){
			append(quoteType);		// " -> ""
		}

		str++;
	}
}
void TextBuffer::setSeparateIf(const char* ifSome,const char* ifNone){
	if (sepMode){
		setSeparate(ifSome);
	}else{
		setSeparate(ifNone);
	}
}

void TextBuffer::separate(){
	if (sepMode){
		concat(sepMode);
	}
}

TextBuffer::operator const char*(){
	if (!buffer) return "";

	terminate();
		
	return buffer;
}

TextBuffer& TextBuffer::operator+(const char* str){
	separate();
	concat(str);

	return *this;
}
TextBuffer& TextBuffer::operator+=(const char* str){
	addQuotedString(str);

	return *this;
}
void TextBuffer::addQuotedString(const char* str,char quote){
	separate();

	concat(quote);
	concatQuotedString(str);
	concat(quote);
}
