#include "../../kraysdk/kray.h"
#include "../../kraysdk/staticlink.h"
#include "../../kraysdk/wrappers/c.h"
#include "../../kraysdk/proto/base.h"
#include "../../kraysdk/proto/direct.h"

using namespace Kray;

KRAYC(KrayInstanceHandle) KrayLibraryCreateInstanceWithEventHandler(KrayEventHandler handler,void* userData){
	return getLibrary().createInstanceWithHandler((EventHandler)handler,userData);
}
KRAYC(KrayInstanceHandle) KrayLibraryCreateInstance(){
	return getLibrary().createInstance();
}
KRAYC(void) KrayLibraryReleaseInstance(KrayInstanceHandle instance){
	getLibrary().releaseInstance((Instance*)instance);

	if (!getLibrary().hasInstances()){
		getLibrary().release();
	}
}

KRAYC(int) KrayLibraryLoad(const char* libraryDir){
	return getLibrary().load(libraryDir);
}
KRAYC(int) KrayInstanceParse(KrayInstanceHandle instance,const char* krayScript,const char* optionalKrayScriptName){
	return ((Instance*)instance)->parse(krayScript,optionalKrayScriptName);
}

/////////////////////////////////////////////////////////////////

KRAYC(void) KrayInstanceSendBackEvent(KrayEventData* eventData){
	((Instance*)(eventData->instance))->sendBackEvent(*(EventData*)eventData);
}
KRAYC(KrayHandle) KrayInstanceGetObjectByName(KrayInstanceHandle instance,const char* name,KrayHandleType type){
	return ((Instance*)instance)->getObjectByName(name,type);
}
KRAYC(void) KrayInstanceGetSymbolValue(KrayInstanceHandle instance,KrayDtHandle symbolHandle,KrayParserExchangeBuffer* data){
	Instance* i=(Instance*)instance;

	i->vtableParser()->getValue(i->getDefaultParser(),symbolHandle,data);
}
KRAYC(const char*) KrayInstanceGetStringSymbolValue(KrayInstanceHandle instance,KrayDtHandle symbolHandle){
	KrayParserExchangeBuffer data;
	data.dtType=KrayDtStringType;

	KrayInstanceGetSymbolValue(instance,symbolHandle,&data);

	return data.u.string.string;
}

KRAYC(KrayProtoHandle) KrayCreateDirectProto(KrayInstanceHandle instance){
	if (!instance) return 0;

	return new DirectPrototyper((Instance*)instance);
}
KRAYC(void) KrayReleaseProto(KrayProtoHandle handle){
	delete (ProtoBase*)handle;
}