unit  kray3commons;


interface
  type
    int    = longint;   // todo: zawsze 32
    uint   = longword;  // todo: zawsze 32
    size_t = PtrUInt;  // todo: rozmiar pointera


  const
    KrayLibInitFunctionString = 'kray3_init';
    KrayLibCoreName           = 'kray3';  // base and core can have the same name, since core uses CPU subtype suffixes
    KrayLibBaseName           = 'kray3';



  const
    KRAY_API_VERSION = 2000;



  const
    KRAY_ASYNC_PARSE_ON       =  1;
    KRAY_ASYNC_PARSE_OFF      =  0;
    KRAY_ASYNC_PARSE_WAIT     = -1;
    KRAY_ASYNC_PARSE_FORGET   = -2;
    KRAY_ASYNC_PARSE_SET_SIZE = -3;
    KRAY_ASYNC_PARSE_PAUSE    = -4;



  const
    KRAY_ADD_FLAG_NEEDUV      = $02;  // do we use UV mapping on this polygon?
    KRAY_ADD_FLAG_SMOOTHING   = $04;  // shading normals needs to be computed
    KRAY_ADD_FLAG_DISPLACE    = $08;  // displace vectors needs to be computed
    KRAY_ADD_FLAG_INVISIBLE   = $10;  // do not add geometry to scene (but add LEM if used)
    KRAY_ADD_FLAG_DOUBLESIDED = $20;  // do we want double sided polygon?



  const
    KRAY_ADD_FLAG_RECTANGLE_LEMS   = $01000;  // find quad that makes a rectangle and add rectangle to the scene (useful for rectangle area lights)
    KRAY_ADD_FLAG_USE_SURFACE_MAP  = $02000;  // use special surface/blend/clipmap switch (fast surface replace)
    KRAY_ADD_FLAG_INSTANCE         = $08000;  // set if your object will be instanced
    KRAY_ADD_FLAG_EXPAND_MB_STATIC = $10000;  // use rendered faster but less mem friendly motion blur handeling of meshes
    KRAY_ADD_FLAG_COMPRESS_NORMALS = $20000;  // use preprocessed, slower, but more mem friendly normals storage
    KRAY_ADD_FLAG_NO_MB            = $40000;  // do not use motion blur
    KRAY_ADD_FLAG_FLIP_NORMALSIDE  = $80000;  // change polygon facing to opposite



  const
    KRAY_NEEDBUFFER_BIT_RGB   =  0;
    KRAY_NEEDBUFFER_BIT_ALPH  =  1;  // alpha channel
    KRAY_NEEDBUFFER_BIT_TXTR  =  2;  // texure
    KRAY_NEEDBUFFER_BIT_ZBUF  =  3;  // z buffer
    KRAY_NEEDBUFFER_BIT_DIRE  =  4;  // direct light
    KRAY_NEEDBUFFER_BIT_SHDN  =  5;  // shadow density
    KRAY_NEEDBUFFER_BIT_INDI  =  6;  // indirect illumination
    KRAY_NEEDBUFFER_BIT_CAUS  =  8;  // caustics
    KRAY_NEEDBUFFER_BIT_REFL  = 10;  // reflection
    KRAY_NEEDBUFFER_BIT_REFR  = 12;  // refraction
    KRAY_NEEDBUFFER_BIT_LUMI  = 14;  // luminosity
    KRAY_NEEDBUFFER_BIT_OTHR  = 16;  // other
    KRAY_NEEDBUFFER_BIT_SFID  = 18;  // surface id
    KRAY_NEEDBUFFER_BIT_OBID  = 20;  // object id
    KRAY_NEEDBUFFER_BIT_NORM  = 22;  // normal map



  // TODO: wrap those below to Kray namespace

  type
    TKrayHandle            = pointer;

    TKraySurfaceHandle     = pointer;
    TKrayBlendHandle       = pointer;
    TKrayMaterialHandle    = pointer;
    TKrayVertexMapHandle   = pointer;
    TKrayTextureHandle     = pointer;
    TKrayBitmapHandle      = pointer;
    TKrayMeshHandle        = pointer;
    TKrayObjectGroupHandle = pointer;

    TKrayInstanceHandle    = pointer;

    TKrayObject            = pointer;



  type
    TKrayHandleType = (
                         kraySurfaceType,
                         krayBlendType,
                         krayMaterialType,
                         krayVertexMapType,
                         krayTextureType,
                         krayBitmapType,
                         krayMeshType,
                         krayObjectGroupType,
                         krayDtType,
                         kraySymbolType
                      );



implementation


  end.
