program kray3test;
uses
  kray3loader;

var
  krayInstance: KrayInstanceHandle;

begin
  if KrayLibraryLoad('./')=true then  { multiple load attempts with different dir paths allowed }
     writeln('### Kray library found in current directory');

  krayInstance:=KrayLibraryCreateInstance();

  if krayInstance <> Pointer(0) then
  begin
    writeln('### Kray instance created');
    KrayInstanceParse(krayInstance,'about;');                           {say hello}

    KrayInstanceParse(krayInstance,'surface s,default;blend b,total;'); {surface and blend for low level geometry}

    KrayInstanceParse(krayInstance,'objectadd sphere,(0,0,2),1,s,b;');   {head}

    KrayInstanceParse(krayInstance,'objectadd sphere,(-0.7,-0.7,2),0.5,s,b;'); {ears}
    KrayInstanceParse(krayInstance,'objectadd sphere,(0.7,-0.7,2),0.5,s,b;');

    KrayInstanceParse(krayInstance,'objectadd sphere,(-0.2,-0.3,1.1),0.08,s,b;'); {eyes}
    KrayInstanceParse(krayInstance,'objectadd sphere,(0.2,-0.3,1.1),0.08,s,b;');

    KrayInstanceParse(krayInstance,'objectadd sphere,(0,0,1.05),0.1,s,b;'); {nose}

    KrayInstanceParse(krayInstance,'objectadd ellipsoid,(0,0.3,1.1)@<>*(0.3,0.1,0.1),s,b;'); {mouth}

    KrayInstanceParse(krayInstance,'lightadd point,(-2,-1,0),(1,1,1);');   { single light source}
    KrayInstanceParse(krayInstance,'background sky;');                     { background }
    KrayInstanceParse(krayInstance,'pv flayer;');
    KrayInstanceParse(krayInstance,'echo "*** Type ''exit;'' to end interactive mode";');
    KrayInstanceParse(krayInstance,'interactive;');

    KrayLibraryReleaseInstance(krayInstance);
  end
  else
  begin
      writeln('##! Failed to create Kray instance');
  end;

  writeln('### Press Enter to continue...');
  readln();
end.

