#ifndef KRAY_COMMANDS_PROTOS_DECLARE_H
#define KRAY_COMMANDS_PROTOS_DECLARE_H

/*
 Kray script prototypes header
  generated from Kray
  use
   kray -c "commandsprotos 2,56,'kprotos.h';"
  to regenerate
*/

#include "kprotosinc.h"
#include "kprotosexp.h"

using namespace Kray;

KRAYCEXPORT(void) about0(KrayProtoHandle kph);
KRAYCEXPORT(void) about1u(KrayProtoHandle kph,const wchar_t* moduleName);
KRAYCEXPORT(void) about1(KrayProtoHandle kph,const char* moduleName);
KRAYCEXPORT(void) anim0_renderFrame(KrayProtoHandle kph);
KRAYCEXPORT(void) anim1_renderFrame(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) anim0_reset(KrayProtoHandle kph);
KRAYCEXPORT(void) anim1_setFps(KrayProtoHandle kph,double fps);
KRAYCEXPORT(void) anim0_setupFrame(KrayProtoHandle kph);
KRAYCEXPORT(void) anim1_setupFrame(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) animOb3u_addAxesKey(KrayProtoHandle kph,const wchar_t* s1,double time,const Axes& axes);
KRAYCEXPORT(void) animOb3_addAxesKey(KrayProtoHandle kph,const char* s1,double time,const Axes& axes);
KRAYCEXPORT(void) animOb4u_addChannelKey(KrayProtoHandle kph,const wchar_t* s1,double time,int channel,double value);
KRAYCEXPORT(void) animOb4_addChannelKey(KrayProtoHandle kph,const char* s1,double time,int channel,double value);
KRAYCEXPORT(void) animOb2u_addInstanceTransformer_copyAxes(KrayProtoHandle kph,const wchar_t* s1,const wchar_t* s4);
KRAYCEXPORT(void) animOb2_addInstanceTransformer_copyAxes(KrayProtoHandle kph,const char* s1,const char* s4);
KRAYCEXPORT(void) animOb2u_addInstanceTransformer_copyRevAxes(KrayProtoHandle kph,const wchar_t* s1,const wchar_t* s4);
KRAYCEXPORT(void) animOb2_addInstanceTransformer_copyRevAxes(KrayProtoHandle kph,const char* s1,const char* s4);
KRAYCEXPORT(void) animOb1u_addInstanceTransformer_localAxes(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_addInstanceTransformer_localAxes(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb2u_addInstanceTransformer_normalFixedRotate(KrayProtoHandle kph,const wchar_t* s1,const Vector& direction);
KRAYCEXPORT(void) animOb2_addInstanceTransformer_normalFixedRotate(KrayProtoHandle kph,const char* s1,const Vector& direction);
KRAYCEXPORT(void) animOb1u_addInstanceTransformer_normalRandomRotate(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_addInstanceTransformer_normalRandomRotate(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb1u_addInstanceTransformer_normalRotate(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_addInstanceTransformer_normalRotate(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb1u_addInstanceTransformer_patternAxes(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_addInstanceTransformer_patternAxes(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb2u_addInstanceTransformer_randomSeed(KrayProtoHandle kph,const wchar_t* s1,int seed);
KRAYCEXPORT(void) animOb2_addInstanceTransformer_randomSeed(KrayProtoHandle kph,const char* s1,int seed);
KRAYCEXPORT(void) animOb4u_addInstanceTransformer_randRotate(KrayProtoHandle kph,const wchar_t* s1,double rand_min,double rand_max,const Vector& rotate_plane_vector);
KRAYCEXPORT(void) animOb4_addInstanceTransformer_randRotate(KrayProtoHandle kph,const char* s1,double rand_min,double rand_max,const Vector& rotate_plane_vector);
KRAYCEXPORT(void) animOb3u_addInstanceTransformer_randScale(KrayProtoHandle kph,const wchar_t* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb3_addInstanceTransformer_randScale(KrayProtoHandle kph,const char* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb3u_addInstanceTransformer_randScaleX(KrayProtoHandle kph,const wchar_t* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb3_addInstanceTransformer_randScaleX(KrayProtoHandle kph,const char* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb3u_addInstanceTransformer_randScaleY(KrayProtoHandle kph,const wchar_t* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb3_addInstanceTransformer_randScaleY(KrayProtoHandle kph,const char* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb3u_addInstanceTransformer_randScaleZ(KrayProtoHandle kph,const wchar_t* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb3_addInstanceTransformer_randScaleZ(KrayProtoHandle kph,const char* s1,double rand_min,double rand_max);
KRAYCEXPORT(void) animOb1u_addInstanceTransformer_worldAxes(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_addInstanceTransformer_worldAxes(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb3u_addKey(KrayProtoHandle kph,const wchar_t* s1,double time,const CoordSys& axes);
KRAYCEXPORT(void) animOb3_addKey(KrayProtoHandle kph,const char* s1,double time,const CoordSys& axes);
KRAYCEXPORT(void) animOb3u_addPositionKey(KrayProtoHandle kph,const wchar_t* s1,double time,const Vector& position);
KRAYCEXPORT(void) animOb3_addPositionKey(KrayProtoHandle kph,const char* s1,double time,const Vector& position);
KRAYCEXPORT(void) animOb1u_clearInstanceTransformers(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_clearInstanceTransformers(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb1u_clearKeys(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_clearKeys(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb1u_invalidateGeometry(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_invalidateGeometry(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb1u_invalidateSurfaces(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_invalidateSurfaces(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb1u_remove(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_remove(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb2u_rename(KrayProtoHandle kph,const wchar_t* s1,const wchar_t* name);
KRAYCEXPORT(void) animOb2_rename(KrayProtoHandle kph,const char* s1,const char* name);
KRAYCEXPORT(void) animOb2u_setActive(KrayProtoHandle kph,const wchar_t* s1,bool state);
KRAYCEXPORT(void) animOb2_setActive(KrayProtoHandle kph,const char* s1,bool state);
KRAYCEXPORT(void) animOb2u_setMeshHandnessAutoFlip(KrayProtoHandle kph,const wchar_t* s1,bool state);
KRAYCEXPORT(void) animOb2_setMeshHandnessAutoFlip(KrayProtoHandle kph,const char* s1,bool state);
KRAYCEXPORT(void) animOb1u_setParent(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_setParent(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb2u_setParent(KrayProtoHandle kph,const wchar_t* s1,const wchar_t* s3);
KRAYCEXPORT(void) animOb2_setParent(KrayProtoHandle kph,const char* s1,const char* s3);
KRAYCEXPORT(void) animOb2u_setStatic(KrayProtoHandle kph,const wchar_t* s1,const CoordSys& axes);
KRAYCEXPORT(void) animOb2_setStatic(KrayProtoHandle kph,const char* s1,const CoordSys& axes);
KRAYCEXPORT(void) animOb1u_showInfo(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_showInfo(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb1u_showKeys(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_showKeys(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animOb2u_typeBackground(KrayProtoHandle kph,const wchar_t* s1,const Symbol& s3);
KRAYCEXPORT(void) animOb2_typeBackground(KrayProtoHandle kph,const char* s1,const Symbol& s3);
KRAYCEXPORT(void) animOb3u_typeBackground(KrayProtoHandle kph,const wchar_t* s1,const Symbol& s3,int flags);
KRAYCEXPORT(void) animOb3_typeBackground(KrayProtoHandle kph,const char* s1,const Symbol& s3,int flags);
KRAYCEXPORT(void) animOb2u_typeCopy(KrayProtoHandle kph,const wchar_t* s1,const wchar_t* s3);
KRAYCEXPORT(void) animOb2_typeCopy(KrayProtoHandle kph,const char* s1,const char* s3);
KRAYCEXPORT(void) animOb2u_typeCopyTree(KrayProtoHandle kph,const wchar_t* s1,const wchar_t* s3);
KRAYCEXPORT(void) animOb2_typeCopyTree(KrayProtoHandle kph,const char* s1,const char* s3);
KRAYCEXPORT(void) animOb2u_typeInstance(KrayProtoHandle kph,const wchar_t* s1,const wchar_t* objectNodeName);
KRAYCEXPORT(void) animOb2_typeInstance(KrayProtoHandle kph,const char* s1,const char* objectNodeName);
KRAYCEXPORT(void) animOb2u_typeMesh(KrayProtoHandle kph,const wchar_t* s1,const MeshSymbol& m3);
KRAYCEXPORT(void) animOb2_typeMesh(KrayProtoHandle kph,const char* s1,const MeshSymbol& m3);
KRAYCEXPORT(void) animOb3u_typeMesh(KrayProtoHandle kph,const wchar_t* s1,const MeshSymbol& m3,int flags);
KRAYCEXPORT(void) animOb3_typeMesh(KrayProtoHandle kph,const char* s1,const MeshSymbol& m3,int flags);
KRAYCEXPORT(void) animOb2u_typeMeshInstance(KrayProtoHandle kph,const wchar_t* s1,const MeshSymbol& m3);
KRAYCEXPORT(void) animOb2_typeMeshInstance(KrayProtoHandle kph,const char* s1,const MeshSymbol& m3);
KRAYCEXPORT(void) animOb3u_typeMeshInstance(KrayProtoHandle kph,const wchar_t* s1,const MeshSymbol& m3,int flags);
KRAYCEXPORT(void) animOb3_typeMeshInstance(KrayProtoHandle kph,const char* s1,const MeshSymbol& m3,int flags);
KRAYCEXPORT(void) animOb1u_typeNull(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) animOb1_typeNull(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) animObLink1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) animObLink2u(KrayProtoHandle kph,Symbol& s1,const wchar_t* animObName);
KRAYCEXPORT(void) animObLink2(KrayProtoHandle kph,Symbol& s1,const char* animObName);
KRAYCEXPORT(void) axes1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) axes2(KrayProtoHandle kph,Symbol& s1,const Axes& a2);
KRAYCEXPORT(void) background1_color(KrayProtoHandle kph,const Vector& color);
KRAYCEXPORT(void) background0_directionsMap(KrayProtoHandle kph);
KRAYCEXPORT(void) background2_fishEyeMap(KrayProtoHandle kph,const BitmapSymbol& b2,const Axes& a3);
KRAYCEXPORT(void) background1_phySky(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) background2_phySky(KrayProtoHandle kph,const Symbol& s2,double alphaChannelValue);
KRAYCEXPORT(void) background3_phySky(KrayProtoHandle kph,const Symbol& s2,double alphaChannelValue,int envFlags);
KRAYCEXPORT(void) background1_phySkyEnv(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) background2_phySkyEnv(KrayProtoHandle kph,const Symbol& s2,double alphaChannelValue);
KRAYCEXPORT(void) background3_phySkyEnv(KrayProtoHandle kph,const Symbol& s2,double alphaChannelValue,int envFlags);
KRAYCEXPORT(void) background1_shader(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) background0_sky(KrayProtoHandle kph);
KRAYCEXPORT(void) background1_sky(KrayProtoHandle kph,const Vector& zenithDirection);
KRAYCEXPORT(void) background4_sky(KrayProtoHandle kph,const Vector& zenithDirection,const Vector& horizon,const Vector& zenith,const Vector& nadir);
KRAYCEXPORT(void) background5_sky(KrayProtoHandle kph,const Vector& zenithDirection,const Vector& horizon,const Vector& zenith,const Vector& nadir,const Vector& horizonNadir);
KRAYCEXPORT(void) background7_sky(KrayProtoHandle kph,const Vector& zenithDirection,const Vector& horizon,const Vector& zenith,const Vector& nadir,const Vector& horizonNadir,double skyGamma,double groundGamma);
KRAYCEXPORT(void) background2_sphereMap(KrayProtoHandle kph,const BitmapSymbol& b2,const Axes& a3);
KRAYCEXPORT(void) bitmap1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap2_alphaMap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) bitmap4_alphaMap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3,double alphaRangeStart,double alphaRangeStop);
KRAYCEXPORT(void) bitmap1_bitPlane(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap2_bitPlane(KrayProtoHandle kph,Symbol& s1,const Vector& bmpSize);
KRAYCEXPORT(void) bitmap2_bumpMap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) bitmap1_charGray(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap2_charGray(KrayProtoHandle kph,Symbol& s1,const Vector& bmpSize);
KRAYCEXPORT(void) bitmap1_charRgba(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap2_charRgba(KrayProtoHandle kph,Symbol& s1,const Vector& bmpSize);
KRAYCEXPORT(void) bitmap2_compress(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) bitmap6_compress(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3,int hdr,int color,int alpha,int halfSizeSteps);
KRAYCEXPORT(void) bitmap2_copy(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) bitmap1_copyView(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_alph(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_caus(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_dire(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_indi(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_lumi(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_norm(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_obid(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_othr(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_posi(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_preview(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_refl(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_refr(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_rgb(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_rgba(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_sfid(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_shdn(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_txtr(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_copyView_zbuf(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap1_floatGray(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap2_floatGray(KrayProtoHandle kph,Symbol& s1,const Vector& bmpSize);
KRAYCEXPORT(void) bitmap1_floatRgb(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap2_floatRgb(KrayProtoHandle kph,Symbol& s1,const Vector& bmpSize);
KRAYCEXPORT(void) bitmap1_floatRgba(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) bitmap2_floatRgba(KrayProtoHandle kph,Symbol& s1,const Vector& bmpSize);
KRAYCEXPORT(void) bitmap2u_load(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) bitmap2_load(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) bitmap3u_load(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,double time);
KRAYCEXPORT(void) bitmap3_load(KrayProtoHandle kph,Symbol& s1,const char* filename,double time);
KRAYCEXPORT(void) bitmapData3(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& startPoint,const VarLenVector& v3);
KRAYCEXPORT(void) bitmapOp2_blit(KrayProtoHandle kph,const BitmapSymbol& b1,const BitmapSymbol& source);
KRAYCEXPORT(void) bitmapOp3_blit(KrayProtoHandle kph,const BitmapSymbol& b1,const BitmapSymbol& source,const Vector& location);
KRAYCEXPORT(void) bitmapOp4_blit(KrayProtoHandle kph,const BitmapSymbol& b1,const BitmapSymbol& source,const Vector& location,const Vector& sourceLocation);
KRAYCEXPORT(void) bitmapOp5_blit(KrayProtoHandle kph,const BitmapSymbol& b1,const BitmapSymbol& source,const Vector& location,const Vector& sourceLocation,const Vector& size);
KRAYCEXPORT(void) bitmapOp4_circle(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& center,double radius,const Vector& v5);
KRAYCEXPORT(void) bitmapOp1_clear(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp2_clear(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& c);
KRAYCEXPORT(void) bitmapOp2_copy(KrayProtoHandle kph,const BitmapSymbol& b1,const BitmapSymbol& source);
KRAYCEXPORT(void) bitmapOp1_copyView(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_alph(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_caus(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_dire(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_indi(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_lumi(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_norm(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_obid(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_othr(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_posi(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_preview(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_refl(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_refr(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_rgb(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_rgba(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_sfid(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_shdn(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_txtr(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_copyView_zbuf(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp3_fill(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& p,const Vector& v4);
KRAYCEXPORT(void) bitmapOp4_fill(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& p,const Vector& v4,double tolerance);
KRAYCEXPORT(void) bitmapOp1_flush(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp4_line(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& p1,const Vector& p2,const Vector& v5);
KRAYCEXPORT(void) bitmapOp2u_load(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* name);
KRAYCEXPORT(void) bitmapOp2_load(KrayProtoHandle kph,const BitmapSymbol& b1,const char* name);
KRAYCEXPORT(void) bitmapOp3u_loadRaw(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) bitmapOp3_loadRaw(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,int flags);
KRAYCEXPORT(void) bitmapOp3_plot(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& point,const Vector& v4);
KRAYCEXPORT(void) bitmapOp2_process(KrayProtoHandle kph,const BitmapSymbol& b1,const Symbol& s3);
KRAYCEXPORT(void) bitmapOp2_resize(KrayProtoHandle kph,const BitmapSymbol& b1,const Vector& newSize);
KRAYCEXPORT(void) bitmapOp2u_save(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp2u_save_bmp(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save_bmp(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp3u_save_bmp(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) bitmapOp3_save_bmp(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,int flags);
KRAYCEXPORT(void) bitmapOp2u_save_exr(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save_exr(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp2u_save_hdr(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save_hdr(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp2u_save_jpg(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save_jpg(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp3u_save_jpg(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,double quality);
KRAYCEXPORT(void) bitmapOp3_save_jpg(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,double quality);
KRAYCEXPORT(void) bitmapOp2u_save_png(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save_png(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp3u_save_png(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) bitmapOp3_save_png(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,int flags);
KRAYCEXPORT(void) bitmapOp2u_save_tga(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save_tga(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp3u_save_tga(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) bitmapOp3_save_tga(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,int flags);
KRAYCEXPORT(void) bitmapOp2u_save_tif(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_save_tif(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp3u_save_tif(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) bitmapOp3_save_tif(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,int flags);
KRAYCEXPORT(void) bitmapOp3u_saveRaw(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) bitmapOp3_saveRaw(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,int flags);
KRAYCEXPORT(void) bitmapOp2u_saveScript(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename);
KRAYCEXPORT(void) bitmapOp2_saveScript(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename);
KRAYCEXPORT(void) bitmapOp3u_saveScript(KrayProtoHandle kph,const BitmapSymbol& b1,const wchar_t* filename,const wchar_t* bmpVariableName);
KRAYCEXPORT(void) bitmapOp3_saveScript(KrayProtoHandle kph,const BitmapSymbol& b1,const char* filename,const char* bmpVariableName);
KRAYCEXPORT(void) bitmapOp1_show(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_showAlpha(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp2_showAlpha(KrayProtoHandle kph,const BitmapSymbol& b1,int mode);
KRAYCEXPORT(void) bitmapOp1_showDirections(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp1_showHit(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) bitmapOp2_showHit(KrayProtoHandle kph,const BitmapSymbol& b1,int mode);
KRAYCEXPORT(void) bitmapOp1_showZ(KrayProtoHandle kph,const BitmapSymbol& b1);
KRAYCEXPORT(void) blend1_default(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) blend2_fromShader(KrayProtoHandle kph,Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) blend1_none(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) blend2_partial(KrayProtoHandle kph,Symbol& s1,const Vector& v3);
KRAYCEXPORT(void) blend3_partial(KrayProtoHandle kph,Symbol& s1,const Vector& v3,int surfaceUsesMapsFlags);
KRAYCEXPORT(void) blend2_superficial(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) blend3_superficial(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int surfaceUsesMapsFlags);
KRAYCEXPORT(void) blend1_total(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) camera2_castMaps(KrayProtoHandle kph,const CoordSys& c2,const BitmapSymbol& directionsMap);
KRAYCEXPORT(void) camera3_castMaps(KrayProtoHandle kph,const CoordSys& c2,const BitmapSymbol& directionsMap,const BitmapSymbol& positionsMap);
KRAYCEXPORT(void) camera4_castMaps(KrayProtoHandle kph,const CoordSys& c2,const BitmapSymbol& directionsMap,const BitmapSymbol& positionsMap,const BitmapSymbol& weightsMap);
KRAYCEXPORT(void) camera2_fishEye(KrayProtoHandle kph,const Vector& imageSize,const CoordSys& c3);
KRAYCEXPORT(void) camera5_lens1(KrayProtoHandle kph,const Vector& imageSize,double focalDistance,double dofDistance,double dofStrength,const CoordSys& c6);
KRAYCEXPORT(void) camera6_lens2(KrayProtoHandle kph,const Vector& imageSize,double focalDistance,double dofDistance,double dofStrength,const CoordSys& c6,const BitmapSymbol& bokehImage);
KRAYCEXPORT(void) camera4u_mesh(KrayProtoHandle kph,const MeshSymbol& m2,const wchar_t* bakerUvName,const Vector& imageSize,const CoordSys& c5);
KRAYCEXPORT(void) camera4_mesh(KrayProtoHandle kph,const MeshSymbol& m2,const char* bakerUvName,const Vector& imageSize,const CoordSys& c5);
KRAYCEXPORT(void) camera1_move(KrayProtoHandle kph,const CoordSys& c2);
KRAYCEXPORT(void) camera3_parallel(KrayProtoHandle kph,const Vector& imageSize,double focalDistance,const CoordSys& c4);
KRAYCEXPORT(void) camera6_parallelExt(KrayProtoHandle kph,const Vector& imageSize,double planeSize,const Vector& pos,const Vector& axisX,const Vector& axisY,const Vector& axisZ);
KRAYCEXPORT(void) camera3_perspective(KrayProtoHandle kph,const Vector& imageSize,double focalDistance,const CoordSys& c4);
KRAYCEXPORT(void) camera3_picture(KrayProtoHandle kph,const Vector& imageSize,double focalDistance,const CoordSys& c4);
KRAYCEXPORT(void) camera1_rotate(KrayProtoHandle kph,const Axes& ori);
KRAYCEXPORT(void) camera1_shift(KrayProtoHandle kph,const Vector& pos);
KRAYCEXPORT(void) camera2_sphere(KrayProtoHandle kph,const Vector& imageSize,const CoordSys& c3);
KRAYCEXPORT(void) camera5_stereo(KrayProtoHandle kph,const Vector& imageSize,double focalDistance,const CoordSys& c4,double eyeSeparation,int stripes);
KRAYCEXPORT(void) classObject1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) clear1(KrayProtoHandle kph,const Symbol& c1);
KRAYCEXPORT(void) color1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) color2(KrayProtoHandle kph,Symbol& s1,const Vector& v2);
KRAYCEXPORT(void) commandsProtos0(KrayProtoHandle kph);
KRAYCEXPORT(void) commandsProtos1(KrayProtoHandle kph,int mode);
KRAYCEXPORT(void) commandsProtos2(KrayProtoHandle kph,int mode,int flags);
KRAYCEXPORT(void) commandsProtos3u(KrayProtoHandle kph,int mode,int flags,const wchar_t* filename);
KRAYCEXPORT(void) commandsProtos3(KrayProtoHandle kph,int mode,int flags,const char* filename);
KRAYCEXPORT(void) coordSys1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) coordSys2(KrayProtoHandle kph,Symbol& s1,const CoordSys& c2);
KRAYCEXPORT(void) delete1(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) displaceMap1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) displaceMap2(KrayProtoHandle kph,Symbol& s1,const Vector& size);
KRAYCEXPORT(void) double1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) double2(KrayProtoHandle kph,Symbol& s1,double d2);
KRAYCEXPORT(void) echo0(KrayProtoHandle kph);
KRAYCEXPORT(void) echo1u(KrayProtoHandle kph,const wchar_t* s1);
KRAYCEXPORT(void) echo1(KrayProtoHandle kph,const char* s1);
KRAYCEXPORT(void) end0(KrayProtoHandle kph);
KRAYCEXPORT(void) environment1_colorFade(KrayProtoHandle kph,const Vector& exponentialFilter);
KRAYCEXPORT(void) environment2_phySky(KrayProtoHandle kph,const Symbol& s2,int flags);
KRAYCEXPORT(void) environment1_shader(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) exit0(KrayProtoHandle kph);
KRAYCEXPORT(void) fg2_gradients(KrayProtoHandle kph,double gradientMaxDistance,double irr_spatial_dens);
KRAYCEXPORT(void) fg2_gradients2(KrayProtoHandle kph,double gradientMinDistance,double irr_brightdens);
KRAYCEXPORT(void) fg2_gradients3(KrayProtoHandle kph,double irr_min_weight,double irr_angle_dens);
KRAYCEXPORT(void) fg2_gradients4(KrayProtoHandle kph,double gradientBackgroundHitDistance,double irr_normal_dist);
KRAYCEXPORT(void) fg1_gradientsFlags(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) fg1_gradientsNeighbour(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) fg1_gradReload(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) fg1_gradSidethreshold(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) fg1_irradianceBlur(KrayProtoHandle kph,double online);
KRAYCEXPORT(void) fg2_irradianceBlur(KrayProtoHandle kph,double online,double offline);
KRAYCEXPORT(void) fg1_irradianceBlurGamma(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) fg1_irrMissingBlur(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) fg1u_load(KrayProtoHandle kph,const wchar_t* gis_filename);
KRAYCEXPORT(void) fg1_load(KrayProtoHandle kph,const char* gis_filename);
KRAYCEXPORT(void) fg5_pixels(KrayProtoHandle kph,double pixel_multiplier,double aa_multiplier,int aa_multiplies,double box_pixels_scale,double max_aniso);
KRAYCEXPORT(void) fg2_pmCorner(KrayProtoHandle kph,double pmCornerDistance,int finalGatherCornerSamples);
KRAYCEXPORT(void) fg1_prerender(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) fg3_prerender(KrayProtoHandle kph,double d2,int d3,double d4);
KRAYCEXPORT(void) fg0_presample(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1_presample(KrayProtoHandle kph,double powerMax);
KRAYCEXPORT(void) fg2_presample(KrayProtoHandle kph,double powerMax,double dynamicMax);
KRAYCEXPORT(void) fg3_presample(KrayProtoHandle kph,double powerMax,double dynamicMax,int minGridSize);
KRAYCEXPORT(void) fg0_rays(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1_rays(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) fg2_rays(KrayProtoHandle kph,int minSamples,int maxSamples);
KRAYCEXPORT(void) fg3_rays(KrayProtoHandle kph,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) fg1_raysNMultiplier(KrayProtoHandle kph,int globalRayAvgN);
KRAYCEXPORT(void) fg0_raysPresampled(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1_raysPresampled(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) fg2_raysPresampled(KrayProtoHandle kph,int minSamples,int maxSamples);
KRAYCEXPORT(void) fg3_raysPresampled(KrayProtoHandle kph,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) fg0_render(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1_render(KrayProtoHandle kph,bool fgOnly);
KRAYCEXPORT(void) fg0_reset(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1u_save(KrayProtoHandle kph,const wchar_t* gis_filename);
KRAYCEXPORT(void) fg1_save(KrayProtoHandle kph,const char* gis_filename);
KRAYCEXPORT(void) fg2u_save(KrayProtoHandle kph,const wchar_t* gis_filename,int flags);
KRAYCEXPORT(void) fg2_save(KrayProtoHandle kph,const char* gis_filename,int flags);
KRAYCEXPORT(void) fg0_scale(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1_scale(KrayProtoHandle kph,double scaleFactor);
KRAYCEXPORT(void) fg0_scaleRelativeToGlobalPm(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1_scaleRelativeToGlobalPm(KrayProtoHandle kph,double scaleFactor);
KRAYCEXPORT(void) fg0_scaleRelativeToPrecachedPm(KrayProtoHandle kph);
KRAYCEXPORT(void) fg1_scaleRelativeToPrecachedPm(KrayProtoHandle kph,double scaleFactor);
KRAYCEXPORT(void) fg1_showCornerSamples(KrayProtoHandle kph,bool showFinalGatherCornerSamples);
KRAYCEXPORT(void) fg2_showCornerSamples(KrayProtoHandle kph,bool showFinalGatherCornerSamples,const Vector& finalGatherSampleColor);
KRAYCEXPORT(void) fg1_showSamples(KrayProtoHandle kph,bool showFinalGatherSamples);
KRAYCEXPORT(void) fg2_showSamples(KrayProtoHandle kph,bool showFinalGatherSamples,const Vector& finalGatherSampleColor);
KRAYCEXPORT(void) fg1_timeGradients(KrayProtoHandle kph,double ca0);
KRAYCEXPORT(void) fg2_timeGradients(KrayProtoHandle kph,double ca0,const VarLenVector& cab1);
KRAYCEXPORT(void) fiberPack1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) fiberPackOp7_addFiber(KrayProtoHandle kph,const Symbol& f1,const Vector& v3,double d4,double d5,const Vector& v6,double d7,double d8);
KRAYCEXPORT(void) fiberPackOp9_addFiber(KrayProtoHandle kph,const Symbol& f1,const Vector& v3,double d4,double d5,const Vector& v6,double d7,double d8,const Vector& v9,double d10);
KRAYCEXPORT(void) fiberPackOp2_bBoxSize(KrayProtoHandle kph,const Symbol& f1,double d3);
KRAYCEXPORT(void) fs2u_appendString(KrayProtoHandle kph,const wchar_t* fileName,const wchar_t* text);
KRAYCEXPORT(void) fs2_appendString(KrayProtoHandle kph,const char* fileName,const char* text);
KRAYCEXPORT(void) fs1u_cat(KrayProtoHandle kph,const wchar_t* fileName);
KRAYCEXPORT(void) fs1_cat(KrayProtoHandle kph,const char* fileName);
KRAYCEXPORT(void) fs2u_copy(KrayProtoHandle kph,const wchar_t* source,const wchar_t* destination);
KRAYCEXPORT(void) fs2_copy(KrayProtoHandle kph,const char* source,const char* destination);
KRAYCEXPORT(void) fs1u_hexCat(KrayProtoHandle kph,const wchar_t* fileName);
KRAYCEXPORT(void) fs1_hexCat(KrayProtoHandle kph,const char* fileName);
KRAYCEXPORT(void) fs2u_hexCat(KrayProtoHandle kph,const wchar_t* fileName,size_t rowSize);
KRAYCEXPORT(void) fs2_hexCat(KrayProtoHandle kph,const char* fileName,size_t rowSize);
KRAYCEXPORT(void) fs0_list(KrayProtoHandle kph);
KRAYCEXPORT(void) fs1u_list(KrayProtoHandle kph,const wchar_t* dir);
KRAYCEXPORT(void) fs1_list(KrayProtoHandle kph,const char* dir);
KRAYCEXPORT(void) fs1u_openUrl(KrayProtoHandle kph,const wchar_t* url);
KRAYCEXPORT(void) fs1_openUrl(KrayProtoHandle kph,const char* url);
KRAYCEXPORT(void) fs1u_pathAdd(KrayProtoHandle kph,const wchar_t* path);
KRAYCEXPORT(void) fs1_pathAdd(KrayProtoHandle kph,const char* path);
KRAYCEXPORT(void) fs1u_pathRemove(KrayProtoHandle kph,const wchar_t* path);
KRAYCEXPORT(void) fs1_pathRemove(KrayProtoHandle kph,const char* path);
KRAYCEXPORT(void) fs0_pathShow(KrayProtoHandle kph);
KRAYCEXPORT(void) fs1_pathSkipCurrentDir(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) fs1_pathSlashCut(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) gpGpu1u_addDebug(KrayProtoHandle kph,const wchar_t* engineId);
KRAYCEXPORT(void) gpGpu1_addDebug(KrayProtoHandle kph,const char* engineId);
KRAYCEXPORT(void) gpGpu1u_addInternal(KrayProtoHandle kph,const wchar_t* engineId);
KRAYCEXPORT(void) gpGpu1_addInternal(KrayProtoHandle kph,const char* engineId);
KRAYCEXPORT(void) gpGpu2u_addInternal(KrayProtoHandle kph,const wchar_t* engineId,int cpuThreads);
KRAYCEXPORT(void) gpGpu2_addInternal(KrayProtoHandle kph,const char* engineId,int cpuThreads);
KRAYCEXPORT(void) gpGpu3u_addInternal(KrayProtoHandle kph,const wchar_t* engineId,int cpuThreads,int complementaryThreads);
KRAYCEXPORT(void) gpGpu3_addInternal(KrayProtoHandle kph,const char* engineId,int cpuThreads,int complementaryThreads);
KRAYCEXPORT(void) gpGpu2u_addOpenCl(KrayProtoHandle kph,const wchar_t* engineId,int openClPlatformIndex);
KRAYCEXPORT(void) gpGpu2_addOpenCl(KrayProtoHandle kph,const char* engineId,int openClPlatformIndex);
KRAYCEXPORT(void) gpGpu3u_addOpenCl(KrayProtoHandle kph,const wchar_t* engineId,int openClPlatformIndex,int openClDeviceIndex);
KRAYCEXPORT(void) gpGpu3_addOpenCl(KrayProtoHandle kph,const char* engineId,int openClPlatformIndex,int openClDeviceIndex);
KRAYCEXPORT(void) gpGpu4u_addOpenCl(KrayProtoHandle kph,const wchar_t* engineId,int openClPlatformIndex,int openClDeviceIndex,int flags);
KRAYCEXPORT(void) gpGpu4_addOpenCl(KrayProtoHandle kph,const char* engineId,int openClPlatformIndex,int openClDeviceIndex,int flags);
KRAYCEXPORT(void) gpGpu0_clear(KrayProtoHandle kph);
KRAYCEXPORT(void) gpGpu0_listAvailable(KrayProtoHandle kph);
KRAYCEXPORT(void) gpGpu0_listUsed(KrayProtoHandle kph);
KRAYCEXPORT(void) gpGpu4u_oct_build(KrayProtoHandle kph,const wchar_t* engineId,double separation_threshold,const Vector& dontSplitRatios,const Vector& forceSplitRatios);
KRAYCEXPORT(void) gpGpu4_oct_build(KrayProtoHandle kph,const char* engineId,double separation_threshold,const Vector& dontSplitRatios,const Vector& forceSplitRatios);
KRAYCEXPORT(void) gpGpu1u_oct_explorer(KrayProtoHandle kph,const wchar_t* engineId);
KRAYCEXPORT(void) gpGpu1_oct_explorer(KrayProtoHandle kph,const char* engineId);
KRAYCEXPORT(void) gpGpu2u_oct_explorer(KrayProtoHandle kph,const wchar_t* engineId,const Vector& v4);
KRAYCEXPORT(void) gpGpu2_oct_explorer(KrayProtoHandle kph,const char* engineId,const Vector& v4);
KRAYCEXPORT(void) gpGpu2u_oct_flags(KrayProtoHandle kph,const wchar_t* engineId,int d4);
KRAYCEXPORT(void) gpGpu2_oct_flags(KrayProtoHandle kph,const char* engineId,int d4);
KRAYCEXPORT(void) gpGpu3u_oct_invalidate(KrayProtoHandle kph,const wchar_t* engineId,const Vector& v4,const Vector& v5);
KRAYCEXPORT(void) gpGpu3_oct_invalidate(KrayProtoHandle kph,const char* engineId,const Vector& v4,const Vector& v5);
KRAYCEXPORT(void) gpGpu3u_oct_limits(KrayProtoHandle kph,const wchar_t* engineId,int recurse_max,double min_leaf_weight);
KRAYCEXPORT(void) gpGpu3_oct_limits(KrayProtoHandle kph,const char* engineId,int recurse_max,double min_leaf_weight);
KRAYCEXPORT(void) gpGpu1u_oct_show(KrayProtoHandle kph,const wchar_t* engineId);
KRAYCEXPORT(void) gpGpu1_oct_show(KrayProtoHandle kph,const char* engineId);
KRAYCEXPORT(void) gpGpu2u_oct_show(KrayProtoHandle kph,const wchar_t* engineId,int flags);
KRAYCEXPORT(void) gpGpu2_oct_show(KrayProtoHandle kph,const char* engineId,int flags);
KRAYCEXPORT(void) gpGpu3u_oct_show(KrayProtoHandle kph,const wchar_t* engineId,int flags,int color_level);
KRAYCEXPORT(void) gpGpu3_oct_show(KrayProtoHandle kph,const char* engineId,int flags,int color_level);
KRAYCEXPORT(void) gpGpu1u_oct_stats(KrayProtoHandle kph,const wchar_t* engineId);
KRAYCEXPORT(void) gpGpu1_oct_stats(KrayProtoHandle kph,const char* engineId);
KRAYCEXPORT(void) gpGpu2u_oct_stats(KrayProtoHandle kph,const wchar_t* engineId,int flags);
KRAYCEXPORT(void) gpGpu2_oct_stats(KrayProtoHandle kph,const char* engineId,int flags);
KRAYCEXPORT(void) gpGpu1u_remove(KrayProtoHandle kph,const wchar_t* engineId);
KRAYCEXPORT(void) gpGpu1_remove(KrayProtoHandle kph,const char* engineId);
KRAYCEXPORT(void) gpGpu0_useGpus(KrayProtoHandle kph);
KRAYCEXPORT(void) gpGpu0_useInternal(KrayProtoHandle kph);
KRAYCEXPORT(void) group0_add(KrayProtoHandle kph);
KRAYCEXPORT(void) group0_addInstance(KrayProtoHandle kph);
KRAYCEXPORT(void) group1u_addInstance(KrayProtoHandle kph,const wchar_t* subGroupOfNode);
KRAYCEXPORT(void) group1_addInstance(KrayProtoHandle kph,const char* subGroupOfNode);
KRAYCEXPORT(void) group8u_attachSet_function(KrayProtoHandle kph,const wchar_t* expression,const CoordSys& axes,double sx,double sy,int dx,int dy,const Symbol& s9,const Symbol& b10);
KRAYCEXPORT(void) group8_attachSet_function(KrayProtoHandle kph,const char* expression,const CoordSys& axes,double sx,double sy,int dx,int dy,const Symbol& s9,const Symbol& b10);
KRAYCEXPORT(void) group1_attachSet_mesh(KrayProtoHandle kph,const MeshSymbol& m3);
KRAYCEXPORT(void) group2_attachSet_mesh(KrayProtoHandle kph,const MeshSymbol& m3,const CoordSys& axes);
KRAYCEXPORT(void) group3_attachSet_mesh(KrayProtoHandle kph,const MeshSymbol& m3,const CoordSys& axes,int flags);
KRAYCEXPORT(void) group0_clear(KrayProtoHandle kph);
KRAYCEXPORT(void) group0_remove(KrayProtoHandle kph);
KRAYCEXPORT(void) group1u_remove(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) group1_remove(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) group0_removeAll(KrayProtoHandle kph);
KRAYCEXPORT(void) group0_removeUnused(KrayProtoHandle kph);
KRAYCEXPORT(void) group1_removeUnused(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) group0_select(KrayProtoHandle kph);
KRAYCEXPORT(void) group1u_select(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) group1_select(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) group1u_selectInstance(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) group1_selectInstance(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) group2u_selectInstance(KrayProtoHandle kph,const wchar_t* s2,const wchar_t* subGroupOfNode);
KRAYCEXPORT(void) group2_selectInstance(KrayProtoHandle kph,const char* s2,const char* subGroupOfNode);
KRAYCEXPORT(void) group0_updateMaterials(KrayProtoHandle kph);
KRAYCEXPORT(void) group1_updateMaterials(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) groupLink1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) groupLink1_attachGroup(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) groupLink2u_attachGroup(KrayProtoHandle kph,Symbol& s1,const wchar_t* name);
KRAYCEXPORT(void) groupLink2_attachGroup(KrayProtoHandle kph,Symbol& s1,const char* name);
KRAYCEXPORT(void) groupLink1_attachInstance(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) groupLink2u_attachInstance(KrayProtoHandle kph,Symbol& s1,const wchar_t* name);
KRAYCEXPORT(void) groupLink2_attachInstance(KrayProtoHandle kph,Symbol& s1,const char* name);
KRAYCEXPORT(void) groupLink3u_attachInstance(KrayProtoHandle kph,Symbol& s1,const wchar_t* name,const wchar_t* instanceGroupName);
KRAYCEXPORT(void) groupLink3_attachInstance(KrayProtoHandle kph,Symbol& s1,const char* name,const char* instanceGroupName);
KRAYCEXPORT(void) groupLink1_group(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) groupLink2u_group(KrayProtoHandle kph,Symbol& s1,const wchar_t* name);
KRAYCEXPORT(void) groupLink2_group(KrayProtoHandle kph,Symbol& s1,const char* name);
KRAYCEXPORT(void) groupLink1_instance(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) groupLink2u_instance(KrayProtoHandle kph,Symbol& s1,const wchar_t* name);
KRAYCEXPORT(void) groupLink2_instance(KrayProtoHandle kph,Symbol& s1,const char* name);
KRAYCEXPORT(void) groupLink3u_instance(KrayProtoHandle kph,Symbol& s1,const wchar_t* name,const wchar_t* instanceGroupName);
KRAYCEXPORT(void) groupLink3_instance(KrayProtoHandle kph,Symbol& s1,const char* name,const char* instanceGroupName);
KRAYCEXPORT(void) help0(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_about(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_anim(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_animOb(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_animObLink(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_axes(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_background(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_bitmap(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_bitmapData(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_bitmapOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_blend(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_camera(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_class(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_classObject(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_clear(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_color(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_commandsProtos(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_coordSys(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_delete(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_displaceMap(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_double(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_echo(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_end(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_environment(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_exit(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_fg(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_fiberPack(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_fiberPackOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_for(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_fs(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_function(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_gpGpu(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_group(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_groupLink(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_help(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_if(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_include(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_instanceAdd(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_instanceLinkAdd(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_interactive(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_k2(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_kray(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_light(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_lightAdd(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_lightOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_lopt(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_lw(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_mapping(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_material(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_materialSet(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_mesh(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_meshAddPoly(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_meshesOptions(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_meshOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_metaSurface(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_metaTexture(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_metaTextureSet(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_method(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_net(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_objectAdd(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_objectInfo(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_oct(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_openCl(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_parse(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_parseMode(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_pause(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_platform(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_pm(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_portalAdd(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_postProcess(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_pv(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_rayCast(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_reference(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_rem(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_render(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_reset(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_return(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_sett(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shaderNode(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shadowMap(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shape(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shapeAdd(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shapeSelection(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shapeSelectionOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shOb(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_shObOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_showInfo(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_stop(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_string(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_stringId(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_surface(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_surfaceOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_symbolsDelete(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_tds(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_texture(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_threads(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_var(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_variable(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_vector(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_vertex2d(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_vertex3d(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_vertexData(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_vertexMap(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_vertexMapOp(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_view(KrayProtoHandle kph);
KRAYCEXPORT(void) help0_while(KrayProtoHandle kph);
KRAYCEXPORT(void) include1u(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) include1(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) instanceAdd2u(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes);
KRAYCEXPORT(void) instanceAdd2(KrayProtoHandle kph,const char* name,const CoordSys& axes);
KRAYCEXPORT(void) instanceAdd3u_clipMap(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4);
KRAYCEXPORT(void) instanceAdd3_clipMap(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4);
KRAYCEXPORT(void) instanceAdd3u_clipMap_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4);
KRAYCEXPORT(void) instanceAdd3_clipMap_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4);
KRAYCEXPORT(void) instanceAdd4u_clipMap_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,int minSamples);
KRAYCEXPORT(void) instanceAdd4_clipMap_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,int minSamples);
KRAYCEXPORT(void) instanceAdd5u_clipMap_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd5_clipMap_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd6u_clipMap_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceAdd6_clipMap_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceAdd4u_clipMap_timeShift(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd4_clipMap_timeShift(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd4u_clipMap_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd4_clipMap_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd5u_clipMap_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples);
KRAYCEXPORT(void) instanceAdd5_clipMap_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples);
KRAYCEXPORT(void) instanceAdd6u_clipMap_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd6_clipMap_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd7u_clipMap_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceAdd7_clipMap_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceAdd2u_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes);
KRAYCEXPORT(void) instanceAdd2_light(KrayProtoHandle kph,const char* name,const CoordSys& axes);
KRAYCEXPORT(void) instanceAdd3u_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,int minSamples);
KRAYCEXPORT(void) instanceAdd3_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,int minSamples);
KRAYCEXPORT(void) instanceAdd4u_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd4_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd5u_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceAdd5_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceAdd3u_timeShift(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd3_timeShift(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd3u_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd3_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Vector& timeShift);
KRAYCEXPORT(void) instanceAdd4u_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Vector& timeShift,int minSamples);
KRAYCEXPORT(void) instanceAdd4_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Vector& timeShift,int minSamples);
KRAYCEXPORT(void) instanceAdd5u_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Vector& timeShift,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd5_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Vector& timeShift,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceAdd6u_timeShift_light(KrayProtoHandle kph,const wchar_t* name,const CoordSys& axes,const Vector& timeShift,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceAdd6_timeShift_light(KrayProtoHandle kph,const char* name,const CoordSys& axes,const Vector& timeShift,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceLinkAdd2(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes);
KRAYCEXPORT(void) instanceLinkAdd3_clipMap(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4);
KRAYCEXPORT(void) instanceLinkAdd3_clipMap_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4);
KRAYCEXPORT(void) instanceLinkAdd4_clipMap_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,int minSamples);
KRAYCEXPORT(void) instanceLinkAdd5_clipMap_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceLinkAdd6_clipMap_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceLinkAdd4_clipMap_timeShift(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift);
KRAYCEXPORT(void) instanceLinkAdd4_clipMap_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift);
KRAYCEXPORT(void) instanceLinkAdd5_clipMap_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples);
KRAYCEXPORT(void) instanceLinkAdd6_clipMap_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceLinkAdd7_clipMap_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Symbol& t4,const Vector& timeShift,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceLinkAdd2_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes);
KRAYCEXPORT(void) instanceLinkAdd3_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,int minSamples);
KRAYCEXPORT(void) instanceLinkAdd4_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceLinkAdd5_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) instanceLinkAdd3_timeShift(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Vector& timeShift);
KRAYCEXPORT(void) instanceLinkAdd3_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Vector& timeShift);
KRAYCEXPORT(void) instanceLinkAdd4_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Vector& timeShift,int minSamples);
KRAYCEXPORT(void) instanceLinkAdd5_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Vector& timeShift,int minSamples,int maxSamples);
KRAYCEXPORT(void) instanceLinkAdd6_timeShift_light(KrayProtoHandle kph,const Symbol& name,const CoordSys& axes,const Vector& timeShift,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) interactive0(KrayProtoHandle kph);
KRAYCEXPORT(void) kray0(KrayProtoHandle kph);
KRAYCEXPORT(void) kray1u(KrayProtoHandle kph,const wchar_t* parameters);
KRAYCEXPORT(void) kray1(KrayProtoHandle kph,const char* parameters);
KRAYCEXPORT(void) kray2u(KrayProtoHandle kph,const wchar_t* parameters,int mode);
KRAYCEXPORT(void) kray2(KrayProtoHandle kph,const char* parameters,int mode);
KRAYCEXPORT(void) light8_adaptive(KrayProtoHandle kph,Symbol& s1,const Vector& position,const Vector& positionDx,const Vector& positionDy,const Symbol& lightTexture,double errorTolerance,int sampleRecursionMin,int sampleRecursionMax);
KRAYCEXPORT(void) light9_adaptiveSpot(KrayProtoHandle kph,Symbol& s1,const Vector& position,const Vector& positionDx,const Vector& positionDy,const Symbol& lightTexture,double errorTolerance,int sampleRecursionMin,int sampleRecursionMax,double spotAngle);
KRAYCEXPORT(void) light10_adaptiveSpot(KrayProtoHandle kph,Symbol& s1,const Vector& position,const Vector& positionDx,const Vector& positionDy,const Symbol& lightTexture,double errorTolerance,int sampleRecursionMin,int sampleRecursionMax,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) light2_ambient(KrayProtoHandle kph,Symbol& s1,const Vector& color);
KRAYCEXPORT(void) light2_ambientTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& lightTexture);
KRAYCEXPORT(void) light2_background(KrayProtoHandle kph,Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) light3_background(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples);
KRAYCEXPORT(void) light4_background(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples);
KRAYCEXPORT(void) light5_background(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light6_background(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation,double powerMax);
KRAYCEXPORT(void) light7_background(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax);
KRAYCEXPORT(void) light8_background(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax,int minGridSize);
KRAYCEXPORT(void) light4_dirPoint(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& orientation,const Vector& color);
KRAYCEXPORT(void) light4_dirPointTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& orientation,const Symbol& lightTexture);
KRAYCEXPORT(void) light2_distantSphere(KrayProtoHandle kph,Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) light3_distantSphere(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples);
KRAYCEXPORT(void) light4_distantSphere(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples);
KRAYCEXPORT(void) light5_distantSphere(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light6_distantSphere(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation,double powerMax);
KRAYCEXPORT(void) light7_distantSphere(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax);
KRAYCEXPORT(void) light8_distantSphere(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax,int minGridSize);
KRAYCEXPORT(void) light2_fade(KrayProtoHandle kph,Symbol& s1,const Symbol& l3);
KRAYCEXPORT(void) light3_fade(KrayProtoHandle kph,Symbol& s1,const Symbol& l3,double multiplier);
KRAYCEXPORT(void) light4_fadeDirPoint(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& orientation,const Vector& color);
KRAYCEXPORT(void) light4_fadeDirPointTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& orientation,const Symbol& lightTexture);
KRAYCEXPORT(void) light3_fadePoint(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const Vector& color);
KRAYCEXPORT(void) light3_fadePointTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const Symbol& lightTexture);
KRAYCEXPORT(void) light2_fakePhotonEmitter(KrayProtoHandle kph,Symbol& s1,const Symbol& l3);
KRAYCEXPORT(void) light3_fakePhotonEmitter(KrayProtoHandle kph,Symbol& s1,const Symbol& l3,double power);
KRAYCEXPORT(void) light2_far(KrayProtoHandle kph,Symbol& s1,const Symbol& l3);
KRAYCEXPORT(void) light2_group(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3);
KRAYCEXPORT(void) light3_group(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3,int minSamples);
KRAYCEXPORT(void) light4_group(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3,int minSamples,int maxSamples);
KRAYCEXPORT(void) light5_group(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light2_groupImportance(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3);
KRAYCEXPORT(void) light3_groupImportance(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3,int minSamples);
KRAYCEXPORT(void) light4_groupImportance(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3,int minSamples,int maxSamples);
KRAYCEXPORT(void) light5_groupImportance(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& l3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light3_ies(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const VarLenCoordSys& axes);
KRAYCEXPORT(void) light4_ies(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const VarLenCoordSys& axes,const Vector& colorFilter);
KRAYCEXPORT(void) light5_ies(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const VarLenCoordSys& axes,const Vector& colorFilter,int flags);
KRAYCEXPORT(void) light4_line(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Vector& color);
KRAYCEXPORT(void) light5_line(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Vector& color,int minRecursionLevel);
KRAYCEXPORT(void) light6_line(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Vector& color,int minRecursionLevel,int maxRecursionLevel);
KRAYCEXPORT(void) light7_line(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light4_linear(KrayProtoHandle kph,Symbol& s1,const Vector& position,const Vector& direction,const Symbol& lightTexture);
KRAYCEXPORT(void) light4_lineTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture);
KRAYCEXPORT(void) light5_lineTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture,int minRecursionLevel);
KRAYCEXPORT(void) light6_lineTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel);
KRAYCEXPORT(void) light7_lineTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light3_parallel(KrayProtoHandle kph,Symbol& s1,const VarLenVector& direction,const Vector& color);
KRAYCEXPORT(void) light3_parallelTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& direction,const Symbol& lightTexture);
KRAYCEXPORT(void) light3_photonMultiplier(KrayProtoHandle kph,Symbol& s1,const Symbol& l3,double numberMultiplier);
KRAYCEXPORT(void) light4_photonMultiplier(KrayProtoHandle kph,Symbol& s1,const Symbol& l3,double numberMultiplier,double powerMultiplier);
KRAYCEXPORT(void) light2_phySky(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light2_phySky_parallel(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySky_parallel(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double exposure);
KRAYCEXPORT(void) light2_phySky_point(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySky_point(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) light4_phySky_point(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) light2_phySky_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySky_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) light4_phySky_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) light5_phySky_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) light7_phySky_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_phySky_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light2_phySky_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySky_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) light4_phySky_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) light5_phySky_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) light7_phySky_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_phySky_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light2_phySun(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light2_phySun_parallel(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySun_parallel(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double exposure);
KRAYCEXPORT(void) light2_phySun_point(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySun_point(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) light4_phySun_point(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) light2_phySun_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySun_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) light4_phySun_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) light5_phySun_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) light7_phySun_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_phySun_rectangle(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light2_phySun_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject);
KRAYCEXPORT(void) light3_phySun_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) light4_phySun_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) light5_phySun_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) light7_phySun_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_phySun_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light3_point(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const Vector& color);
KRAYCEXPORT(void) light3_pointTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,const Symbol& lightTexture);
KRAYCEXPORT(void) light3_rangeLimiter(KrayProtoHandle kph,Symbol& s1,const Symbol& l3,double rangeMax);
KRAYCEXPORT(void) light4_rangeLimiter(KrayProtoHandle kph,Symbol& s1,const Symbol& l3,double rangeMax,double clip);
KRAYCEXPORT(void) light4_rectangle(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color);
KRAYCEXPORT(void) light5_rectangle(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel);
KRAYCEXPORT(void) light7_rectangle(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_rectangle(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light4_rectangleDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color);
KRAYCEXPORT(void) light5_rectangleDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel);
KRAYCEXPORT(void) light7_rectangleDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_rectangleDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light5_rectangleSpot(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle);
KRAYCEXPORT(void) light6_rectangleSpot(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) light7_rectangleSpot(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) light8_rectangleSpot(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) light10_rectangleSpot(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light11_rectangleSpot(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light5_rectangleSpotDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle);
KRAYCEXPORT(void) light6_rectangleSpotDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) light7_rectangleSpotDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) light8_rectangleSpotDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) light10_rectangleSpotDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light11_rectangleSpotDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light5_rectangleSpotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle);
KRAYCEXPORT(void) light6_rectangleSpotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) light7_rectangleSpotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) light8_rectangleSpotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) light10_rectangleSpotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light11_rectangleSpotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light5_rectangleSpotTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle);
KRAYCEXPORT(void) light6_rectangleSpotTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) light7_rectangleSpotTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) light8_rectangleSpotTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) light10_rectangleSpotTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light11_rectangleSpotTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light4_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture);
KRAYCEXPORT(void) light5_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel);
KRAYCEXPORT(void) light7_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_rectangleTextured(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light4_rectangleTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture);
KRAYCEXPORT(void) light5_rectangleTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel);
KRAYCEXPORT(void) light7_rectangleTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) light8_rectangleTexturedDS(KrayProtoHandle kph,Symbol& s1,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) light4_shadowCache(KrayProtoHandle kph,Symbol& s1,const Symbol& l3,int cacheSize,double distanceTolerance);
KRAYCEXPORT(void) light3_shadowMapPoint(KrayProtoHandle kph,Symbol& s1,const Symbol& shadowMap,const Vector& color);
KRAYCEXPORT(void) light3_shadowMapPointTextured(KrayProtoHandle kph,Symbol& s1,const Symbol& shadowMap,const Symbol& lightTexture);
KRAYCEXPORT(void) light3_shape(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenVector& v4);
KRAYCEXPORT(void) light4_shape(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenVector& v4,int minSamples);
KRAYCEXPORT(void) light5_shape(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenVector& v4,int minSamples,int maxSamples);
KRAYCEXPORT(void) light6_shape(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenVector& v4,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light4_shapeSurfaced(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4,const VarLenSymbol& s5);
KRAYCEXPORT(void) light5_shapeSurfaced(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4,const VarLenSymbol& s5,int minSamples);
KRAYCEXPORT(void) light6_shapeSurfaced(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4,const VarLenSymbol& s5,int minSamples,int maxSamples);
KRAYCEXPORT(void) light7_shapeSurfaced(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4,const VarLenSymbol& s5,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light3_shapeTextured(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4);
KRAYCEXPORT(void) light4_shapeTextured(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4,int minSamples);
KRAYCEXPORT(void) light5_shapeTextured(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4,int minSamples,int maxSamples);
KRAYCEXPORT(void) light6_shapeTextured(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenSymbol& s4,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light4_sphere(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Vector& color);
KRAYCEXPORT(void) light5_sphere(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Vector& color,int minSamples);
KRAYCEXPORT(void) light6_sphere(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Vector& color,int minSamples,int maxSamples);
KRAYCEXPORT(void) light7_sphere(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Vector& color,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light4_sphereTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Symbol& lightTexture);
KRAYCEXPORT(void) light5_sphereTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Symbol& lightTexture,int minSamples);
KRAYCEXPORT(void) light6_sphereTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Symbol& lightTexture,int minSamples,int maxSamples);
KRAYCEXPORT(void) light7_sphereTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& position,double radius,const Symbol& lightTexture,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) light5_spot(KrayProtoHandle kph,Symbol& s1,const VarLenVector& v3,const VarLenVector& v4,const Vector& color,double spotAngle);
KRAYCEXPORT(void) light6_spot(KrayProtoHandle kph,Symbol& s1,const VarLenVector& v3,const VarLenVector& v4,const Vector& color,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) light5_spotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& v3,const VarLenVector& v4,const Symbol& lightTexture,double spotAngle);
KRAYCEXPORT(void) light6_spotTextured(KrayProtoHandle kph,Symbol& s1,const VarLenVector& v3,const VarLenVector& v4,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) light2_symbol(KrayProtoHandle kph,Symbol& s1,const Symbol& l3);
KRAYCEXPORT(void) lightAdd7_adaptive(KrayProtoHandle kph,const Vector& position,const Vector& positionDx,const Vector& positionDy,const Symbol& lightTexture,double errorTolerance,int sampleRecursionMin,int sampleRecursionMax);
KRAYCEXPORT(void) lightAdd8_adaptiveSpot(KrayProtoHandle kph,const Vector& position,const Vector& positionDx,const Vector& positionDy,const Symbol& lightTexture,double errorTolerance,int sampleRecursionMin,int sampleRecursionMax,double spotAngle);
KRAYCEXPORT(void) lightAdd9_adaptiveSpot(KrayProtoHandle kph,const Vector& position,const Vector& positionDx,const Vector& positionDy,const Symbol& lightTexture,double errorTolerance,int sampleRecursionMin,int sampleRecursionMax,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) lightAdd1_ambient(KrayProtoHandle kph,const Vector& color);
KRAYCEXPORT(void) lightAdd1_ambientTextured(KrayProtoHandle kph,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd1_background(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) lightAdd2_background(KrayProtoHandle kph,const Symbol& s2,int minSamples);
KRAYCEXPORT(void) lightAdd3_background(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd4_background(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd5_background(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation,double powerMax);
KRAYCEXPORT(void) lightAdd6_background(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax);
KRAYCEXPORT(void) lightAdd7_background(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax,int minGridSize);
KRAYCEXPORT(void) lightAdd3_dirPoint(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& orientation,const Vector& color);
KRAYCEXPORT(void) lightAdd3_dirPointTextured(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& orientation,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd1_distantSphere(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) lightAdd2_distantSphere(KrayProtoHandle kph,const Symbol& s2,int minSamples);
KRAYCEXPORT(void) lightAdd3_distantSphere(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd4_distantSphere(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd5_distantSphere(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation,double powerMax);
KRAYCEXPORT(void) lightAdd6_distantSphere(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax);
KRAYCEXPORT(void) lightAdd7_distantSphere(KrayProtoHandle kph,const Symbol& s2,int minSamples,int maxSamples,double stdDeviation,double powerMax,double dynamicMax,int minGridSize);
KRAYCEXPORT(void) lightAdd1_fade(KrayProtoHandle kph,const Symbol& l2);
KRAYCEXPORT(void) lightAdd2_fade(KrayProtoHandle kph,const Symbol& l2,double multiplier);
KRAYCEXPORT(void) lightAdd3_fadeDirPoint(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& orientation,const Vector& color);
KRAYCEXPORT(void) lightAdd3_fadeDirPointTextured(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& orientation,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd2_fadePoint(KrayProtoHandle kph,const VarLenVector& position,const Vector& color);
KRAYCEXPORT(void) lightAdd2_fadePointTextured(KrayProtoHandle kph,const VarLenVector& position,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd1_fakePhotonEmitter(KrayProtoHandle kph,const Symbol& l2);
KRAYCEXPORT(void) lightAdd2_fakePhotonEmitter(KrayProtoHandle kph,const Symbol& l2,double power);
KRAYCEXPORT(void) lightAdd1_far(KrayProtoHandle kph,const Symbol& l2);
KRAYCEXPORT(void) lightAdd1_group(KrayProtoHandle kph,const VarLenSymbol& l2);
KRAYCEXPORT(void) lightAdd2_group(KrayProtoHandle kph,const VarLenSymbol& l2,int minSamples);
KRAYCEXPORT(void) lightAdd3_group(KrayProtoHandle kph,const VarLenSymbol& l2,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd4_group(KrayProtoHandle kph,const VarLenSymbol& l2,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd1_groupImportance(KrayProtoHandle kph,const VarLenSymbol& l2);
KRAYCEXPORT(void) lightAdd2_groupImportance(KrayProtoHandle kph,const VarLenSymbol& l2,int minSamples);
KRAYCEXPORT(void) lightAdd3_groupImportance(KrayProtoHandle kph,const VarLenSymbol& l2,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd4_groupImportance(KrayProtoHandle kph,const VarLenSymbol& l2,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd2_ies(KrayProtoHandle kph,const Symbol& s2,const VarLenCoordSys& axes);
KRAYCEXPORT(void) lightAdd3_ies(KrayProtoHandle kph,const Symbol& s2,const VarLenCoordSys& axes,const Vector& colorFilter);
KRAYCEXPORT(void) lightAdd4_ies(KrayProtoHandle kph,const Symbol& s2,const VarLenCoordSys& axes,const Vector& colorFilter,int flags);
KRAYCEXPORT(void) lightAdd3_line(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Vector& color);
KRAYCEXPORT(void) lightAdd4_line(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Vector& color,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd5_line(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Vector& color,int minRecursionLevel,int maxRecursionLevel);
KRAYCEXPORT(void) lightAdd6_line(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd3_linear(KrayProtoHandle kph,const Vector& position,const Vector& direction,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd3_lineTextured(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd4_lineTextured(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd5_lineTextured(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel);
KRAYCEXPORT(void) lightAdd6_lineTextured(KrayProtoHandle kph,const VarLenVector& position,const VarLenVector& direction,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd2_parallel(KrayProtoHandle kph,const VarLenVector& direction,const Vector& color);
KRAYCEXPORT(void) lightAdd2_parallelTextured(KrayProtoHandle kph,const VarLenVector& direction,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd2_photonMultiplier(KrayProtoHandle kph,const Symbol& l2,double numberMultiplier);
KRAYCEXPORT(void) lightAdd3_photonMultiplier(KrayProtoHandle kph,const Symbol& l2,double numberMultiplier,double powerMultiplier);
KRAYCEXPORT(void) lightAdd1_phySky(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd1_phySky_parallel(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySky_parallel(KrayProtoHandle kph,const Symbol& phySkyObject,double exposure);
KRAYCEXPORT(void) lightAdd1_phySky_point(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySky_point(KrayProtoHandle kph,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) lightAdd3_phySky_point(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) lightAdd1_phySky_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySky_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) lightAdd3_phySky_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) lightAdd4_phySky_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_phySky_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_phySky_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd1_phySky_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySky_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) lightAdd3_phySky_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) lightAdd4_phySky_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_phySky_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_phySky_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd1_phySun(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd1_phySun_parallel(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySun_parallel(KrayProtoHandle kph,const Symbol& phySkyObject,double exposure);
KRAYCEXPORT(void) lightAdd1_phySun_point(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySun_point(KrayProtoHandle kph,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) lightAdd3_phySun_point(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) lightAdd1_phySun_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySun_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) lightAdd3_phySun_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) lightAdd4_phySun_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_phySun_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_phySun_rectangle(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd1_phySun_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject);
KRAYCEXPORT(void) lightAdd2_phySun_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance);
KRAYCEXPORT(void) lightAdd3_phySun_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure);
KRAYCEXPORT(void) lightAdd4_phySun_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_phySun_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_phySun_rectangleTextured(KrayProtoHandle kph,const Symbol& phySkyObject,double distance,double exposure,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd2_point(KrayProtoHandle kph,const VarLenVector& position,const Vector& color);
KRAYCEXPORT(void) lightAdd2_pointTextured(KrayProtoHandle kph,const VarLenVector& position,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd2_rangeLimiter(KrayProtoHandle kph,const Symbol& l2,double rangeMax);
KRAYCEXPORT(void) lightAdd3_rangeLimiter(KrayProtoHandle kph,const Symbol& l2,double rangeMax,double clip);
KRAYCEXPORT(void) lightAdd3_rectangle(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color);
KRAYCEXPORT(void) lightAdd4_rectangle(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_rectangle(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_rectangle(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd3_rectangleDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color);
KRAYCEXPORT(void) lightAdd4_rectangleDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_rectangleDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_rectangleDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd4_rectangleSpot(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle);
KRAYCEXPORT(void) lightAdd5_rectangleSpot(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) lightAdd6_rectangleSpot(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) lightAdd7_rectangleSpot(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd9_rectangleSpot(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd10_rectangleSpot(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd4_rectangleSpotDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle);
KRAYCEXPORT(void) lightAdd5_rectangleSpotDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) lightAdd6_rectangleSpotDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) lightAdd7_rectangleSpotDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd9_rectangleSpotDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd10_rectangleSpotDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Vector& color,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd4_rectangleSpotTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle);
KRAYCEXPORT(void) lightAdd5_rectangleSpotTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) lightAdd6_rectangleSpotTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) lightAdd7_rectangleSpotTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd9_rectangleSpotTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd10_rectangleSpotTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd4_rectangleSpotTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle);
KRAYCEXPORT(void) lightAdd5_rectangleSpotTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) lightAdd6_rectangleSpotTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection);
KRAYCEXPORT(void) lightAdd7_rectangleSpotTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd9_rectangleSpotTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd10_rectangleSpotTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd,const Vector& spotDirection,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd3_rectangleTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd4_rectangleTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_rectangleTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_rectangleTextured(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd3_rectangleTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd4_rectangleTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel);
KRAYCEXPORT(void) lightAdd6_rectangleTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lightAdd7_rectangleTexturedDS(KrayProtoHandle kph,const VarLenCoordSys& axes,const Vector& size,const Symbol& lightTexture,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lightAdd3_shadowCache(KrayProtoHandle kph,const Symbol& l2,int cacheSize,double distanceTolerance);
KRAYCEXPORT(void) lightAdd2_shadowMapPoint(KrayProtoHandle kph,const Symbol& shadowMap,const Vector& color);
KRAYCEXPORT(void) lightAdd2_shadowMapPointTextured(KrayProtoHandle kph,const Symbol& shadowMap,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd2_shape(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenVector& v3);
KRAYCEXPORT(void) lightAdd3_shape(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenVector& v3,int minSamples);
KRAYCEXPORT(void) lightAdd4_shape(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenVector& v3,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd5_shape(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenVector& v3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd3_shapeSurfaced(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3,const VarLenSymbol& s4);
KRAYCEXPORT(void) lightAdd4_shapeSurfaced(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3,const VarLenSymbol& s4,int minSamples);
KRAYCEXPORT(void) lightAdd5_shapeSurfaced(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3,const VarLenSymbol& s4,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd6_shapeSurfaced(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3,const VarLenSymbol& s4,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd2_shapeTextured(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3);
KRAYCEXPORT(void) lightAdd3_shapeTextured(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3,int minSamples);
KRAYCEXPORT(void) lightAdd4_shapeTextured(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd5_shapeTextured(KrayProtoHandle kph,const VarLenSymbol& s2,const VarLenSymbol& s3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd3_sphere(KrayProtoHandle kph,const VarLenVector& position,double radius,const Vector& color);
KRAYCEXPORT(void) lightAdd4_sphere(KrayProtoHandle kph,const VarLenVector& position,double radius,const Vector& color,int minSamples);
KRAYCEXPORT(void) lightAdd5_sphere(KrayProtoHandle kph,const VarLenVector& position,double radius,const Vector& color,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd6_sphere(KrayProtoHandle kph,const VarLenVector& position,double radius,const Vector& color,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd3_sphereTextured(KrayProtoHandle kph,const VarLenVector& position,double radius,const Symbol& lightTexture);
KRAYCEXPORT(void) lightAdd4_sphereTextured(KrayProtoHandle kph,const VarLenVector& position,double radius,const Symbol& lightTexture,int minSamples);
KRAYCEXPORT(void) lightAdd5_sphereTextured(KrayProtoHandle kph,const VarLenVector& position,double radius,const Symbol& lightTexture,int minSamples,int maxSamples);
KRAYCEXPORT(void) lightAdd6_sphereTextured(KrayProtoHandle kph,const VarLenVector& position,double radius,const Symbol& lightTexture,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lightAdd4_spot(KrayProtoHandle kph,const VarLenVector& v2,const VarLenVector& v3,const Vector& color,double spotAngle);
KRAYCEXPORT(void) lightAdd5_spot(KrayProtoHandle kph,const VarLenVector& v2,const VarLenVector& v3,const Vector& color,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) lightAdd4_spotTextured(KrayProtoHandle kph,const VarLenVector& v2,const VarLenVector& v3,const Symbol& lightTexture,double spotAngle);
KRAYCEXPORT(void) lightAdd5_spotTextured(KrayProtoHandle kph,const VarLenVector& v2,const VarLenVector& v3,const Symbol& lightTexture,double spotAngle,double spotAngleSoftEnd);
KRAYCEXPORT(void) lightAdd1_symbol(KrayProtoHandle kph,const Symbol& l2);
KRAYCEXPORT(void) lightOp2_shadow(KrayProtoHandle kph,const Symbol& l1,bool onOff);
KRAYCEXPORT(void) lopt0_lemQuality(KrayProtoHandle kph);
KRAYCEXPORT(void) lopt1_lemQuality(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) lopt2_lemQuality(KrayProtoHandle kph,int minSamples,int maxSamples);
KRAYCEXPORT(void) lopt3_lemQuality(KrayProtoHandle kph,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lopt0_lineQuality(KrayProtoHandle kph);
KRAYCEXPORT(void) lopt1_lineQuality(KrayProtoHandle kph,int minRecursionLevel);
KRAYCEXPORT(void) lopt2_lineQuality(KrayProtoHandle kph,int minRecursionLevel,int maxRecursionLevel);
KRAYCEXPORT(void) lopt3_lineQuality(KrayProtoHandle kph,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lopt0_presample(KrayProtoHandle kph);
KRAYCEXPORT(void) lopt1_presample(KrayProtoHandle kph,double powerMax);
KRAYCEXPORT(void) lopt2_presample(KrayProtoHandle kph,double powerMax,double dynamicMax);
KRAYCEXPORT(void) lopt3_presample(KrayProtoHandle kph,double powerMax,double dynamicMax,int minGridSize);
KRAYCEXPORT(void) lopt0_rectangleQuality(KrayProtoHandle kph);
KRAYCEXPORT(void) lopt1_rectangleQuality(KrayProtoHandle kph,int minRecursionLevel);
KRAYCEXPORT(void) lopt3_rectangleQuality(KrayProtoHandle kph,int minRecursionLevel,int maxRecursionLevel,double errorTolerance);
KRAYCEXPORT(void) lopt4_rectangleQuality(KrayProtoHandle kph,int minRecursionLevel,int maxRecursionLevel,double errorTolerance,int borderTestRecursionLevel);
KRAYCEXPORT(void) lw3_areaLights(KrayProtoHandle kph,int showAreaLights,bool doubleSided,bool computeWithLumi);
KRAYCEXPORT(void) lw0_backgroundInputTone(KrayProtoHandle kph);
KRAYCEXPORT(void) lw1_backgroundInputTone(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) lw2u_bitmapLoad(KrayProtoHandle kph,const BitmapSymbol& b2,const wchar_t* name);
KRAYCEXPORT(void) lw2_bitmapLoad(KrayProtoHandle kph,const BitmapSymbol& b2,const char* name);
KRAYCEXPORT(void) lw3u_bitmapLoad(KrayProtoHandle kph,const BitmapSymbol& b2,const wchar_t* name,double time);
KRAYCEXPORT(void) lw3_bitmapLoad(KrayProtoHandle kph,const BitmapSymbol& b2,const char* name,double time);
KRAYCEXPORT(void) lw1_camBokeh(KrayProtoHandle kph,const BitmapSymbol& bokeh);
KRAYCEXPORT(void) lw2_camCastMaps(KrayProtoHandle kph,const BitmapSymbol& positionMap,const BitmapSymbol& directionMap);
KRAYCEXPORT(void) lw1u_camDofTargetObject(KrayProtoHandle kph,const wchar_t* dofTarget);
KRAYCEXPORT(void) lw1_camDofTargetObject(KrayProtoHandle kph,const char* dofTarget);
KRAYCEXPORT(void) lw2u_camMeshAndUv(KrayProtoHandle kph,const wchar_t* meshAnimObName,const wchar_t* uvName);
KRAYCEXPORT(void) lw2_camMeshAndUv(KrayProtoHandle kph,const char* meshAnimObName,const char* uvName);
KRAYCEXPORT(void) lw0_camMode(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_castMaps(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_fishEye(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_lens1(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_lens2(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_mesh(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_move(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_parallel(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_parallelExt(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_perspective(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_picture(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_rotate(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_shift(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_sphere(KrayProtoHandle kph);
KRAYCEXPORT(void) lw0_camMode_stereo(KrayProtoHandle kph);
KRAYCEXPORT(void) lw2_camStereo(KrayProtoHandle kph,double eyeSeparation,int stripes);
KRAYCEXPORT(void) lw3_commRingEvent(KrayProtoHandle kph,int dest,int value,double param);
KRAYCEXPORT(void) lw4u_commRingEvent(KrayProtoHandle kph,int dest,int value,double param,const wchar_t* stringParam);
KRAYCEXPORT(void) lw4_commRingEvent(KrayProtoHandle kph,int dest,int value,double param,const char* stringParam);
KRAYCEXPORT(void) lw1_coneToArea(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) lw1_controlAmbient(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) lw1_controlBackground(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) lw1_controlEnvironment(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) lw1_directLoader(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) lw1_environmentFlags(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) lw1_ignoreItemId(KrayProtoHandle kph,size_t id);
KRAYCEXPORT(void) lw1u_ignoreItemName(KrayProtoHandle kph,const wchar_t* name);
KRAYCEXPORT(void) lw1_ignoreItemName(KrayProtoHandle kph,const char* name);
KRAYCEXPORT(void) lw0_inputTone(KrayProtoHandle kph);
KRAYCEXPORT(void) lw1_inputTone(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) lw1_instanceTemplateItem(KrayProtoHandle kph,size_t id1);
KRAYCEXPORT(void) lw2_instanceTemplateItem(KrayProtoHandle kph,size_t id1,size_t id2);
KRAYCEXPORT(void) lw3_instanceTemplateItem(KrayProtoHandle kph,size_t id1,size_t id2,int flags);
KRAYCEXPORT(void) lw0_invalidateScene(KrayProtoHandle kph);
KRAYCEXPORT(void) lw1_itemReload(KrayProtoHandle kph,size_t itemId);
KRAYCEXPORT(void) lw2_itemReload(KrayProtoHandle kph,size_t itemId,bool reset);
KRAYCEXPORT(void) lw0_lightInputTone(KrayProtoHandle kph);
KRAYCEXPORT(void) lw1_lightInputTone(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) lw2_meshesOptions_airPolys(KrayProtoHandle kph,bool needAirPolysFlag,bool backside_pure_transmission);
KRAYCEXPORT(void) lw1_meshesOptions_baseNormalGrab(KrayProtoHandle kph,bool d3);
KRAYCEXPORT(void) lw0_meshesOptions_blur(KrayProtoHandle kph);
KRAYCEXPORT(void) lw1_meshesOptions_blur(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) lw2_meshesOptions_blur(KrayProtoHandle kph,int minSamples,int maxSamples);
KRAYCEXPORT(void) lw3_meshesOptions_blur(KrayProtoHandle kph,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) lw4_meshesOptions_blur(KrayProtoHandle kph,int minSamples,int maxSamples,double stdDeviation,double blurred_accuracy_threshold);
KRAYCEXPORT(void) lw1_meshesOptions_blurDoubleSide(KrayProtoHandle kph,bool d3);
KRAYCEXPORT(void) lw2_meshesOptions_raysLimit(KrayProtoHandle kph,int d3,double d4);
KRAYCEXPORT(void) lw1_meshesOptions_reflectBlurModel(KrayProtoHandle kph,int reflectblur_model);
KRAYCEXPORT(void) lw1_meshesOptions_sideness(KrayProtoHandle kph,bool d3);
KRAYCEXPORT(void) lw1_meshesOptions_textureSystem(KrayProtoHandle kph,bool d3);
KRAYCEXPORT(void) lw1_meshesOptions_unseenByRaysAffectsGi(KrayProtoHandle kph,bool unseenbyrays_affects_gi);
KRAYCEXPORT(void) lw1_nonPhyLightsCastsPhotons(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) lw1_outputTo(KrayProtoHandle kph,bool lwOutput);
KRAYCEXPORT(void) lw1_pathMode(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) lw1_raySamples(KrayProtoHandle kph,int samples);
KRAYCEXPORT(void) lw2_replaceLight(KrayProtoHandle kph,size_t d2,const Symbol& l3);
KRAYCEXPORT(void) lw1u_sceneLoad(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) lw1_sceneLoad(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) lw2u_sceneLoad(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) lw2_sceneLoad(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) lw0_sceneReLoad(KrayProtoHandle kph);
KRAYCEXPORT(void) lw1_sceneReLoad(KrayProtoHandle kph,bool force);
KRAYCEXPORT(void) lw1_selfInstance(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) lw1_setGlobalHandlers(KrayProtoHandle kph,int mask);
KRAYCEXPORT(void) lw1_shaderNodeBackground(KrayProtoHandle kph,Symbol& s2);
KRAYCEXPORT(void) lw1_shaderNodeEnvironment(KrayProtoHandle kph,Symbol& s2);
KRAYCEXPORT(void) lw0_textureInputTone(KrayProtoHandle kph);
KRAYCEXPORT(void) lw1_textureInputTone(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) mapping4_rect(KrayProtoHandle kph,Symbol& s1,const Vector& dx,const Vector& dy,const Vector& pos);
KRAYCEXPORT(void) mapping2_sphere(KrayProtoHandle kph,Symbol& s1,const CoordSys& axes);
KRAYCEXPORT(void) mapping2_triangleUvMap(KrayProtoHandle kph,Symbol& s1,const VertexMapSymbol& v3);
KRAYCEXPORT(void) mapping3_tube(KrayProtoHandle kph,Symbol& s1,const CoordSys& axes,double len);
KRAYCEXPORT(void) material1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) material3_fromMeshTag(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m3,size_t polygonTag);
KRAYCEXPORT(void) material3u_fromMeshTagName(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m3,const wchar_t* polygonTagName);
KRAYCEXPORT(void) material3_fromMeshTagName(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m3,const char* polygonTagName);
KRAYCEXPORT(void) materialSet2_ambientOcclusionColor(KrayProtoHandle kph,const Symbol& m1,const Vector& t);
KRAYCEXPORT(void) materialSet2_ambientOcclusionDistance(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_backSideFlags(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_blurMaxRays(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet4_blurRays(KrayProtoHandle kph,const Symbol& m1,int minRays,int maxRays,double noiseTolerance);
KRAYCEXPORT(void) materialSet2_blurTolerance(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_bumpDepth(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_color(KrayProtoHandle kph,const Symbol& m1,const Vector& t);
KRAYCEXPORT(void) materialSet2_diffuse(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_diffuseModel(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_edgeDetectSlot(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_flags(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_forceColor(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_fresnel(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_glossiness(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_ior(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_light(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_lightGroup(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_reflection(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_reflectionBlur(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_reflectionBlurLights(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_refractionBlur(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_specularity(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet1_texture_bump(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_bump(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_color(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_color(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_diffuse(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_diffuse(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_light(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_light(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_normal(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_normal(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_reflection(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_reflection(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_specularity(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_specularity(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_translucency(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_translucency(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet1_texture_transparency(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) materialSet2_texture_transparency(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) materialSet2_translucency(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_transparency(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) materialSet2_transparencyAffects(KrayProtoHandle kph,const Symbol& m1,double value);
KRAYCEXPORT(void) mesh1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) mesh2u_fromAnimOb(KrayProtoHandle kph,Symbol& s1,const wchar_t* s3);
KRAYCEXPORT(void) mesh2_fromAnimOb(KrayProtoHandle kph,Symbol& s1,const char* s3);
KRAYCEXPORT(void) mesh3u_fromAnimOb(KrayProtoHandle kph,Symbol& s1,const wchar_t* s3,int flags);
KRAYCEXPORT(void) mesh3_fromAnimOb(KrayProtoHandle kph,Symbol& s1,const char* s3,int flags);
KRAYCEXPORT(void) mesh2_fromBitmap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) mesh7_fromBitmap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8);
KRAYCEXPORT(void) mesh8_fromBitmap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9);
KRAYCEXPORT(void) mesh10_fromBitmap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9,const Vector& v10,const Vector& v11);
KRAYCEXPORT(void) mesh2_fromVertexMap(KrayProtoHandle kph,Symbol& s1,const VertexMapSymbol& v3);
KRAYCEXPORT(void) mesh2u_import(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) mesh2_import(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) mesh3u_import(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,int layer);
KRAYCEXPORT(void) mesh3_import(KrayProtoHandle kph,Symbol& s1,const char* filename,int layer);
KRAYCEXPORT(void) mesh4u_import(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,int layer,const wchar_t* meshname);
KRAYCEXPORT(void) mesh4_import(KrayProtoHandle kph,Symbol& s1,const char* filename,int layer,const char* meshname);
KRAYCEXPORT(void) mesh2_triple(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m3);
KRAYCEXPORT(void) meshAddPoly3(KrayProtoHandle kph,const MeshSymbol& m1,size_t d2,const VarLenDouble& polygon);
KRAYCEXPORT(void) meshAddPoly4(KrayProtoHandle kph,const MeshSymbol& m1,size_t d2,const VarLenDouble& polygon,int groupId);
KRAYCEXPORT(void) meshAddPoly5(KrayProtoHandle kph,const MeshSymbol& m1,size_t d2,const VarLenDouble& polygon,int groupId,int flags);
KRAYCEXPORT(void) meshesOptions2_ambientOcclusion(KrayProtoHandle kph,const Vector& ambientOcclusionColor,double ambientOcclusionDistance);
KRAYCEXPORT(void) meshesOptions1_bitFlags(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) meshesOptions2_bitFlags(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) meshesOptions1_diffuseModel(KrayProtoHandle kph,int model);
KRAYCEXPORT(void) meshesOptions1_illuminateModel(KrayProtoHandle kph,int illuminateModel);
KRAYCEXPORT(void) meshesOptions1_overrideColor(KrayProtoHandle kph,const Vector& override_color);
KRAYCEXPORT(void) meshesOptions1_overrideSurface(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) meshesOptions2_overrideSurface(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) meshesOptions3_overrideWire(KrayProtoHandle kph,const Vector& wire_color,double d3,double d4);
KRAYCEXPORT(void) meshesOptions1_preprocessDuplicatePointTolerance(KrayProtoHandle kph,double preprocessDuplicatePointTolerance);
KRAYCEXPORT(void) meshesOptions1_preprocessFlags(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) meshesOptions2_preprocessFlags(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) meshesOptions1_surfaceFlags(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) meshOp3u_addPolyTagName(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* polygonTagName,const VarLenDouble& polygon);
KRAYCEXPORT(void) meshOp3_addPolyTagName(KrayProtoHandle kph,const MeshSymbol& m1,const char* polygonTagName,const VarLenDouble& polygon);
KRAYCEXPORT(void) meshOp4u_addPolyTagName(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* polygonTagName,const VarLenDouble& polygon,int groupId);
KRAYCEXPORT(void) meshOp4_addPolyTagName(KrayProtoHandle kph,const MeshSymbol& m1,const char* polygonTagName,const VarLenDouble& polygon,int groupId);
KRAYCEXPORT(void) meshOp5u_addPolyTagName(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* polygonTagName,const VarLenDouble& polygon,int groupId,int flags);
KRAYCEXPORT(void) meshOp5_addPolyTagName(KrayProtoHandle kph,const MeshSymbol& m1,const char* polygonTagName,const VarLenDouble& polygon,int groupId,int flags);
KRAYCEXPORT(void) meshOp1_align(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_align(KrayProtoHandle kph,const MeshSymbol& m1,bool checkFacingDirection);
KRAYCEXPORT(void) meshOp3_align(KrayProtoHandle kph,const MeshSymbol& m1,bool checkFacingDirection,bool findSamePointsWithDifferentIndicesFirst);
KRAYCEXPORT(void) meshOp4_align(KrayProtoHandle kph,const MeshSymbol& m1,bool checkFacingDirection,bool findSamePointsWithDifferentIndicesFirst,bool doubleSidedOnly);
KRAYCEXPORT(void) meshOp1_autoGroup(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_autoGroup(KrayProtoHandle kph,const MeshSymbol& m1,bool edgeMode);
KRAYCEXPORT(void) meshOp3u_export_grabVertexMap_discretizePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density);
KRAYCEXPORT(void) meshOp3_export_grabVertexMap_discretizePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density);
KRAYCEXPORT(void) meshOp4u_export_grabVertexMap_discretizePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density,double time);
KRAYCEXPORT(void) meshOp4_export_grabVertexMap_discretizePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density,double time);
KRAYCEXPORT(void) meshOp3u_export_grabVertexMap_gridSamplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density);
KRAYCEXPORT(void) meshOp3_export_grabVertexMap_gridSamplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density);
KRAYCEXPORT(void) meshOp4u_export_grabVertexMap_gridSamplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density,double time);
KRAYCEXPORT(void) meshOp4_export_grabVertexMap_gridSamplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density,double time);
KRAYCEXPORT(void) meshOp5u_export_grabVertexMap_gridSamplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density,double time,const Axes& plane);
KRAYCEXPORT(void) meshOp5_export_grabVertexMap_gridSamplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density,double time,const Axes& plane);
KRAYCEXPORT(void) meshOp3u_export_grabVertexMap_samplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density);
KRAYCEXPORT(void) meshOp3_export_grabVertexMap_samplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density);
KRAYCEXPORT(void) meshOp4u_export_grabVertexMap_samplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density,double time);
KRAYCEXPORT(void) meshOp4_export_grabVertexMap_samplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density,double time);
KRAYCEXPORT(void) meshOp5u_export_grabVertexMap_samplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,double density,double time,int accuracy);
KRAYCEXPORT(void) meshOp5_export_grabVertexMap_samplePoints(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,double density,double time,int accuracy);
KRAYCEXPORT(void) meshOp2u_export_json(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename);
KRAYCEXPORT(void) meshOp2_export_json(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename);
KRAYCEXPORT(void) meshOp3u_export_json(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) meshOp3_export_json(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,int flags);
KRAYCEXPORT(void) meshOp2u_export_videoScape(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename);
KRAYCEXPORT(void) meshOp2_export_videoScape(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename);
KRAYCEXPORT(void) meshOp1_findQuads(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp1_flip(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp1_geometricNormalFlip(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_geometricNormalFlip(KrayProtoHandle kph,const MeshSymbol& m1,const VertexMapSymbol& v3);
KRAYCEXPORT(void) meshOp2u_metaShare(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* name);
KRAYCEXPORT(void) meshOp2_metaShare(KrayProtoHandle kph,const MeshSymbol& m1,const char* name);
KRAYCEXPORT(void) meshOp2u_pointMeta(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* name);
KRAYCEXPORT(void) meshOp2_pointMeta(KrayProtoHandle kph,const MeshSymbol& m1,const char* name);
KRAYCEXPORT(void) meshOp3u_pointMeta(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* name,const VertexMapSymbol& v4);
KRAYCEXPORT(void) meshOp3_pointMeta(KrayProtoHandle kph,const MeshSymbol& m1,const char* name,const VertexMapSymbol& v4);
KRAYCEXPORT(void) meshOp1_pointNormals(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_pointNormals(KrayProtoHandle kph,const MeshSymbol& m1,const VertexMapSymbol& v3);
KRAYCEXPORT(void) meshOp1_points(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_points(KrayProtoHandle kph,const MeshSymbol& m1,const VertexMapSymbol& v3);
KRAYCEXPORT(void) meshOp2u_polyMeta(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* name);
KRAYCEXPORT(void) meshOp2_polyMeta(KrayProtoHandle kph,const MeshSymbol& m1,const char* name);
KRAYCEXPORT(void) meshOp3u_polyMeta(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* name,const VertexMapSymbol& v4);
KRAYCEXPORT(void) meshOp3_polyMeta(KrayProtoHandle kph,const MeshSymbol& m1,const char* name,const VertexMapSymbol& v4);
KRAYCEXPORT(void) meshOp1_polyNormals(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_polyNormals(KrayProtoHandle kph,const MeshSymbol& m1,const VertexMapSymbol& v3);
KRAYCEXPORT(void) meshOp1_removeDuplicates(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_removeDuplicates(KrayProtoHandle kph,const MeshSymbol& m1,bool findSamePointsWithDifferentIndicesFirst);
KRAYCEXPORT(void) meshOp3_removeDuplicates(KrayProtoHandle kph,const MeshSymbol& m1,bool findSamePointsWithDifferentIndicesFirst,bool ignoreBackSide);
KRAYCEXPORT(void) meshOp4_removeDuplicates(KrayProtoHandle kph,const MeshSymbol& m1,bool findSamePointsWithDifferentIndicesFirst,bool ignoreBackSide,bool ignoreBackSideUv);
KRAYCEXPORT(void) meshOp1_removeUnusedTags(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2u_saveScript(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename);
KRAYCEXPORT(void) meshOp2_saveScript(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename);
KRAYCEXPORT(void) meshOp3u_saveScript(KrayProtoHandle kph,const MeshSymbol& m1,const wchar_t* filename,const wchar_t* meshVariableName);
KRAYCEXPORT(void) meshOp3_saveScript(KrayProtoHandle kph,const MeshSymbol& m1,const char* filename,const char* meshVariableName);
KRAYCEXPORT(void) meshOp2_setUvIndexShift(KrayProtoHandle kph,const MeshSymbol& m1,size_t d3);
KRAYCEXPORT(void) meshOp1_shadingNormalFlip(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp3_tag_clipMap(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const Symbol& m5);
KRAYCEXPORT(void) meshOp3_tag_directClipMap(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const Symbol& t5);
KRAYCEXPORT(void) meshOp3_tag_displaceDepth(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,double d5);
KRAYCEXPORT(void) meshOp3_tag_displaceDepthPointUv(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const VertexMapSymbol& v5);
KRAYCEXPORT(void) meshOp3_tag_displaceDepthPolyUv(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const VertexMapSymbol& v5);
KRAYCEXPORT(void) meshOp3_tag_displaceMap(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const Symbol& d5);
KRAYCEXPORT(void) meshOp3_tag_displacePointUv(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const VertexMapSymbol& v5);
KRAYCEXPORT(void) meshOp3_tag_displacePolyUv(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const VertexMapSymbol& v5);
KRAYCEXPORT(void) meshOp3_tag_flags(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,int d5);
KRAYCEXPORT(void) meshOp3_tag_material(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const Symbol& s5);
KRAYCEXPORT(void) meshOp3u_tag_name(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const wchar_t* s5);
KRAYCEXPORT(void) meshOp3_tag_name(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const char* s5);
KRAYCEXPORT(void) meshOp3_tag_normalPointMap(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const VertexMapSymbol& v5);
KRAYCEXPORT(void) meshOp3_tag_normalPolyMap(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const VertexMapSymbol& v5);
KRAYCEXPORT(void) meshOp3_tag_shader(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,const Symbol& s5);
KRAYCEXPORT(void) meshOp4_tag_smoothing(KrayProtoHandle kph,const MeshSymbol& m1,size_t index,int smoothingGroup,double maxSmoothingAngle);
KRAYCEXPORT(void) meshOp1_tagsMap(KrayProtoHandle kph,const MeshSymbol& m1);
KRAYCEXPORT(void) meshOp2_tagsMap(KrayProtoHandle kph,const MeshSymbol& m1,const VertexMapSymbol& v3);
KRAYCEXPORT(void) metaSurface1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) metaSurface3_fromMeshTag(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m3,size_t polygonTag);
KRAYCEXPORT(void) metaSurface3u_fromMeshTagName(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m3,const wchar_t* polygonTagName);
KRAYCEXPORT(void) metaSurface3_fromMeshTagName(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m3,const char* polygonTagName);
KRAYCEXPORT(void) metaTexture1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) metaTextureSet1_bitmap(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) metaTextureSet2_bitmap(KrayProtoHandle kph,const Symbol& m1,const BitmapSymbol& b3);
KRAYCEXPORT(void) metaTextureSet2u_bitmapFilename(KrayProtoHandle kph,const Symbol& m1,const wchar_t* fileName);
KRAYCEXPORT(void) metaTextureSet2_bitmapFilename(KrayProtoHandle kph,const Symbol& m1,const char* fileName);
KRAYCEXPORT(void) metaTextureSet2_color(KrayProtoHandle kph,const Symbol& m1,const Vector& v3);
KRAYCEXPORT(void) metaTextureSet2u_colorVmap(KrayProtoHandle kph,const Symbol& m1,const wchar_t* s3);
KRAYCEXPORT(void) metaTextureSet2_colorVmap(KrayProtoHandle kph,const Symbol& m1,const char* s3);
KRAYCEXPORT(void) metaTextureSet1_inputTone(KrayProtoHandle kph,const Symbol& m1);
KRAYCEXPORT(void) metaTextureSet2_inputTone(KrayProtoHandle kph,const Symbol& m1,const Symbol& s3);
KRAYCEXPORT(void) metaTextureSet2_lod(KrayProtoHandle kph,const Symbol& m1,bool onOff);
KRAYCEXPORT(void) metaTextureSet2_mapping_external(KrayProtoHandle kph,const Symbol& m1,const Symbol& s4);
KRAYCEXPORT(void) metaTextureSet2_mapping_fishEye(KrayProtoHandle kph,const Symbol& m1,const CoordSys& axes);
KRAYCEXPORT(void) metaTextureSet2_mapping_fishEyeDirection(KrayProtoHandle kph,const Symbol& m1,const Axes& axes);
KRAYCEXPORT(void) metaTextureSet4_mapping_projection(KrayProtoHandle kph,const Symbol& m1,const CoordSys& ori,const Vector& imageSize,double focalLength);
KRAYCEXPORT(void) metaTextureSet4_mapping_projectionDirection(KrayProtoHandle kph,const Symbol& m1,const Axes& ori,const Vector& imageSize,double focalLength);
KRAYCEXPORT(void) metaTextureSet4_mapping_rect(KrayProtoHandle kph,const Symbol& m1,const Vector& dx,const Vector& dy,const Vector& pos);
KRAYCEXPORT(void) metaTextureSet2_mapping_sphere(KrayProtoHandle kph,const Symbol& m1,const CoordSys& axes);
KRAYCEXPORT(void) metaTextureSet2_mapping_sphereDirection(KrayProtoHandle kph,const Symbol& m1,const Axes& axes);
KRAYCEXPORT(void) metaTextureSet3_mapping_tube(KrayProtoHandle kph,const Symbol& m1,const CoordSys& axes,double len);
KRAYCEXPORT(void) metaTextureSet2u_mapping_uv(KrayProtoHandle kph,const Symbol& m1,const wchar_t* s4);
KRAYCEXPORT(void) metaTextureSet2_mapping_uv(KrayProtoHandle kph,const Symbol& m1,const char* s4);
KRAYCEXPORT(void) metaTextureSet2_worldCoords(KrayProtoHandle kph,const Symbol& m1,bool onOff);
KRAYCEXPORT(void) metaTextureSet3_wraping(KrayProtoHandle kph,const Symbol& m1,int wrapWidth,int wrapHeight);
KRAYCEXPORT(void) net0_ftp(KrayProtoHandle kph);
KRAYCEXPORT(void) net1u_ftp(KrayProtoHandle kph,const wchar_t* ftpRoot);
KRAYCEXPORT(void) net1_ftp(KrayProtoHandle kph,const char* ftpRoot);
KRAYCEXPORT(void) net2u_ftp(KrayProtoHandle kph,const wchar_t* ftpRoot,int port);
KRAYCEXPORT(void) net2_ftp(KrayProtoHandle kph,const char* ftpRoot,int port);
KRAYCEXPORT(void) net3u_ftp(KrayProtoHandle kph,const wchar_t* ftpRoot,int port,int flags);
KRAYCEXPORT(void) net3_ftp(KrayProtoHandle kph,const char* ftpRoot,int port,int flags);
KRAYCEXPORT(void) net0_server(KrayProtoHandle kph);
KRAYCEXPORT(void) net1u_server(KrayProtoHandle kph,const wchar_t* newInstanceCommandLine);
KRAYCEXPORT(void) net1_server(KrayProtoHandle kph,const char* newInstanceCommandLine);
KRAYCEXPORT(void) net2u_server(KrayProtoHandle kph,const wchar_t* newInstanceCommandLine,int port);
KRAYCEXPORT(void) net2_server(KrayProtoHandle kph,const char* newInstanceCommandLine,int port);
KRAYCEXPORT(void) net3u_server(KrayProtoHandle kph,const wchar_t* newInstanceCommandLine,int port,int flags);
KRAYCEXPORT(void) net3_server(KrayProtoHandle kph,const char* newInstanceCommandLine,int port,int flags);
KRAYCEXPORT(void) objectAdd4_and2(KrayProtoHandle kph,const Symbol& s2,const Symbol& s3,const Symbol& s4,const Symbol& b5);
KRAYCEXPORT(void) objectAdd5_circle(KrayProtoHandle kph,const Vector& position,const Vector& direction,double radius,const Symbol& s5,const Symbol& b6);
KRAYCEXPORT(void) objectAdd4_clipMap(KrayProtoHandle kph,const Symbol& s2,const Symbol& t3,const Symbol& s4,const Symbol& b5);
KRAYCEXPORT(void) objectAdd6_cone(KrayProtoHandle kph,const CoordSys& ori,double r1,double r2,double len,const Symbol& s6,const Symbol& b7);
KRAYCEXPORT(void) objectAdd12_dIntTriangle(KrayProtoHandle kph,const Vector& v2,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Symbol& d8,const Vector& v9,const Vector& v10,const Vector& v11,const Symbol& s12,const Symbol& b13);
KRAYCEXPORT(void) objectAdd12_dIntTriangleSs(KrayProtoHandle kph,const Vector& v2,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Symbol& d8,const Vector& v9,const Vector& v10,const Vector& v11,const Symbol& s12,const Symbol& b13);
KRAYCEXPORT(void) objectAdd3u_distanceField(KrayProtoHandle kph,const wchar_t* expression,const Symbol& s3,const Symbol& b4);
KRAYCEXPORT(void) objectAdd3_distanceField(KrayProtoHandle kph,const char* expression,const Symbol& s3,const Symbol& b4);
KRAYCEXPORT(void) objectAdd2_dQuad(KrayProtoHandle kph,int flags,const Symbol& d3);
KRAYCEXPORT(void) objectAdd7_dQuad(KrayProtoHandle kph,int flags,const Symbol& d3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8);
KRAYCEXPORT(void) objectAdd8_dQuad(KrayProtoHandle kph,int flags,const Symbol& d3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9);
KRAYCEXPORT(void) objectAdd12_dQuad(KrayProtoHandle kph,int flags,const Symbol& d3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9,const Vector& v10,const Vector& v11,const Symbol& s12,const Symbol& b13);
KRAYCEXPORT(void) objectAdd12_dTriangle(KrayProtoHandle kph,const Vector& v2,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Symbol& d8,const Vector& v9,const Vector& v10,const Vector& v11,const Symbol& s12,const Symbol& b13);
KRAYCEXPORT(void) objectAdd12_dTriangleSs(KrayProtoHandle kph,const Vector& v2,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Symbol& d8,const Vector& v9,const Vector& v10,const Vector& v11,const Symbol& s12,const Symbol& b13);
KRAYCEXPORT(void) objectAdd7_elipCone(KrayProtoHandle kph,const CoordSys& ori,double rx,double ry,double rz,double l,const Symbol& s7,const Symbol& b8);
KRAYCEXPORT(void) objectAdd7_elipParaboloid(KrayProtoHandle kph,const CoordSys& ori,double rx,double ry,double rz,double l,const Symbol& s7,const Symbol& b8);
KRAYCEXPORT(void) objectAdd7_elipTube(KrayProtoHandle kph,const CoordSys& ori,double rx,double ry,double rz,double l,const Symbol& s7,const Symbol& b8);
KRAYCEXPORT(void) objectAdd3_ellipsoid(KrayProtoHandle kph,const CoordSys& ori,const Symbol& s3,const Symbol& b4);
KRAYCEXPORT(void) objectAdd11_fibers(KrayProtoHandle kph,const Symbol& f2,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9,const Vector& v10,const Symbol& s11,const Symbol& b12);
KRAYCEXPORT(void) objectAdd9_intTriangle(KrayProtoHandle kph,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex,const Vector& normal0,const Vector& normal1,const Vector& normal2,const Symbol& s9,const Symbol& b10);
KRAYCEXPORT(void) objectAdd9_intTriangleSs(KrayProtoHandle kph,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex,const Vector& normal0,const Vector& normal1,const Vector& normal2,const Symbol& s9,const Symbol& b10);
KRAYCEXPORT(void) objectAdd3u_isoSurface(KrayProtoHandle kph,const wchar_t* expression,const Symbol& s3,const Symbol& b4);
KRAYCEXPORT(void) objectAdd3_isoSurface(KrayProtoHandle kph,const char* expression,const Symbol& s3,const Symbol& b4);
KRAYCEXPORT(void) objectAdd11_mandelBulb(KrayProtoHandle kph,const CoordSys& axes,int iterations,double escape_radius,double exponent,int max_ray_iterations,double error,double maxstep,double minstep,double steppower,const Symbol& s11,const Symbol& b12);
KRAYCEXPORT(void) objectAdd2_or2(KrayProtoHandle kph,const Symbol& s2,const Symbol& b3);
KRAYCEXPORT(void) objectAdd6_paraboloid(KrayProtoHandle kph,const CoordSys& ori,double r1,double r2,double len,const Symbol& s6,const Symbol& b7);
KRAYCEXPORT(void) objectAdd3_polygon(KrayProtoHandle kph,const VarLenVector& v2,const Symbol& s3,const Symbol& b4);
KRAYCEXPORT(void) objectAdd7_qJulia(KrayProtoHandle kph,const CoordSys& axes,const Vector& axisw,int iterations,double escape_radius,const Vector& v6,const Symbol& s7,const Symbol& b8);
KRAYCEXPORT(void) objectAdd3_rectangle(KrayProtoHandle kph,const Vector& cornerPosition,const Vector& deltaX,const Vector& deltaY);
KRAYCEXPORT(void) objectAdd6_rectangle(KrayProtoHandle kph,const Vector& cornerPosition,const Vector& deltaX,const Vector& deltaY,size_t uvIndex,const Symbol& s6,const Symbol& b7);
KRAYCEXPORT(void) objectAdd4_sphere(KrayProtoHandle kph,const Vector& v2,double d3,const Symbol& s4,const Symbol& b5);
KRAYCEXPORT(void) objectAdd4_sub2(KrayProtoHandle kph,const Symbol& s2,const Symbol& s3,const Symbol& s4,const Symbol& b5);
KRAYCEXPORT(void) objectAdd2_testShape(KrayProtoHandle kph,const Symbol& s2,const Symbol& b3);
KRAYCEXPORT(void) objectAdd5_triangle(KrayProtoHandle kph,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,const Symbol& s5,const Symbol& b6);
KRAYCEXPORT(void) objectAdd5_triangleSs(KrayProtoHandle kph,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,const Symbol& s5,const Symbol& b6);
KRAYCEXPORT(void) objectAdd5_tube(KrayProtoHandle kph,const CoordSys& ori,double r,double len,const Symbol& s5,const Symbol& b6);
KRAYCEXPORT(void) objectAdd3_uvTriangle(KrayProtoHandle kph,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2);
KRAYCEXPORT(void) objectAdd6_uvTriangle(KrayProtoHandle kph,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex,const Symbol& s6,const Symbol& b7);
KRAYCEXPORT(void) objectAdd6_uvTriangleSs(KrayProtoHandle kph,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex,const Symbol& s6,const Symbol& b7);
KRAYCEXPORT(void) objectAdd4_wall(KrayProtoHandle kph,const Vector& v2,const Vector& v3,const Symbol& s4,const Symbol& b5);
KRAYCEXPORT(void) objectInfo1(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) objectInfo2(KrayProtoHandle kph,const Symbol& s1,int mode);
KRAYCEXPORT(void) objectInfo3(KrayProtoHandle kph,const Symbol& s1,int mode,size_t param);
KRAYCEXPORT(void) oct3_build(KrayProtoHandle kph,double separation_threshold,const Vector& dontSplitRatios,const Vector& forceSplitRatios);
KRAYCEXPORT(void) oct0_explorer(KrayProtoHandle kph);
KRAYCEXPORT(void) oct1_explorer(KrayProtoHandle kph,const Vector& v2);
KRAYCEXPORT(void) oct1_flags(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) oct2_invalidate(KrayProtoHandle kph,const Vector& v2,const Vector& v3);
KRAYCEXPORT(void) oct2_limits(KrayProtoHandle kph,int recurse_max,double min_leaf_weight);
KRAYCEXPORT(void) oct0_show(KrayProtoHandle kph);
KRAYCEXPORT(void) oct1_show(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) oct2_show(KrayProtoHandle kph,int flags,int color_level);
KRAYCEXPORT(void) oct0_stats(KrayProtoHandle kph);
KRAYCEXPORT(void) oct1_stats(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) openCl2_deviceInfo(KrayProtoHandle kph,int platformindex,int deviceindex);
KRAYCEXPORT(void) openCl0_devices(KrayProtoHandle kph);
KRAYCEXPORT(void) openCl1_devices(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) openCl2_devices(KrayProtoHandle kph,int d2,int d3);
KRAYCEXPORT(void) openCl3_devices(KrayProtoHandle kph,int d2,int d3,int d4);
KRAYCEXPORT(void) openCl1_platformInfo(KrayProtoHandle kph,int platformindex);
KRAYCEXPORT(void) openCl0_platforms(KrayProtoHandle kph);
KRAYCEXPORT(void) parse1u(KrayProtoHandle kph,const wchar_t* commands);
KRAYCEXPORT(void) parse1(KrayProtoHandle kph,const char* commands);
KRAYCEXPORT(void) parse2u(KrayProtoHandle kph,const wchar_t* commands,const wchar_t* name);
KRAYCEXPORT(void) parse2(KrayProtoHandle kph,const char* commands,const char* name);
KRAYCEXPORT(void) parseMode1(KrayProtoHandle kph,int mode);
KRAYCEXPORT(void) pause0(KrayProtoHandle kph);
KRAYCEXPORT(void) pause1(KrayProtoHandle kph,double seconds);
KRAYCEXPORT(void) platform0_mem_flush(KrayProtoHandle kph);
KRAYCEXPORT(void) platform1_mem_markerSet(KrayProtoHandle kph,int marker);
KRAYCEXPORT(void) platform0_mem_markerStats(KrayProtoHandle kph);
KRAYCEXPORT(void) platform0_mem_show(KrayProtoHandle kph);
KRAYCEXPORT(void) platform1_mem_show(KrayProtoHandle kph,int marker);
KRAYCEXPORT(void) platform0_mem_stats(KrayProtoHandle kph);
KRAYCEXPORT(void) platform1u_options(KrayProtoHandle kph,const wchar_t* option_string);
KRAYCEXPORT(void) platform1_options(KrayProtoHandle kph,const char* option_string);
KRAYCEXPORT(void) platform0_test(KrayProtoHandle kph);
KRAYCEXPORT(void) platform1_test(KrayProtoHandle kph,int testId);
KRAYCEXPORT(void) pm1_auto_caustics(KrayProtoHandle kph,int samples);
KRAYCEXPORT(void) pm2_auto_caustics(KrayProtoHandle kph,int samples,double minFilterBound);
KRAYCEXPORT(void) pm4_auto_caustics(KrayProtoHandle kph,int samples,double minFilterBound,double maxFilterBound,double relativeStep);
KRAYCEXPORT(void) pm5_auto_caustics(KrayProtoHandle kph,int samples,double minFilterBound,double maxFilterBound,double relativeStep,double reSize);
KRAYCEXPORT(void) pm6_auto_caustics(KrayProtoHandle kph,int samples,double minFilterBound,double maxFilterBound,double relativeStep,double reSize,double giveUpSearchIfZeroFound);
KRAYCEXPORT(void) pm1_auto_global(KrayProtoHandle kph,int samples);
KRAYCEXPORT(void) pm2_auto_global(KrayProtoHandle kph,int samples,double minFilterBound);
KRAYCEXPORT(void) pm4_auto_global(KrayProtoHandle kph,int samples,double minFilterBound,double maxFilterBound,double relativeStep);
KRAYCEXPORT(void) pm5_auto_global(KrayProtoHandle kph,int samples,double minFilterBound,double maxFilterBound,double relativeStep,double reSize);
KRAYCEXPORT(void) pm1_auto_gScaleCaustics(KrayProtoHandle kph,double d3);
KRAYCEXPORT(void) pm2_auto_gScaleCaustics(KrayProtoHandle kph,double d3,double causticsFromAutoGlobalScale);
KRAYCEXPORT(void) pm1_auto_gScalePrecached(KrayProtoHandle kph,double d3);
KRAYCEXPORT(void) pm2_auto_gScalePrecached(KrayProtoHandle kph,double d3,double precachedFromAutoGlobalScale);
KRAYCEXPORT(void) pm1_causticsBuild(KrayProtoHandle kph,double photons);
KRAYCEXPORT(void) pm2_causticsBuild(KrayProtoHandle kph,double photons,double photonSamples);
KRAYCEXPORT(void) pm1_causticsFlags(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) pm2_causticsFlags(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) pm1_causticsMultiplier(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm1_causticsRrValue(KrayProtoHandle kph,double rr);
KRAYCEXPORT(void) pm1_causticsSearch(KrayProtoHandle kph,int minPhotons);
KRAYCEXPORT(void) pm2_causticsSearch(KrayProtoHandle kph,int minPhotons,double minFilterSize);
KRAYCEXPORT(void) pm3_causticsSearch(KrayProtoHandle kph,int minPhotons,double minFilterSize,double maxFilterSize);
KRAYCEXPORT(void) pm4_causticsSearch(KrayProtoHandle kph,int minPhotons,double minFilterSize,double maxFilterSize,double steps);
KRAYCEXPORT(void) pm5_causticsSearch(KrayProtoHandle kph,int minPhotons,double minFilterSize,double maxFilterSize,double steps,double giveUpSearchIfZeroFound);
KRAYCEXPORT(void) pm1_globalBuild(KrayProtoHandle kph,double photons);
KRAYCEXPORT(void) pm2_globalBuild(KrayProtoHandle kph,double photons,double photonSamples);
KRAYCEXPORT(void) pm1_globalBuildLightMap(KrayProtoHandle kph,double photons);
KRAYCEXPORT(void) pm2_globalBuildLightMap(KrayProtoHandle kph,double photons,double photonSamples);
KRAYCEXPORT(void) pm1_globalBuildLightMapWithCaustics(KrayProtoHandle kph,double photons);
KRAYCEXPORT(void) pm2_globalBuildLightMapWithCaustics(KrayProtoHandle kph,double photons,double photonSamples);
KRAYCEXPORT(void) pm1_globalFlags(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) pm2_globalFlags(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) pm1_globalMultiplier(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm1_globalSearch(KrayProtoHandle kph,int minPhotons);
KRAYCEXPORT(void) pm2_globalSearch(KrayProtoHandle kph,int minPhotons,double minFilterSize);
KRAYCEXPORT(void) pm3_globalSearch(KrayProtoHandle kph,int minPhotons,double minFilterSize,double maxFilterSize);
KRAYCEXPORT(void) pm4_globalSearch(KrayProtoHandle kph,int minPhotons,double minFilterSize,double maxFilterSize,double steps);
KRAYCEXPORT(void) pm1_kdBalance(KrayProtoHandle kph,size_t kdBalanceMaxPhotons);
KRAYCEXPORT(void) pm2_kdBalance(KrayProtoHandle kph,size_t kdBalanceMaxPhotons,double kdBalanceBadSplitTolerance);
KRAYCEXPORT(void) pm1_kdOptimize(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) pm1_lmAnim(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) pm1_lmImportance(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm1_photonNormal(KrayProtoHandle kph,double photonNormalDist);
KRAYCEXPORT(void) pm1_precachedBlur(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm1_precachedBuild(KrayProtoHandle kph,int precacheEvery);
KRAYCEXPORT(void) pm2_precachedBuild(KrayProtoHandle kph,int precacheEvery,double precacheMinDistToFilterSizeRatio);
KRAYCEXPORT(void) pm1_precachedCorner(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm1_precachedFlags(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) pm2_precachedFlags(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) pm1_precachedSearch(KrayProtoHandle kph,double minFilterSize);
KRAYCEXPORT(void) pm1_precacheLimitdr(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm1_receivedMinHitRatio(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm1_removeUnused(KrayProtoHandle kph,bool removePhotonMapsUsedForInitOnly);
KRAYCEXPORT(void) pm0_render(KrayProtoHandle kph);
KRAYCEXPORT(void) pm1_render(KrayProtoHandle kph,int mapsMask);
KRAYCEXPORT(void) pm0_reset(KrayProtoHandle kph);
KRAYCEXPORT(void) pm1_reset(KrayProtoHandle kph,int mask);
KRAYCEXPORT(void) pm1_showPreview(KrayProtoHandle kph,bool showPhotonPreview);
KRAYCEXPORT(void) pm1_smoothPrecacheScale(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) pm0_stats(KrayProtoHandle kph);
KRAYCEXPORT(void) pm1_timePrecached(KrayProtoHandle kph,double ca0);
KRAYCEXPORT(void) pm2_timePrecached(KrayProtoHandle kph,double ca0,const VarLenVector& cab1);
KRAYCEXPORT(void) portalAdd2u_lightId(KrayProtoHandle kph,const Symbol& l2,const wchar_t* s3);
KRAYCEXPORT(void) portalAdd2_lightId(KrayProtoHandle kph,const Symbol& l2,const char* s3);
KRAYCEXPORT(void) portalAdd3u_shapeSelectionId_caustics(KrayProtoHandle kph,const Symbol& s2,const wchar_t* s3,double weight);
KRAYCEXPORT(void) portalAdd3_shapeSelectionId_caustics(KrayProtoHandle kph,const Symbol& s2,const char* s3,double weight);
KRAYCEXPORT(void) portalAdd3u_shapeSelectionId_global(KrayProtoHandle kph,const Symbol& s2,const wchar_t* s3,double weight);
KRAYCEXPORT(void) portalAdd3_shapeSelectionId_global(KrayProtoHandle kph,const Symbol& s2,const char* s3,double weight);
KRAYCEXPORT(void) portalAdd3_sShapeSelectionLight_caustics(KrayProtoHandle kph,const Symbol& s2,const Symbol& l3,double weight);
KRAYCEXPORT(void) portalAdd3_sShapeSelectionLight_global(KrayProtoHandle kph,const Symbol& s2,const Symbol& l3,double weight);
KRAYCEXPORT(void) postProcess1_add(KrayProtoHandle kph,const Vector& v2);
KRAYCEXPORT(void) postProcess1_autoExp(KrayProtoHandle kph,double blend);
KRAYCEXPORT(void) postProcess3_bitmapOverlay(KrayProtoHandle kph,int x,int y,const BitmapSymbol& b4);
KRAYCEXPORT(void) postProcess4_ca(KrayProtoHandle kph,double strength,double pixel_aspect,double aberationGamma,int samples);
KRAYCEXPORT(void) postProcess1_desaturate(KrayProtoHandle kph,double value);
KRAYCEXPORT(void) postProcess4_dof(KrayProtoHandle kph,double distance,double depth,int maxsize,const BitmapSymbol& irisImage);
KRAYCEXPORT(void) postProcess1_erode(KrayProtoHandle kph,int strength);
KRAYCEXPORT(void) postProcess2_erodeAlpha(KrayProtoHandle kph,double level,int steps);
KRAYCEXPORT(void) postProcess1_filter(KrayProtoHandle kph,const VarLenDouble& mask);
KRAYCEXPORT(void) postProcess1_gamma(KrayProtoHandle kph,double value);
KRAYCEXPORT(void) postProcess1_gBlur(KrayProtoHandle kph,double size);
KRAYCEXPORT(void) postProcess2_gBlur(KrayProtoHandle kph,double size,double blend);
KRAYCEXPORT(void) postProcess3_gBlur(KrayProtoHandle kph,double size,double blend,double cutOff);
KRAYCEXPORT(void) postProcess3_glow(KrayProtoHandle kph,double strength,double size,const BitmapSymbol& b4);
KRAYCEXPORT(void) postProcess2_histogramFix(KrayProtoHandle kph,double low,double high);
KRAYCEXPORT(void) postProcess1_mult(KrayProtoHandle kph,const Vector& filter);
KRAYCEXPORT(void) postProcess1u_saveImage(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess1u_saveImage_bmp(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage_bmp(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess2u_saveImage_bmp(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) postProcess2_saveImage_bmp(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) postProcess1u_saveImage_exr(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage_exr(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess1u_saveImage_hdr(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage_hdr(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess1u_saveImage_jpg(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage_jpg(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess2u_saveImage_jpg(KrayProtoHandle kph,const wchar_t* filename,double quality);
KRAYCEXPORT(void) postProcess2_saveImage_jpg(KrayProtoHandle kph,const char* filename,double quality);
KRAYCEXPORT(void) postProcess1u_saveImage_png(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage_png(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess2u_saveImage_png(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) postProcess2_saveImage_png(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) postProcess1u_saveImage_tga(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage_tga(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess2u_saveImage_tga(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) postProcess2_saveImage_tga(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) postProcess1u_saveImage_tif(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveImage_tif(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess2u_saveImage_tif(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) postProcess2_saveImage_tif(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) postProcess1u_saveNormal(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveNormal(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess1u_saveZ(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) postProcess1_saveZ(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) postProcess1_setDirectionsMapFormat(KrayProtoHandle kph,bool compress);
KRAYCEXPORT(void) postProcess2_setDirectionsMapFormat(KrayProtoHandle kph,bool compress,bool d3);
KRAYCEXPORT(void) postProcess1_shader(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) postProcess2_stereogram(KrayProtoHandle kph,const BitmapSymbol& b2,int patternPositon);
KRAYCEXPORT(void) postProcess3_stereogram(KrayProtoHandle kph,const BitmapSymbol& b2,int patternPositon,int randomSeed);
KRAYCEXPORT(void) postProcess1_trimAlpha(KrayProtoHandle kph,int steps);
KRAYCEXPORT(void) pv0_flayer(KrayProtoHandle kph);
KRAYCEXPORT(void) pv1_flayer(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) pv2_flayer(KrayProtoHandle kph,int flags,double flySpeed);
KRAYCEXPORT(void) pv3_flayer(KrayProtoHandle kph,int flags,double flySpeed,double mouseSensitivity);
KRAYCEXPORT(void) pv1_iterativeWaitLevel(KrayProtoHandle kph,int level);
KRAYCEXPORT(void) pv2_iterativeWaitLevel(KrayProtoHandle kph,int level,double seconds);
KRAYCEXPORT(void) pv0_none(KrayProtoHandle kph);
KRAYCEXPORT(void) pv0_on(KrayProtoHandle kph);
KRAYCEXPORT(void) pv0_pause(KrayProtoHandle kph);
KRAYCEXPORT(void) pv0_pauseSignal(KrayProtoHandle kph);
KRAYCEXPORT(void) pv0_rasterize(KrayProtoHandle kph);
KRAYCEXPORT(void) pv1_rasterize(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) pv0_raycast(KrayProtoHandle kph);
KRAYCEXPORT(void) pv1_raycast(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) pv0_raytrace(KrayProtoHandle kph);
KRAYCEXPORT(void) pv2_raytrace(KrayProtoHandle kph,int flags,int maxPixelSize);
KRAYCEXPORT(void) pv0_render(KrayProtoHandle kph);
KRAYCEXPORT(void) pv0_restart(KrayProtoHandle kph);
KRAYCEXPORT(void) pv1_setAnimMode(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) pv1_setAutoRestart(KrayProtoHandle kph,bool state);
KRAYCEXPORT(void) pv1_setDelay(KrayProtoHandle kph,double delay);
KRAYCEXPORT(void) pv1_setWeight(KrayProtoHandle kph,double weight);
KRAYCEXPORT(void) pv0_start(KrayProtoHandle kph);
KRAYCEXPORT(void) pv0_stop(KrayProtoHandle kph);
KRAYCEXPORT(void) pv1_waitLevel(KrayProtoHandle kph,int level);
KRAYCEXPORT(void) pv2_waitLevel(KrayProtoHandle kph,int level,double seconds);
KRAYCEXPORT(void) rayCast2_camera(KrayProtoHandle kph,const Vector& dofPosition,const BitmapSymbol& directionMap);
KRAYCEXPORT(void) rayCast3_camera(KrayProtoHandle kph,const Vector& dofPosition,const BitmapSymbol& directionMap,const BitmapSymbol& positionMap);
KRAYCEXPORT(void) rayCast4_camera(KrayProtoHandle kph,const Vector& dofPosition,const BitmapSymbol& directionMap,const BitmapSymbol& positionMap,const BitmapSymbol& weightMap);
KRAYCEXPORT(void) rayCast0_cameraHit(KrayProtoHandle kph);
KRAYCEXPORT(void) rayCast1_cameraHit(KrayProtoHandle kph,const BitmapSymbol& zBufferResult);
KRAYCEXPORT(void) rayCast2_cameraHit(KrayProtoHandle kph,const BitmapSymbol& zBufferResult,const Vector& v3);
KRAYCEXPORT(void) rayCast0_cameraZ(KrayProtoHandle kph);
KRAYCEXPORT(void) rayCast1_cameraZ(KrayProtoHandle kph,const BitmapSymbol& zBufferResult);
KRAYCEXPORT(void) rayCast2_cameraZ(KrayProtoHandle kph,const BitmapSymbol& zBufferResult,const Vector& v3);
KRAYCEXPORT(void) rayCast2_hitToNormalQuick(KrayProtoHandle kph,const BitmapSymbol& normalMapResult,const BitmapSymbol& hitMap);
KRAYCEXPORT(void) rayCast0_init(KrayProtoHandle kph);
KRAYCEXPORT(void) rayCast3_z(KrayProtoHandle kph,const BitmapSymbol& zBufferResult,const BitmapSymbol& directionMap,const BitmapSymbol& positionMap);
KRAYCEXPORT(void) rayCast4_zToHit(KrayProtoHandle kph,const BitmapSymbol& hitMapResult,const BitmapSymbol& zBuffer,const BitmapSymbol& directionMap,const BitmapSymbol& positionMap);
KRAYCEXPORT(void) reference2(KrayProtoHandle kph,Symbol& s1,const Symbol& s2);
KRAYCEXPORT(void) rem0(KrayProtoHandle kph);
KRAYCEXPORT(void) render0(KrayProtoHandle kph);
KRAYCEXPORT(void) reset0(KrayProtoHandle kph);
KRAYCEXPORT(void) return0(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_aRecurse(KrayProtoHandle kph,int recursion_maxacrays);
KRAYCEXPORT(void) sett1_aWeight(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) sett4_bitmapPixelCompression(KrayProtoHandle kph,int hdr,int color,int alpha,int halfSizeSteps);
KRAYCEXPORT(void) sett1_buffersMask(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) sett2_buffersMask(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) sett1_debug(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) sett2_debug(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) sett1_debugExecute(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) sett2u_debugExecute(KrayProtoHandle kph,int d2,const wchar_t* s3);
KRAYCEXPORT(void) sett2_debugExecute(KrayProtoHandle kph,int d2,const char* s3);
KRAYCEXPORT(void) sett3u_debugExecute(KrayProtoHandle kph,int d2,const wchar_t* s3,double d4);
KRAYCEXPORT(void) sett3_debugExecute(KrayProtoHandle kph,int d2,const char* s3,double d4);
KRAYCEXPORT(void) sett4u_debugExecute(KrayProtoHandle kph,int d2,const wchar_t* s3,double d4,const wchar_t* s5);
KRAYCEXPORT(void) sett4_debugExecute(KrayProtoHandle kph,int d2,const char* s3,double d4,const char* s5);
KRAYCEXPORT(void) sett5u_debugExecute(KrayProtoHandle kph,int d2,const wchar_t* s3,double d4,const wchar_t* s5,double d6);
KRAYCEXPORT(void) sett5_debugExecute(KrayProtoHandle kph,int d2,const char* s3,double d4,const char* s5,double d6);
KRAYCEXPORT(void) sett1_debugTestValue(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) sett0_dither_floydSteinberg(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_dither_qRandom(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_dither_random(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_dither_simple(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_ditherAmplitude(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) sett1_edgeDetector(KrayProtoHandle kph,double absolutePixel);
KRAYCEXPORT(void) sett2_edgeDetector(KrayProtoHandle kph,double absolutePixel,double relativePixel);
KRAYCEXPORT(void) sett3_edgeDetector(KrayProtoHandle kph,double absolutePixel,double relativePixel,double normal);
KRAYCEXPORT(void) sett4_edgeDetector(KrayProtoHandle kph,double absolutePixel,double relativePixel,double normal,double zBuffer);
KRAYCEXPORT(void) sett5_edgeDetector(KrayProtoHandle kph,double absolutePixel,double relativePixel,double normal,double zBuffer,int enhancedAA);
KRAYCEXPORT(void) sett6_edgeDetector(KrayProtoHandle kph,double absolutePixel,double relativePixel,double normal,double zBuffer,int enhancedAA,double maxPixelBrightness);
KRAYCEXPORT(void) sett7_edgeDetector(KrayProtoHandle kph,double absolutePixel,double relativePixel,double normal,double zBuffer,int enhancedAA,double maxPixelBrightness,int upsample);
KRAYCEXPORT(void) sett2_edgeDetectorGlobals(KrayProtoHandle kph,int enhancedAA,int upsample);
KRAYCEXPORT(void) sett6_edgeDetectorSlot(KrayProtoHandle kph,int index,double absolutePixel,double relativePixel,double normal,double zBuffer,double maxPixelBrightness);
KRAYCEXPORT(void) sett1_energetic(KrayProtoHandle kph,int nrg_iterations);
KRAYCEXPORT(void) sett0_failBitmap(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_failBitmap(KrayProtoHandle kph,const BitmapSymbol& b2);
KRAYCEXPORT(void) sett0_imageSampler_none(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_imageSampler_qmcAdaptive(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_imageSampler_qmcAdaptive(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett2_imageSampler_qmcAdaptive(KrayProtoHandle kph,int minSamples,int maxSamples);
KRAYCEXPORT(void) sett3_imageSampler_qmcAdaptive(KrayProtoHandle kph,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) sett1_imageSampler_rotUniform(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett2_imageSampler_totalMbRandom(KrayProtoHandle kph,int minSamples,int maxSamples);
KRAYCEXPORT(void) sett1_imageSampler_totalQmc(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett0_imageSampler_totalQmcAdaptive(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_imageSampler_totalQmcAdaptive(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett2_imageSampler_totalQmcAdaptive(KrayProtoHandle kph,int minSamples,int maxSamples);
KRAYCEXPORT(void) sett3_imageSampler_totalQmcAdaptive(KrayProtoHandle kph,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) sett1_imageSampler_totalRandom(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett1_imageSampler_totalRotUniform(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett1_imageSampler_totalUniform(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett1_imageSampler_uniform(KrayProtoHandle kph,int minSamples);
KRAYCEXPORT(void) sett1_imageSamplerMultiPass(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) sett1_instanceOctreeWeight(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) sett1_instanceRecurse(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) sett1_lightRaysShadowCheck(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) sett1u_logFile(KrayProtoHandle kph,const wchar_t* logFile);
KRAYCEXPORT(void) sett1_logFile(KrayProtoHandle kph,const char* logFile);
KRAYCEXPORT(void) sett2u_logFile(KrayProtoHandle kph,const wchar_t* logFile,bool logTime);
KRAYCEXPORT(void) sett2_logFile(KrayProtoHandle kph,const char* logFile,bool logTime);
KRAYCEXPORT(void) sett3u_logFile(KrayProtoHandle kph,const wchar_t* logFile,bool logTime,bool logAppend);
KRAYCEXPORT(void) sett3_logFile(KrayProtoHandle kph,const char* logFile,bool logTime,bool logAppend);
KRAYCEXPORT(void) sett1_maxRayColor(KrayProtoHandle kph,const Vector& max_ray_col);
KRAYCEXPORT(void) sett2_mipMap(KrayProtoHandle kph,double mipMapLevelShift,int maxSamples);
KRAYCEXPORT(void) sett1_miscBufOrder(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) sett0_outputFormat_bmp(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_outputFormat_bmp(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) sett0_outputFormat_exr(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_outputFormat_hdr(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_outputFormat_jpg(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_outputFormat_jpg(KrayProtoHandle kph,double quality);
KRAYCEXPORT(void) sett0_outputFormat_png(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_outputFormat_png(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) sett0_outputFormat_tga(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_outputFormat_tga(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) sett0_outputFormat_tif(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_outputFormat_tif(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) sett0_outputTo(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1u_outputTo(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett1u_outputTo_bmp(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo_bmp(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett2u_outputTo_bmp(KrayProtoHandle kph,const wchar_t* s2,int flags);
KRAYCEXPORT(void) sett2_outputTo_bmp(KrayProtoHandle kph,const char* s2,int flags);
KRAYCEXPORT(void) sett1u_outputTo_exr(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo_exr(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett1u_outputTo_hdr(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo_hdr(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett1u_outputTo_jpg(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo_jpg(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett2u_outputTo_jpg(KrayProtoHandle kph,const wchar_t* s2,double quality);
KRAYCEXPORT(void) sett2_outputTo_jpg(KrayProtoHandle kph,const char* s2,double quality);
KRAYCEXPORT(void) sett1u_outputTo_png(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo_png(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett2u_outputTo_png(KrayProtoHandle kph,const wchar_t* s2,int flags);
KRAYCEXPORT(void) sett2_outputTo_png(KrayProtoHandle kph,const char* s2,int flags);
KRAYCEXPORT(void) sett1u_outputTo_tga(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo_tga(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett2u_outputTo_tga(KrayProtoHandle kph,const wchar_t* s2,int flags);
KRAYCEXPORT(void) sett2_outputTo_tga(KrayProtoHandle kph,const char* s2,int flags);
KRAYCEXPORT(void) sett1u_outputTo_tif(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_outputTo_tif(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett2u_outputTo_tif(KrayProtoHandle kph,const wchar_t* s2,int flags);
KRAYCEXPORT(void) sett2_outputTo_tif(KrayProtoHandle kph,const char* s2,int flags);
KRAYCEXPORT(void) sett1_outsideSize(KrayProtoHandle kph,double d2);
KRAYCEXPORT(void) sett1_pixelBufOrder(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) sett1_pixelFilter_box(KrayProtoHandle kph,double d3);
KRAYCEXPORT(void) sett0_pixelFilter_catmull(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_pixelFilter_cone(KrayProtoHandle kph,double d3);
KRAYCEXPORT(void) sett1_pixelFilter_cubic(KrayProtoHandle kph,double d3);
KRAYCEXPORT(void) sett1_pixelFilter_lanczos(KrayProtoHandle kph,double d3);
KRAYCEXPORT(void) sett0_pixelFilter_mitchell(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_pixelFilter_quadric(KrayProtoHandle kph,double d3);
KRAYCEXPORT(void) sett0_pixelFilter_spline(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_pixelOrder_flood(KrayProtoHandle kph,const BitmapSymbol& b3);
KRAYCEXPORT(void) sett2_pixelOrder_flood(KrayProtoHandle kph,const BitmapSymbol& b3,int flags);
KRAYCEXPORT(void) sett3_pixelOrder_flood(KrayProtoHandle kph,const BitmapSymbol& b3,int flags,double jitter);
KRAYCEXPORT(void) sett0_pixelOrder_frost(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_pixelOrder_progressive(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_pixelOrder_random(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_pixelOrder_random(KrayProtoHandle kph,double randomRange);
KRAYCEXPORT(void) sett0_pixelOrder_ripples(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_pixelOrder_ripples(KrayProtoHandle kph,const Vector& position);
KRAYCEXPORT(void) sett0_pixelOrder_scanLine(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_pixelOrder_scanRow(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_pixelOrder_worm(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_previewSize(KrayProtoHandle kph,const Vector& maxSize);
KRAYCEXPORT(void) sett0_rayDiff(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_recurse(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) sett1u_renderInfo(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) sett1_renderInfo(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) sett2_renderInfoSize(KrayProtoHandle kph,double renderInfoPercent,int renderInfoBorder);
KRAYCEXPORT(void) sett0_renderMode_mlt(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_renderMode_mlt(KrayProtoHandle kph,size_t d3);
KRAYCEXPORT(void) sett2_renderMode_mlt(KrayProtoHandle kph,size_t d3,int d4);
KRAYCEXPORT(void) sett0_renderMode_raytrace(KrayProtoHandle kph);
KRAYCEXPORT(void) sett1_semaphoreFileTryDelete(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) sett1_splitScreen_auto_flood(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett1_splitScreen_auto_frost(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett1_splitScreen_auto_progressive(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett1_splitScreen_auto_random(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett1_splitScreen_auto_ripples(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett1_splitScreen_auto_scanLine(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett1_splitScreen_auto_scanRow(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett1_splitScreen_auto_worm(KrayProtoHandle kph,int splitsperthread);
KRAYCEXPORT(void) sett0_splitScreen_betterAuto(KrayProtoHandle kph);
KRAYCEXPORT(void) sett0_splitScreen_none(KrayProtoHandle kph);
KRAYCEXPORT(void) sett2_splitScreen_parts_flood(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_parts_frost(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_parts_progressive(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_parts_random(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_parts_ripples(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_parts_scanLine(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_parts_scanRow(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_parts_worm(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_flood(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_frost(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_progressive(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_random(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_ripples(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_scanLine(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_scanRow(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett2_splitScreen_size_worm(KrayProtoHandle kph,int sizx,int sizy);
KRAYCEXPORT(void) sett4_sssErr(KrayProtoHandle kph,double d2,double d3,double d4,double d5);
KRAYCEXPORT(void) sett2_sssOct(KrayProtoHandle kph,int sss_samples_per_leaf,int sss_max_rec_level);
KRAYCEXPORT(void) sett1_subframeRecomputeFlags(KrayProtoHandle kph,int bitFlags);
KRAYCEXPORT(void) sett2_subframeRecomputeFlags(KrayProtoHandle kph,int bitFlags,int mask);
KRAYCEXPORT(void) sett1_threadMinSplit(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) sett1_toneMapping_edge(KrayProtoHandle kph,const Symbol& s3);
KRAYCEXPORT(void) sett1_toneMapping_ray(KrayProtoHandle kph,const Symbol& s3);
KRAYCEXPORT(void) sett4_toneMapping_z_inverse(KrayProtoHandle kph,double d4,double d5,double d6,double d7);
KRAYCEXPORT(void) sett4_toneMapping_z_linear(KrayProtoHandle kph,double d4,double d5,double d6,double d7);
KRAYCEXPORT(void) sett4_toneMapping_z_log(KrayProtoHandle kph,double d4,double d5,double d6,double d7);
KRAYCEXPORT(void) sett3_underSample(KrayProtoHandle kph,int undersampleLevel,double threshold,bool edge);
KRAYCEXPORT(void) sett1_undersamplePrerender(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) sett1_vrPrerender(KrayProtoHandle kph,int d2);
KRAYCEXPORT(void) shaderNode2_background_color(KrayProtoHandle kph,Symbol& s1,const Vector& color);
KRAYCEXPORT(void) shaderNode1_background_directionsMap(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shaderNode3_background_fishEyeMap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b4,const Axes& a5);
KRAYCEXPORT(void) shaderNode2_background_phySky(KrayProtoHandle kph,Symbol& s1,const Symbol& s4);
KRAYCEXPORT(void) shaderNode3_background_phySky(KrayProtoHandle kph,Symbol& s1,const Symbol& s4,double alphaChannelValue);
KRAYCEXPORT(void) shaderNode4_background_phySky(KrayProtoHandle kph,Symbol& s1,const Symbol& s4,double alphaChannelValue,int envFlags);
KRAYCEXPORT(void) shaderNode2_background_phySkyEnv(KrayProtoHandle kph,Symbol& s1,const Symbol& s4);
KRAYCEXPORT(void) shaderNode3_background_phySkyEnv(KrayProtoHandle kph,Symbol& s1,const Symbol& s4,double alphaChannelValue);
KRAYCEXPORT(void) shaderNode4_background_phySkyEnv(KrayProtoHandle kph,Symbol& s1,const Symbol& s4,double alphaChannelValue,int envFlags);
KRAYCEXPORT(void) shaderNode2_background_shader(KrayProtoHandle kph,Symbol& s1,const Symbol& s4);
KRAYCEXPORT(void) shaderNode1_background_sky(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shaderNode2_background_sky(KrayProtoHandle kph,Symbol& s1,const Vector& zenithDirection);
KRAYCEXPORT(void) shaderNode5_background_sky(KrayProtoHandle kph,Symbol& s1,const Vector& zenithDirection,const Vector& horizon,const Vector& zenith,const Vector& nadir);
KRAYCEXPORT(void) shaderNode6_background_sky(KrayProtoHandle kph,Symbol& s1,const Vector& zenithDirection,const Vector& horizon,const Vector& zenith,const Vector& nadir,const Vector& horizonNadir);
KRAYCEXPORT(void) shaderNode8_background_sky(KrayProtoHandle kph,Symbol& s1,const Vector& zenithDirection,const Vector& horizon,const Vector& zenith,const Vector& nadir,const Vector& horizonNadir,double skyGamma,double groundGamma);
KRAYCEXPORT(void) shaderNode3_background_sphereMap(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b4,const Axes& a5);
KRAYCEXPORT(void) shaderNode2_chain(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3);
KRAYCEXPORT(void) shaderNode3_colorFilter(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Vector& color);
KRAYCEXPORT(void) shaderNode1_dummy(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shaderNode2_environment_colorFade(KrayProtoHandle kph,Symbol& s1,const Vector& exponentialFilter);
KRAYCEXPORT(void) shaderNode3_environment_phySky(KrayProtoHandle kph,Symbol& s1,const Symbol& s4,int flags);
KRAYCEXPORT(void) shaderNode2_environment_shader(KrayProtoHandle kph,Symbol& s1,const Symbol& s4);
KRAYCEXPORT(void) shaderNode2_extractAlpha(KrayProtoHandle kph,Symbol& s1,const Symbol& node);
KRAYCEXPORT(void) shaderNode4_extractAlpha(KrayProtoHandle kph,Symbol& s1,const Symbol& node,double rangeStart,double rangeStop);
KRAYCEXPORT(void) shaderNode5_extractAlpha(KrayProtoHandle kph,Symbol& s1,const Symbol& node,double rangeStart,double rangeStop,double alphaDefault);
KRAYCEXPORT(void) shaderNode3_fromMeshTag(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m,size_t polygonTag);
KRAYCEXPORT(void) shaderNode3u_fromMeshTagName(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m,const wchar_t* polygonTagName);
KRAYCEXPORT(void) shaderNode3_fromMeshTagName(KrayProtoHandle kph,Symbol& s1,const MeshSymbol& m,const char* polygonTagName);
KRAYCEXPORT(void) shaderNode3_giDesaturate(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double desaturate);
KRAYCEXPORT(void) shaderNode4_giDesaturate(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double desaturate,double multiplier);
KRAYCEXPORT(void) shaderNode5_giDesaturate(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double desaturate,double multiplier,double dynamicRangeLimit);
KRAYCEXPORT(void) shaderNode2_lowLevel(KrayProtoHandle kph,Symbol& s1,Symbol& s3);
KRAYCEXPORT(void) shaderNode2_mix(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3);
KRAYCEXPORT(void) shaderNode3_mix(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenVector& v4);
KRAYCEXPORT(void) shaderNode2_postProcess_add(KrayProtoHandle kph,Symbol& s1,const Vector& v4);
KRAYCEXPORT(void) shaderNode2_postProcess_autoExp(KrayProtoHandle kph,Symbol& s1,double blend);
KRAYCEXPORT(void) shaderNode4_postProcess_bitmapOverlay(KrayProtoHandle kph,Symbol& s1,int x,int y,const BitmapSymbol& b6);
KRAYCEXPORT(void) shaderNode5_postProcess_ca(KrayProtoHandle kph,Symbol& s1,double strength,double pixel_aspect,double aberationGamma,int samples);
KRAYCEXPORT(void) shaderNode2_postProcess_desaturate(KrayProtoHandle kph,Symbol& s1,double value);
KRAYCEXPORT(void) shaderNode5_postProcess_dof(KrayProtoHandle kph,Symbol& s1,double distance,double depth,int maxsize,const BitmapSymbol& irisImage);
KRAYCEXPORT(void) shaderNode2_postProcess_erode(KrayProtoHandle kph,Symbol& s1,int strength);
KRAYCEXPORT(void) shaderNode3_postProcess_erodeAlpha(KrayProtoHandle kph,Symbol& s1,double level,int steps);
KRAYCEXPORT(void) shaderNode2_postProcess_filter(KrayProtoHandle kph,Symbol& s1,const VarLenDouble& mask);
KRAYCEXPORT(void) shaderNode2_postProcess_gamma(KrayProtoHandle kph,Symbol& s1,double value);
KRAYCEXPORT(void) shaderNode2_postProcess_gBlur(KrayProtoHandle kph,Symbol& s1,double size);
KRAYCEXPORT(void) shaderNode3_postProcess_gBlur(KrayProtoHandle kph,Symbol& s1,double size,double blend);
KRAYCEXPORT(void) shaderNode4_postProcess_gBlur(KrayProtoHandle kph,Symbol& s1,double size,double blend,double cutOff);
KRAYCEXPORT(void) shaderNode4_postProcess_glow(KrayProtoHandle kph,Symbol& s1,double strength,double size,const BitmapSymbol& b6);
KRAYCEXPORT(void) shaderNode3_postProcess_histogramFix(KrayProtoHandle kph,Symbol& s1,double low,double high);
KRAYCEXPORT(void) shaderNode2_postProcess_mult(KrayProtoHandle kph,Symbol& s1,const Vector& filter);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage_bmp(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage_bmp(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode3u_postProcess_saveImage_bmp(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) shaderNode3_postProcess_saveImage_bmp(KrayProtoHandle kph,Symbol& s1,const char* filename,int flags);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage_exr(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage_exr(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage_hdr(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage_hdr(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage_jpg(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage_jpg(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode3u_postProcess_saveImage_jpg(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,double quality);
KRAYCEXPORT(void) shaderNode3_postProcess_saveImage_jpg(KrayProtoHandle kph,Symbol& s1,const char* filename,double quality);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage_png(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage_png(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode3u_postProcess_saveImage_png(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) shaderNode3_postProcess_saveImage_png(KrayProtoHandle kph,Symbol& s1,const char* filename,int flags);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage_tga(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage_tga(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode3u_postProcess_saveImage_tga(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) shaderNode3_postProcess_saveImage_tga(KrayProtoHandle kph,Symbol& s1,const char* filename,int flags);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveImage_tif(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveImage_tif(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode3u_postProcess_saveImage_tif(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename,int flags);
KRAYCEXPORT(void) shaderNode3_postProcess_saveImage_tif(KrayProtoHandle kph,Symbol& s1,const char* filename,int flags);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveNormal(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveNormal(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode2u_postProcess_saveZ(KrayProtoHandle kph,Symbol& s1,const wchar_t* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_saveZ(KrayProtoHandle kph,Symbol& s1,const char* filename);
KRAYCEXPORT(void) shaderNode2_postProcess_setDirectionsMapFormat(KrayProtoHandle kph,Symbol& s1,bool compress);
KRAYCEXPORT(void) shaderNode3_postProcess_setDirectionsMapFormat(KrayProtoHandle kph,Symbol& s1,bool compress,bool d5);
KRAYCEXPORT(void) shaderNode2_postProcess_shader(KrayProtoHandle kph,Symbol& s1,const Symbol& s4);
KRAYCEXPORT(void) shaderNode3_postProcess_stereogram(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b4,int patternPositon);
KRAYCEXPORT(void) shaderNode4_postProcess_stereogram(KrayProtoHandle kph,Symbol& s1,const BitmapSymbol& b4,int patternPositon,int randomSeed);
KRAYCEXPORT(void) shaderNode2_postProcess_trimAlpha(KrayProtoHandle kph,Symbol& s1,int steps);
KRAYCEXPORT(void) shaderNode2_toneMap_desaturate(KrayProtoHandle kph,Symbol& s1,double d4);
KRAYCEXPORT(void) shaderNode2_toneMap_exponential(KrayProtoHandle kph,Symbol& s1,double parameter);
KRAYCEXPORT(void) shaderNode3_toneMap_exponential(KrayProtoHandle kph,Symbol& s1,double parameter,double exposure);
KRAYCEXPORT(void) shaderNode2_toneMap_gamma(KrayProtoHandle kph,Symbol& s1,double parameter);
KRAYCEXPORT(void) shaderNode3_toneMap_gamma(KrayProtoHandle kph,Symbol& s1,double parameter,double exposure);
KRAYCEXPORT(void) shaderNode3_toneMap_gammaAlpha(KrayProtoHandle kph,Symbol& s1,double RGB_gamma,double A_gamma);
KRAYCEXPORT(void) shaderNode2_toneMap_limitDr(KrayProtoHandle kph,Symbol& s1,double limit);
KRAYCEXPORT(void) shaderNode1_toneMap_linear(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shaderNode2_toneMap_reverse(KrayProtoHandle kph,Symbol& s1,const Symbol& s4);
KRAYCEXPORT(void) shaderNode2_toneMap_vExponential(KrayProtoHandle kph,Symbol& s1,double parameter);
KRAYCEXPORT(void) shaderNode3_toneMap_vExponential(KrayProtoHandle kph,Symbol& s1,double parameter,double exposure);
KRAYCEXPORT(void) shaderNode2_toneMap_vGamma(KrayProtoHandle kph,Symbol& s1,double parameter);
KRAYCEXPORT(void) shaderNode3_toneMap_vGamma(KrayProtoHandle kph,Symbol& s1,double parameter,double exposure);
KRAYCEXPORT(void) shaderNode3_toneMap_vGammaAlpha(KrayProtoHandle kph,Symbol& s1,double RGB_gamma,double A_gamma);
KRAYCEXPORT(void) shaderNode2_toneMap_vLimitDr(KrayProtoHandle kph,Symbol& s1,double limit);
KRAYCEXPORT(void) shaderNode3_toneMapFilter(KrayProtoHandle kph,Symbol& s1,const Symbol& node,const Symbol& filter);
KRAYCEXPORT(void) shaderNode3_twoSided(KrayProtoHandle kph,Symbol& s1,const Symbol& front,const Symbol& back);
KRAYCEXPORT(void) shaderNode3_visibilityFlags(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,int flags);
KRAYCEXPORT(void) shaderNode1_wire(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shadowMap3(KrayProtoHandle kph,Symbol& s1,const Vector& v2,const Vector& size);
KRAYCEXPORT(void) shape3_and2(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& s4);
KRAYCEXPORT(void) shape4_circle(KrayProtoHandle kph,Symbol& s1,const Vector& position,const Vector& direction,double radius);
KRAYCEXPORT(void) shape3_clipMap(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& t4);
KRAYCEXPORT(void) shape5_cone(KrayProtoHandle kph,Symbol& s1,const CoordSys& ori,double r1,double r2,double len);
KRAYCEXPORT(void) shape11_dIntTriangle(KrayProtoHandle kph,Symbol& s1,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Symbol& d9,const Vector& v10,const Vector& v11,const Vector& v12);
KRAYCEXPORT(void) shape11_dIntTriangleSs(KrayProtoHandle kph,Symbol& s1,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Symbol& d9,const Vector& v10,const Vector& v11,const Vector& v12);
KRAYCEXPORT(void) shape2u_distanceField(KrayProtoHandle kph,Symbol& s1,const wchar_t* expression);
KRAYCEXPORT(void) shape2_distanceField(KrayProtoHandle kph,Symbol& s1,const char* expression);
KRAYCEXPORT(void) shape3_dQuad(KrayProtoHandle kph,Symbol& s1,int flags,const Symbol& d4);
KRAYCEXPORT(void) shape8_dQuad(KrayProtoHandle kph,Symbol& s1,int flags,const Symbol& d4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9);
KRAYCEXPORT(void) shape9_dQuad(KrayProtoHandle kph,Symbol& s1,int flags,const Symbol& d4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9,const Vector& v10);
KRAYCEXPORT(void) shape11_dQuad(KrayProtoHandle kph,Symbol& s1,int flags,const Symbol& d4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9,const Vector& v10,const Vector& v11,const Vector& v12);
KRAYCEXPORT(void) shape11_dTriangle(KrayProtoHandle kph,Symbol& s1,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Symbol& d9,const Vector& v10,const Vector& v11,const Vector& v12);
KRAYCEXPORT(void) shape11_dTriangleSs(KrayProtoHandle kph,Symbol& s1,const Vector& v3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Symbol& d9,const Vector& v10,const Vector& v11,const Vector& v12);
KRAYCEXPORT(void) shape6_elipCone(KrayProtoHandle kph,Symbol& s1,const CoordSys& ori,double rx,double ry,double rz,double l);
KRAYCEXPORT(void) shape6_elipParaboloid(KrayProtoHandle kph,Symbol& s1,const CoordSys& ori,double rx,double ry,double rz,double l);
KRAYCEXPORT(void) shape6_elipTube(KrayProtoHandle kph,Symbol& s1,const CoordSys& ori,double rx,double ry,double rz,double l);
KRAYCEXPORT(void) shape2_ellipsoid(KrayProtoHandle kph,Symbol& s1,const CoordSys& ori);
KRAYCEXPORT(void) shape10_fibers(KrayProtoHandle kph,Symbol& s1,const Symbol& f3,const Vector& v4,const Vector& v5,const Vector& v6,const Vector& v7,const Vector& v8,const Vector& v9,const Vector& v10,const Vector& v11);
KRAYCEXPORT(void) shape8_intTriangle(KrayProtoHandle kph,Symbol& s1,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex,const Vector& normal0,const Vector& normal1,const Vector& normal2);
KRAYCEXPORT(void) shape8_intTriangleSs(KrayProtoHandle kph,Symbol& s1,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex,const Vector& normal0,const Vector& normal1,const Vector& normal2);
KRAYCEXPORT(void) shape2u_isoSurface(KrayProtoHandle kph,Symbol& s1,const wchar_t* expression);
KRAYCEXPORT(void) shape2_isoSurface(KrayProtoHandle kph,Symbol& s1,const char* expression);
KRAYCEXPORT(void) shape10_mandelBulb(KrayProtoHandle kph,Symbol& s1,const CoordSys& axes,int iterations,double escape_radius,double exponent,int max_ray_iterations,double error,double maxstep,double minstep,double steppower);
KRAYCEXPORT(void) shape1_or2(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shape5_paraboloid(KrayProtoHandle kph,Symbol& s1,const CoordSys& ori,double r1,double r2,double len);
KRAYCEXPORT(void) shape2_polygon(KrayProtoHandle kph,Symbol& s1,const VarLenVector& v3);
KRAYCEXPORT(void) shape6_qJulia(KrayProtoHandle kph,Symbol& s1,const CoordSys& axes,const Vector& axisw,int iterations,double escape_radius,const Vector& v7);
KRAYCEXPORT(void) shape4_rectangle(KrayProtoHandle kph,Symbol& s1,const Vector& cornerPosition,const Vector& deltaX,const Vector& deltaY);
KRAYCEXPORT(void) shape5_rectangle(KrayProtoHandle kph,Symbol& s1,const Vector& cornerPosition,const Vector& deltaX,const Vector& deltaY,size_t uvIndex);
KRAYCEXPORT(void) shape3_sphere(KrayProtoHandle kph,Symbol& s1,const Vector& v3,double d4);
KRAYCEXPORT(void) shape3_sub2(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& s4);
KRAYCEXPORT(void) shape1_testShape(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shape4_triangle(KrayProtoHandle kph,Symbol& s1,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2);
KRAYCEXPORT(void) shape4_triangleSs(KrayProtoHandle kph,Symbol& s1,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2);
KRAYCEXPORT(void) shape4_tube(KrayProtoHandle kph,Symbol& s1,const CoordSys& ori,double r,double len);
KRAYCEXPORT(void) shape4_uvTriangle(KrayProtoHandle kph,Symbol& s1,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2);
KRAYCEXPORT(void) shape5_uvTriangle(KrayProtoHandle kph,Symbol& s1,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex);
KRAYCEXPORT(void) shape5_uvTriangleSs(KrayProtoHandle kph,Symbol& s1,const Vector& vertex0,const Vector& vertex1,const Vector& vertex2,size_t uvIndex);
KRAYCEXPORT(void) shape3_wall(KrayProtoHandle kph,Symbol& s1,const Vector& v3,const Vector& v4);
KRAYCEXPORT(void) shapeAdd3(KrayProtoHandle kph,const Symbol& s1,const Symbol& s2,const Symbol& b3);
KRAYCEXPORT(void) shapeSelection1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shapeSelectionOp2_add(KrayProtoHandle kph,const Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) shOb2u_ies(KrayProtoHandle kph,Symbol& s1,const wchar_t* iesFileName);
KRAYCEXPORT(void) shOb2_ies(KrayProtoHandle kph,Symbol& s1,const char* iesFileName);
KRAYCEXPORT(void) shOb1_physky(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shOb2_physky(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection);
KRAYCEXPORT(void) shOb3_physky(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity);
KRAYCEXPORT(void) shOb4_physky(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure);
KRAYCEXPORT(void) shOb5_physky(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation);
KRAYCEXPORT(void) shOb6_physky(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation,double sunIntensityMultiplier);
KRAYCEXPORT(void) shOb7_physky(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation,double sunIntensityMultiplier,double sunSolidAngleMultiplier);
KRAYCEXPORT(void) shOb1_physky0(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shOb2_physky0(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection);
KRAYCEXPORT(void) shOb3_physky0(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,const Vector& sunColor);
KRAYCEXPORT(void) shOb4_physky0(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,const Vector& sunColor,const Axes& orientation);
KRAYCEXPORT(void) shOb5_physky0(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,const Vector& sunColor,const Axes& orientation,double sunIntensityMultiplier);
KRAYCEXPORT(void) shOb6_physky0(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,const Vector& sunColor,const Axes& orientation,double sunIntensityMultiplier,double sunSolidAngleMultiplier);
KRAYCEXPORT(void) shOb1_physky2(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) shOb2_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection);
KRAYCEXPORT(void) shOb3_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity);
KRAYCEXPORT(void) shOb4_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure);
KRAYCEXPORT(void) shOb5_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation);
KRAYCEXPORT(void) shOb6_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation,const Vector& groundAlbedo);
KRAYCEXPORT(void) shOb7_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation,const Vector& groundAlbedo,double sunIntensityMultiplier);
KRAYCEXPORT(void) shOb8_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation,const Vector& groundAlbedo,double sunIntensityMultiplier,double sunSolidAngleMultiplier);
KRAYCEXPORT(void) shOb10_physky2(KrayProtoHandle kph,Symbol& s1,const Vector& sunDirection,double turbidity,double exposure,const Axes& orientation,const Vector& groundAlbedo,double sunIntensityMultiplier,double sunSolidAngleMultiplier,double sunDawnDuskAboveAngle,double sunDawnDuskUnderAngle);
KRAYCEXPORT(void) shOb2_water(KrayProtoHandle kph,Symbol& s1,const Vector& size);
KRAYCEXPORT(void) shObOp2_flags(KrayProtoHandle kph,const Symbol& s1,int objectFlags);
KRAYCEXPORT(void) shObOp2_waterDisturb(KrayProtoHandle kph,const Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) shObOp3_waterDisturb(KrayProtoHandle kph,const Symbol& s1,const BitmapSymbol& b3,double multiplier);
KRAYCEXPORT(void) shObOp2_waterIterate(KrayProtoHandle kph,const Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) shObOp3_waterIterate(KrayProtoHandle kph,const Symbol& s1,const BitmapSymbol& b3,double iterateStepFraction);
KRAYCEXPORT(void) shObOp4_waterIterate(KrayProtoHandle kph,const Symbol& s1,const BitmapSymbol& b3,double iterateStepFraction,double attentuation);
KRAYCEXPORT(void) shObOp1_waterSetBounds(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) shObOp2_waterSetBounds(KrayProtoHandle kph,const Symbol& s1,const BitmapSymbol& b3);
KRAYCEXPORT(void) showInfo0(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_all(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_anim(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_bitmaps(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_bitmapsExt(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_fg(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_fiberPacks(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_pm(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_scene(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_shared(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_symbols(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_vertexMaps(KrayProtoHandle kph);
KRAYCEXPORT(void) showInfo0_views(KrayProtoHandle kph);
KRAYCEXPORT(void) stop0(KrayProtoHandle kph);
KRAYCEXPORT(void) string1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) string2u(KrayProtoHandle kph,Symbol& s1,const wchar_t* s2);
KRAYCEXPORT(void) string2(KrayProtoHandle kph,Symbol& s1,const char* s2);
KRAYCEXPORT(void) stringId1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface4_ambientOcclusion(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Vector& occlusionColor,double maxDistance);
KRAYCEXPORT(void) surface5_ambientOcclusion(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Vector& occlusionColor,double maxDistance,int minSamples);
KRAYCEXPORT(void) surface6_ambientOcclusion(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Vector& occlusionColor,double maxDistance,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface7_ambientOcclusion(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Vector& occlusionColor,double maxDistance,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface1_black(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface4_blur2(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double d4,bool accurateReflection);
KRAYCEXPORT(void) surface5_blur2(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double d4,bool accurateReflection,int minSamples);
KRAYCEXPORT(void) surface6_blur2(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double d4,bool accurateReflection,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface7_blur2(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double d4,bool accurateReflection,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface4_btHybrid(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Symbol& s4,const Symbol& s5);
KRAYCEXPORT(void) surface4_bump(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& t4,double d5);
KRAYCEXPORT(void) surface11_cell(KrayProtoHandle kph,Symbol& s1,const Vector& upc,double upt,const Vector& midc,double lowt,const Vector& lowc,const Vector& shadc,double shadt,const Vector& bordc,double bordt,double hight);
KRAYCEXPORT(void) surface1_color(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface2_cosColor(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface2_cShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface1_default(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface2_diffuse(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_diffuse(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int d4);
KRAYCEXPORT(void) surface4_dispGlass2(KrayProtoHandle kph,Symbol& s1,double d3,double d4,int d5);
KRAYCEXPORT(void) surface1_dist(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface1_dist2(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface3_dist3(KrayProtoHandle kph,Symbol& s1,double d3,double d4);
KRAYCEXPORT(void) surface2_dReflect(KrayProtoHandle kph,Symbol& s1,double exponent);
KRAYCEXPORT(void) surface2_dSide(KrayProtoHandle kph,Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) surface4_energetic(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Symbol& t4,double d5);
KRAYCEXPORT(void) surface3_envMap(KrayProtoHandle kph,Symbol& s1,const Axes& ori,const BitmapSymbol& b4);
KRAYCEXPORT(void) surface4_fHybrid(KrayProtoHandle kph,Symbol& s1,double ior,const VarLenSymbol& s4,const VarLenDouble& d5);
KRAYCEXPORT(void) surface3_filter(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& t4);
KRAYCEXPORT(void) surface4_filter(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& t4,bool alpha);
KRAYCEXPORT(void) surface5_filter(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& t4,bool alpha,bool pmMode);
KRAYCEXPORT(void) surface2_filterMetalic(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface5_fresnel(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,double dc,double amp,double pow);
KRAYCEXPORT(void) surface2_fromShader(KrayProtoHandle kph,Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) surface8_gisst(KrayProtoHandle kph,Symbol& s1,const Vector& s,const Vector& a,double n,int smp,int pht,double pmr,const Symbol& t9);
KRAYCEXPORT(void) surface2_glass2(KrayProtoHandle kph,Symbol& s1,double d3);
KRAYCEXPORT(void) surface3_glassTransparent2(KrayProtoHandle kph,Symbol& s1,double d3,const Vector& v4);
KRAYCEXPORT(void) surface5_glassTransparentText2(KrayProtoHandle kph,Symbol& s1,double n,double f,const Symbol& t5,double spd);
KRAYCEXPORT(void) surface2_gStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_gStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_gStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_gStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface3_hybrid(KrayProtoHandle kph,Symbol& s1,const VarLenSymbol& s3,const VarLenDouble& d4);
KRAYCEXPORT(void) surface5_hybridRgb(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Symbol& s4,const Symbol& s5,const Symbol& t6);
KRAYCEXPORT(void) surface8_ids(KrayProtoHandle kph,Symbol& s1,const Symbol& s3,const Vector& surface_id,const Vector& object_id,int buffers_flags,int edge_flags,int alpha_mode,double alpha_value);
KRAYCEXPORT(void) surface2_light(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_light(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,bool doubleSided);
KRAYCEXPORT(void) surface1_metalic(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface2_mltHybrid(KrayProtoHandle kph,Symbol& s1,int d3);
KRAYCEXPORT(void) surface2_noCC(KrayProtoHandle kph,Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) surface1_normal(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface3_nrgShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,double divisionSize);
KRAYCEXPORT(void) surface2_nrgTest(KrayProtoHandle kph,Symbol& s1,double size);
KRAYCEXPORT(void) surface3_nrgTest(KrayProtoHandle kph,Symbol& s1,double size,int flags);
KRAYCEXPORT(void) surface4_nrgTest(KrayProtoHandle kph,Symbol& s1,double size,int flags,double value);
KRAYCEXPORT(void) surface2_occlusionMap(KrayProtoHandle kph,Symbol& s1,double maxDistance);
KRAYCEXPORT(void) surface3_occlusionMap(KrayProtoHandle kph,Symbol& s1,double maxDistance,int minSamples);
KRAYCEXPORT(void) surface4_occlusionMap(KrayProtoHandle kph,Symbol& s1,double maxDistance,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_occlusionMap(KrayProtoHandle kph,Symbol& s1,double maxDistance,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmBaked(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface2_pmbcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmbcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_pmbcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_pmbcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmbShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmbShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_pmbShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_pmbShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmcmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmcmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_pmcmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_pmcmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_pmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_pmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmDirect(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface2_pmLight(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmLight(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_pmLight(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_pmLight(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_pmmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_pmmcShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmPrecached(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface2_pmShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_pmShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_pmShaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_pmUnfiltered(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_pmUnfiltered(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,double scale);
KRAYCEXPORT(void) surface2_qStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_qStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_qStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_qStat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_qStatD(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_qStatD(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_qStatD(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_qStatD(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_qStatDReflect(KrayProtoHandle kph,Symbol& s1,double exponent);
KRAYCEXPORT(void) surface3_qStatDReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples);
KRAYCEXPORT(void) surface4_qStatDReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_qStatDReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_qStatReflect(KrayProtoHandle kph,Symbol& s1,double exponent);
KRAYCEXPORT(void) surface3_qStatReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples);
KRAYCEXPORT(void) surface4_qStatReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_qStatReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_reflect(KrayProtoHandle kph,Symbol& s1,double d3);
KRAYCEXPORT(void) surface3_reflectMap(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const BitmapSymbol& b4);
KRAYCEXPORT(void) surface2_shaded(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_shadeMap(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const BitmapSymbol& b4);
KRAYCEXPORT(void) surface4_shSdEnergetic(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Symbol& t4,double d5);
KRAYCEXPORT(void) surface4_shSdSmoothEnergetic(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Symbol& t4,double d5);
KRAYCEXPORT(void) surface6_sss(KrayProtoHandle kph,Symbol& s1,const Vector& s,const Vector& a,double n,const Symbol& t6,const Symbol& s7);
KRAYCEXPORT(void) surface8_sst(KrayProtoHandle kph,Symbol& s1,const Vector& s,const Vector& a,double n,int smp,int pht,double pmr,const Symbol& t9);
KRAYCEXPORT(void) surface2_stat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_stat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_stat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_stat(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_statd(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface3_statd(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples);
KRAYCEXPORT(void) surface4_statd(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_statd(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_statReflect(KrayProtoHandle kph,Symbol& s1,double exponent);
KRAYCEXPORT(void) surface3_statReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples);
KRAYCEXPORT(void) surface4_statReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples,int maxSamples);
KRAYCEXPORT(void) surface5_statReflect(KrayProtoHandle kph,Symbol& s1,double exponent,int minSamples,int maxSamples,double stdDeviation);
KRAYCEXPORT(void) surface2_sTransparent(KrayProtoHandle kph,Symbol& s1,const Symbol& t3);
KRAYCEXPORT(void) surface2_transparent(KrayProtoHandle kph,Symbol& s1,const Vector& v3);
KRAYCEXPORT(void) surface1_uvColors(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface1_wireNormal(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surface1_zeroTransparent2(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_background(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_chain(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_colorFilter(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_dummy(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_environment(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_extractAlpha(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp2_fromMeshTag(KrayProtoHandle kph,const Symbol& s1,int flag);
KRAYCEXPORT(void) surfaceOp1_fromMeshTagName(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_giDesaturate(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_lowLevel(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_mix(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_postProcess(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_toneMap(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_toneMapFilter(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp2_twoSided(KrayProtoHandle kph,const Symbol& s1,int flag);
KRAYCEXPORT(void) surfaceOp1_visibilityFlags(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) surfaceOp1_wire(KrayProtoHandle kph,const Symbol& s1);
KRAYCEXPORT(void) symbolsDelete0(KrayProtoHandle kph);
KRAYCEXPORT(void) tds1u_sceneLoad(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) tds1_sceneLoad(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) texture3_bitmap(KrayProtoHandle kph,Symbol& s1,const Symbol& m3,const BitmapSymbol& b4);
KRAYCEXPORT(void) texture2_color(KrayProtoHandle kph,Symbol& s1,const Vector& color);
KRAYCEXPORT(void) texture2_fromShader(KrayProtoHandle kph,Symbol& s1,const Symbol& s3);
KRAYCEXPORT(void) texture3_lodBitmap(KrayProtoHandle kph,Symbol& s1,const Symbol& m3,const BitmapSymbol& b4);
KRAYCEXPORT(void) texture3_toneMap(KrayProtoHandle kph,Symbol& s1,const Symbol& t3,const Symbol& s4);
KRAYCEXPORT(void) texture5_wire(KrayProtoHandle kph,Symbol& s1,double wireThickness,const Vector& wire,double alpha,const Vector& inside);
KRAYCEXPORT(void) threads1(KrayProtoHandle kph,int threadsCount);
KRAYCEXPORT(void) var1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) var2(KrayProtoHandle kph,Symbol& s1,double d2);
KRAYCEXPORT(void) variable1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) variable2(KrayProtoHandle kph,Symbol& s1,double d2);
KRAYCEXPORT(void) vector1(KrayProtoHandle kph,Symbol& s1);
KRAYCEXPORT(void) vector2(KrayProtoHandle kph,Symbol& s1,const Vector& v2);
KRAYCEXPORT(void) vertex2d3(KrayProtoHandle kph,const VertexMapSymbol& v1,size_t index,const Vector& data);
KRAYCEXPORT(void) vertex3d3(KrayProtoHandle kph,const VertexMapSymbol& v1,size_t index,const VarLenVector& data);
KRAYCEXPORT(void) vertexData3(KrayProtoHandle kph,const VertexMapSymbol& v1,size_t index,const VarLenDouble& data);
KRAYCEXPORT(void) vertexMap2(KrayProtoHandle kph,Symbol& s1,int dim);
KRAYCEXPORT(void) vertexMap3_fixedSize(KrayProtoHandle kph,Symbol& s1,int dim,size_t stop);
KRAYCEXPORT(void) vertexMap4_fixedSize(KrayProtoHandle kph,Symbol& s1,int dim,size_t stop,int animSamples);
KRAYCEXPORT(void) vertexMap4_grabMesh_discretizePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density);
KRAYCEXPORT(void) vertexMap5_grabMesh_discretizePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density,double time);
KRAYCEXPORT(void) vertexMap4_grabMesh_gridSamplePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density);
KRAYCEXPORT(void) vertexMap5_grabMesh_gridSamplePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density,double time);
KRAYCEXPORT(void) vertexMap6_grabMesh_gridSamplePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density,double time,const Axes& plane);
KRAYCEXPORT(void) vertexMap4_grabMesh_samplePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density);
KRAYCEXPORT(void) vertexMap5_grabMesh_samplePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density,double time);
KRAYCEXPORT(void) vertexMap6_grabMesh_samplePoints(KrayProtoHandle kph,Symbol& s1,int dim,const MeshSymbol& m4,double density,double time,int accuracy);
KRAYCEXPORT(void) vertexMapOp1_flush(KrayProtoHandle kph,const VertexMapSymbol& v1);
KRAYCEXPORT(void) vertexMapOp2_resize(KrayProtoHandle kph,const VertexMapSymbol& v1,size_t size);
KRAYCEXPORT(void) vertexMapOp2u_saveScript(KrayProtoHandle kph,const VertexMapSymbol& v1,const wchar_t* filename);
KRAYCEXPORT(void) vertexMapOp2_saveScript(KrayProtoHandle kph,const VertexMapSymbol& v1,const char* filename);
KRAYCEXPORT(void) vertexMapOp3u_saveScript(KrayProtoHandle kph,const VertexMapSymbol& v1,const wchar_t* filename,const wchar_t* vertexMapVariableName);
KRAYCEXPORT(void) vertexMapOp3_saveScript(KrayProtoHandle kph,const VertexMapSymbol& v1,const char* filename,const char* vertexMapVariableName);
KRAYCEXPORT(void) vertexMapOp1_show(KrayProtoHandle kph,const VertexMapSymbol& v1);
KRAYCEXPORT(void) vertexMapOp2_show(KrayProtoHandle kph,const VertexMapSymbol& v1,double time);
KRAYCEXPORT(void) vertexMapOp3_show(KrayProtoHandle kph,const VertexMapSymbol& v1,double time,int position);
KRAYCEXPORT(void) vertexMapOp4_show(KrayProtoHandle kph,const VertexMapSymbol& v1,double time,int position,int normals);
KRAYCEXPORT(void) vertexMapOp5_show(KrayProtoHandle kph,const VertexMapSymbol& v1,double time,int position,int normals,int color);
KRAYCEXPORT(void) vertexMapOp6_show(KrayProtoHandle kph,const VertexMapSymbol& v1,double time,int position,int normals,int color,int weight);
KRAYCEXPORT(void) vertexMapOp7_show(KrayProtoHandle kph,const VertexMapSymbol& v1,double time,int position,int normals,int color,int weight,const Vector& defaultColor);
KRAYCEXPORT(void) view1_camAspect(KrayProtoHandle kph,double aspect);
KRAYCEXPORT(void) view0_camFilter(KrayProtoHandle kph);
KRAYCEXPORT(void) view1_camFilter(KrayProtoHandle kph,const Symbol& m2);
KRAYCEXPORT(void) view1_camSingleSide(KrayProtoHandle kph,bool d2);
KRAYCEXPORT(void) view0_close(KrayProtoHandle kph);
KRAYCEXPORT(void) view1_flags(KrayProtoHandle kph,int flags);
KRAYCEXPORT(void) view0_freeRenderedImage(KrayProtoHandle kph);
KRAYCEXPORT(void) view0_offset(KrayProtoHandle kph);
KRAYCEXPORT(void) view1_offset(KrayProtoHandle kph,const Vector& offset);
KRAYCEXPORT(void) view1_postProcess_add(KrayProtoHandle kph,const Vector& v3);
KRAYCEXPORT(void) view1_postProcess_autoExp(KrayProtoHandle kph,double blend);
KRAYCEXPORT(void) view3_postProcess_bitmapOverlay(KrayProtoHandle kph,int x,int y,const BitmapSymbol& b5);
KRAYCEXPORT(void) view4_postProcess_ca(KrayProtoHandle kph,double strength,double pixel_aspect,double aberationGamma,int samples);
KRAYCEXPORT(void) view1_postProcess_desaturate(KrayProtoHandle kph,double value);
KRAYCEXPORT(void) view4_postProcess_dof(KrayProtoHandle kph,double distance,double depth,int maxsize,const BitmapSymbol& irisImage);
KRAYCEXPORT(void) view1_postProcess_erode(KrayProtoHandle kph,int strength);
KRAYCEXPORT(void) view2_postProcess_erodeAlpha(KrayProtoHandle kph,double level,int steps);
KRAYCEXPORT(void) view1_postProcess_filter(KrayProtoHandle kph,const VarLenDouble& mask);
KRAYCEXPORT(void) view1_postProcess_gamma(KrayProtoHandle kph,double value);
KRAYCEXPORT(void) view1_postProcess_gBlur(KrayProtoHandle kph,double size);
KRAYCEXPORT(void) view2_postProcess_gBlur(KrayProtoHandle kph,double size,double blend);
KRAYCEXPORT(void) view3_postProcess_gBlur(KrayProtoHandle kph,double size,double blend,double cutOff);
KRAYCEXPORT(void) view3_postProcess_glow(KrayProtoHandle kph,double strength,double size,const BitmapSymbol& b5);
KRAYCEXPORT(void) view2_postProcess_histogramFix(KrayProtoHandle kph,double low,double high);
KRAYCEXPORT(void) view1_postProcess_mult(KrayProtoHandle kph,const Vector& filter);
KRAYCEXPORT(void) view1u_postProcess_saveImage(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1u_postProcess_saveImage_bmp(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage_bmp(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_postProcess_saveImage_bmp(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_postProcess_saveImage_bmp(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view1u_postProcess_saveImage_exr(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage_exr(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1u_postProcess_saveImage_hdr(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage_hdr(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1u_postProcess_saveImage_jpg(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage_jpg(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_postProcess_saveImage_jpg(KrayProtoHandle kph,const wchar_t* filename,double quality);
KRAYCEXPORT(void) view2_postProcess_saveImage_jpg(KrayProtoHandle kph,const char* filename,double quality);
KRAYCEXPORT(void) view1u_postProcess_saveImage_png(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage_png(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_postProcess_saveImage_png(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_postProcess_saveImage_png(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view1u_postProcess_saveImage_tga(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage_tga(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_postProcess_saveImage_tga(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_postProcess_saveImage_tga(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view1u_postProcess_saveImage_tif(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveImage_tif(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_postProcess_saveImage_tif(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_postProcess_saveImage_tif(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view1u_postProcess_saveNormal(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveNormal(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1u_postProcess_saveZ(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_postProcess_saveZ(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1_postProcess_setDirectionsMapFormat(KrayProtoHandle kph,bool compress);
KRAYCEXPORT(void) view2_postProcess_setDirectionsMapFormat(KrayProtoHandle kph,bool compress,bool d4);
KRAYCEXPORT(void) view1_postProcess_shader(KrayProtoHandle kph,const Symbol& s3);
KRAYCEXPORT(void) view2_postProcess_stereogram(KrayProtoHandle kph,const BitmapSymbol& b3,int patternPositon);
KRAYCEXPORT(void) view3_postProcess_stereogram(KrayProtoHandle kph,const BitmapSymbol& b3,int patternPositon,int randomSeed);
KRAYCEXPORT(void) view1_postProcess_trimAlpha(KrayProtoHandle kph,int steps);
KRAYCEXPORT(void) view1_rayDiff(KrayProtoHandle kph,bool rdf);
KRAYCEXPORT(void) view0_remove(KrayProtoHandle kph);
KRAYCEXPORT(void) view1u_remove(KrayProtoHandle kph,const wchar_t* name);
KRAYCEXPORT(void) view1_remove(KrayProtoHandle kph,const char* name);
KRAYCEXPORT(void) view0_removeAll(KrayProtoHandle kph);
KRAYCEXPORT(void) view0_render(KrayProtoHandle kph);
KRAYCEXPORT(void) view1u_save(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1u_save_bmp(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save_bmp(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_save_bmp(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_save_bmp(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view1u_save_exr(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save_exr(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1u_save_hdr(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save_hdr(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view1u_save_jpg(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save_jpg(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_save_jpg(KrayProtoHandle kph,const wchar_t* filename,double quality);
KRAYCEXPORT(void) view2_save_jpg(KrayProtoHandle kph,const char* filename,double quality);
KRAYCEXPORT(void) view1u_save_png(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save_png(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_save_png(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_save_png(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view1u_save_tga(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save_tga(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_save_tga(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_save_tga(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view1u_save_tif(KrayProtoHandle kph,const wchar_t* filename);
KRAYCEXPORT(void) view1_save_tif(KrayProtoHandle kph,const char* filename);
KRAYCEXPORT(void) view2u_save_tif(KrayProtoHandle kph,const wchar_t* filename,int flags);
KRAYCEXPORT(void) view2_save_tif(KrayProtoHandle kph,const char* filename,int flags);
KRAYCEXPORT(void) view0_select(KrayProtoHandle kph);
KRAYCEXPORT(void) view1u_select(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) view1_select(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) view0_selectActive(KrayProtoHandle kph);
KRAYCEXPORT(void) view1u_selectActive(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) view1_selectActive(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) view0_setActive(KrayProtoHandle kph);
KRAYCEXPORT(void) view1u_setActive(KrayProtoHandle kph,const wchar_t* s2);
KRAYCEXPORT(void) view1_setActive(KrayProtoHandle kph,const char* s2);
KRAYCEXPORT(void) view1_size(KrayProtoHandle kph,const Vector& size);
KRAYCEXPORT(void) view0_toneMapping(KrayProtoHandle kph);
KRAYCEXPORT(void) view1_toneMapping(KrayProtoHandle kph,const Symbol& s2);
KRAYCEXPORT(void) view0_window(KrayProtoHandle kph);
KRAYCEXPORT(void) view2_window(KrayProtoHandle kph,const Vector& leftUp,const Vector& rightBottom);

#endif
